/*
Tree Game
© 2017 Corey Van Hoosen 
*/

treeGame.levelPlanet = function (game) {

	console.log("Setting global variables...");

	//	When a State is added to Phaser it automatically has the following properties set on it, even if they already exist:

    this.game = game;		//	a reference to the currently running game
    this.add;		        //	used to add sprites, text, groups, etc
    this.camera;	        //	a reference to the game camera
    this.cache;		        //	the game cache
    this.input;		        //	the global input manager (you can access this.input.keyboard, this.input.mouse, as well from it)
    this.load;		        //	for preloading assets
    this.math;		        //	lots of useful common math operations
    this.sound;		        //	the sound manager - add a sound, play one, set-up markers, etc
    this.stage;		        //	the game stage
    this.time;		        //	the clock
    this.tweens;	        //	the tween manager
    this.world;		        //	the game world
    this.particles;	        //	the particle manager
    this.physics;	        //	the physics manager
    this.rnd;		        //	the repeatable random number generator

	levelPlanetState = this;

	//  Load Mobs and Objects
	console.log("Loading objects...");


	treeGame.objective = function (level) 
	{			

		this.width = window.innerWidth;
		this.height = 100;
		this.x = 0;
		this.y = (window.innerHeight - this.height);
		this.radius = 1;
		
	    this.objectiveBox = game.add.graphics(this.x, this.y);
	    this.objectiveBox.lineStyle(0);
	    this.objectiveBox.beginFill(0x634241, 1);
	    this.objectiveBox.drawRoundedRect(0, 0, this.width, this.height, this.radius);
        this.objectiveBox.endFill();
        this.objectiveBox.blendMode = Phaser.blendModes.OVERLAY;
        this.objectiveBox.fixedToCamera = true;
        this.textX = window.innerWidth - 300;
        this.textY = this.objectiveBox.y + 10;
        
        switch (game.selectedLevel)
		{
			case 1:
				this.randomObjective = game.rnd.integerInRange(0, 6);
				switch (this.randomObjective) {
					case 0:
					    treeGame.currentObjective = "treesCreated";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Trees Created: " + treeGame.numberOfTreesCreated, this.fontStyle);
					    break;
					case 1:
					    treeGame.currentObjective = "treesCreatedOak";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Oak Trees Created: " + treeGame.numberOfTreesOakCreated, this.fontStyle);
					    break;
					case 2:
					    treeGame.currentObjective = "treesCreatedBeech";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Beech Trees Created: " + treeGame.numberOfTreesBeechCreated, this.fontStyle);
					    break;
					case 3:
					    treeGame.currentObjective = "treesCreatedBirch";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Birch Trees Created: " + treeGame.numberOfTreesBirchCreated, this.fontStyle);
					    break;
					case 4:
					    treeGame.currentObjective = "treesCreatedPine";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Pine Trees Created: " + treeGame.numberOfTreesPineCreated, this.fontStyle);
					    break;
					case 5:
					    treeGame.currentObjective = "treesCreatedWillow";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Willow Trees Created: " + treeGame.numberOfTreesWillowCreated, this.fontStyle);
					    break;
					case 6:
					    treeGame.currentObjective = "mushroomsAbsorbed";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Mushrooms Absorbed: " + treeGame.numberOfMushroomsAbsorbed, this.fontStyle);
					    break;
				}
			    break;
			    
			case 2:
			    this.randomObjective = game.rnd.integerInRange(0, 2);
				switch (this.randomObjective) {
					case 0:
					    treeGame.currentObjective = "crowsAlive";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Crows Alive: " + treeGame.numberOfCrowsAlive, this.fontStyle);
					    break;
					case 1:
					    treeGame.currentObjective = "squirrelsAlive";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Squirrels Alive: " + treeGame.numberOfSquirrelsAlive, this.fontStyle);
					    break;
					case 2:
					    treeGame.currentObjective = "deerAlive";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Deer Alive: " + treeGame.numberOfDeerAlive, this.fontStyle);
					    break;
				}
				break;
						
			case 3:
			    this.randomObjective = game.rnd.integerInRange(0, 1);
				switch (this.randomObjective) {
					case 0:
					    treeGame.currentObjective = "woodcuttersAbsorbed";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Woodcutters Absorbed: " + treeGame.numberOfWoodcuttersAbsorbed, this.fontStyle);
					    break;
					case 1:
					    treeGame.currentObjective = "ceremoniesAttended";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Ceremonies Attended: " + treeGame.numberOfCeremoniesAttended, this.fontStyle);
					    break;		
			    }
			default:
			    this.randomObjective = game.rnd.integerInRange(0, 0);
				switch (this.randomObjective) {
					case 0:
					    treeGame.currentObjective = "none";
					    this.objectiveText = game.add.text(this.textX, this.textY, "Woodcutters Absorbed: " + treeGame.numberOfWoodcuttersAbsorbed, this.fontStyle);
					    break;
			    }
			}
			

	    this.objectiveText.lineSpacing = -10;
// 		this.objectiveText.anchor.setTo(0.5, 0.5);
		this.objectiveText.align = 'left';
	    this.objectiveText.fill = '#EBDDA1';
	    this.objectiveText.addFontStyle('italic', 6);
	    this.objectiveText.font = 'Palatino';
	    this.objectiveText.fontSize = 23;
	    this.objectiveText.fixedToCamera = true;

        
        // Add the sky to the sky group
        uiGroup.add(this.objectiveBox);
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
/*
        this.width = 450;
		this.height = 100;
		this.x = 60;
		this.y = (window.innerHeight - this.height - 50);
		this.radius = 9;

		this.messageBox = game.add.graphics(this.x, this.y);
	    this.messageBox.lineStyle(0);
	    this.messageBox.beginFill(0xEBDDA1, 0.75);
	    this.messageBox.drawRoundedRect(0, 0, this.width, this.height, this.radius);
        this.messageBox.endFill();
		this.messageBox.fixedToCamera = true;
		this.messageBox.alpha = .75;
		this.messageBox.anchor.setTo(0.5, 0.5);
*/
	    
	    var x = this.objectiveBox.x + 10;
	    var y = this.objectiveBox.y + 10;

	    
	    this.tutorialMessageProgress = 1;
	    
	    switch (game.selectedLevel)
		{
			case 1:
			    var message = "Welcome, Woodland Spirit. \nPress a destination to walk to it.";
			    break;
			case 2:
			    var message = "Attracted to the shelter of your trees, \nand the nutrition from the seeds, \ndeer and crows have arrived.";
			    break;
			 case 3:
			    var message = "Attracted to the lumber of your trees, \nhumans have arrived.";
			    break;
		}
		
		this.tutorialText = game.add.text(x, y, message, this.fontStyle);
	    
// 	    this.messageBox.addChild(this.tutorialText);

	    this.tutorialText.lineSpacing = -10;
		this.tutorialText.anchor.setTo(0.0, 0.0);
		this.tutorialText.align = 'left';
	    this.tutorialText.fill = '#EBDDA1';
	    this.tutorialText.addFontStyle('italic', 6);
	    this.tutorialText.font = 'Palatino';
	    this.tutorialText.fontSize = 23;
	    this.tutorialText.fixedToCamera = true;
	    
		// Next button
		this.nextButton = game.add.button(this.objectiveBox.width/2.5, this.textY, null);
		this.nextButton.loadTexture('textureAtlas', 'buttonNext');
		this.nextButton.fixedToCamera = true;
		this.nextButton.anchor.setTo(0.5, 0.0);
        
		this.nextButton.events.onInputOver.add(function() {
	        this.nextButton.loadTexture('textureAtlas', 'buttonNextHover');
		}, this);
		
		this.nextButton.events.onInputOut.add(function() {
	        this.nextButton.loadTexture('textureAtlas', 'buttonNext');
		}, this);
		
		
		
		
		this.nextButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		});

	
		this.nextButton.events.onInputUp.add(function() {
			if (this.tutorialMessageProgress == 1)
			{
				this.tutorialMessageProgress += 1;
				switch (game.selectedLevel)
				{
					case 1:
					     this.tutorialText.setText("Activate your Spawn Tree power and press \nwhere you would like to place a tree. \nEach spawn depletes your energy.");
					     break;
					case 2:
					     this.tutorialText.setText("Attracted to the shelter of your trees, \n and the nutrition from the seeds, \ndeer and crows have arrived.");
					     break;
					 case 3:
					     this.tutorialText.setText("Some humans carry with them hatchets to \nharm your trees,");
					     break;
				}
				
			} else if (this.tutorialMessageProgress == 2)
			{
				this.tutorialMessageProgress += 1;
				
				switch (game.selectedLevel)
				{
					case 1:
					     this.tutorialText.setText("Switch to the Absorb Life power, and \npress on living beings to gain their energy.");
					     break;
					case 2:
					     this.tutorialText.setText("Attracted to the shelter of your trees, \n and the nutrition from the seeds, \ndeer and crows have arrived.");
					     break;
					 case 3:
					     this.tutorialText.setText("Other humans come to build shrines \nand to worship you.");
					     break;
				}
				
				
				this.nextButton.alpha = 0;
				
				// Close Message Box Button. Those shows up on the final slide.
				this.closeButton = game.add.button(this.nextButton.x, this.textY, null);
				this.closeButton.loadTexture('textureAtlas', 'buttonClose');
				this.closeButton.fixedToCamera = true;
				this.closeButton.anchor.setTo(0.5, 0.0);
				
				this.closeButton.events.onInputOver.add(function() {
			        this.closeButton.loadTexture('textureAtlas', 'buttonCloseHover');
				}, this);
				
				this.closeButton.events.onInputDown.add(function() {
			        treeGame.uiActive = true;
				}, this);
				
				this.closeButton.events.onInputOut.add(function() {
			        this.closeButton.loadTexture('textureAtlas', 'buttonClose');
				}, this);
				
				this.closeButton.events.onInputUp.add(function() {
					this.closeButton.alpha = 0;
					this.nextButton.alpha = 0;
					this.tutorialText.alpha = 0;

// 					this.objectiveBox.anchor.setTo(1, 0.0);
					this.objectiveBoxShrink = game.add.tween(this.objectiveBox.scale).to({y: 0.5}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
					var newXPosition = window.innerWidth - this.objectiveBox.width;
					this.objectiveBoxMove = game.add.tween(this.objectiveBox.cameraOffset).to({x: game.width - 400}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);

					console.log("Box radius before: ", this.objectiveBox.graphicsData[0].shape.radius);
					this.objectiveBoxMove.onComplete.add(function () 
			        {
				        this.objectiveBoxRadiusTween = game.add.tween(this.objectiveBox.graphicsData[0].shape).to({radius: 13}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
				        					console.log("Box radius after: ", this.objectiveBox.graphicsData[0].shape.radius);

				    }, this);
					
				}, this);	
				
			} 
						
			
		treeGame.uiActive = false;	
			
		}, this);	
        
            	
	}

	treeGame.tree = function (specieOfTree, spawnedFromSeed, seedX, seedY) 
	{	
		
		this.specieOfTree = specieOfTree;
		this.spawnedFromSeed = spawnedFromSeed;
		this.seedX = seedX;
		this.seedY = seedY;
		
		this.randomHeightVariation = game.rnd.integerInRange(-400, 400);
		this.randomTrunkSizeVariation = game.rnd.integerInRange(-10, 10);
		
		// Create a bitmap for the tree structure
	    this.treeBitmap = levelPlanetState.game.add.bitmapData(500, 450 + this.randomHeightVariation);
	    // Create a bitmap for the root structure
	    this.treeRootBitmap = levelPlanetState.game.add.bitmapData(500, 200 + this.randomHeightVariation);
	
	    // Create a sprite to hold the tree structure
	    if (spawnedFromSeed == false)
	    {
		    this.treeSprite = levelPlanetState.game.add.sprite(levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, treeGame.grounds[0].groundSprite.y - treeGame.grounds[0].groundSprite.height - this.treeRootBitmap.height, this.treeBitmap);
		    treeGame.numberOfTreesCreated += 1;
		    this.objectiveText = game.add.text(this.textX, this.textY, "Trees Created: " + treeGame.numberOfTreesCreated, this.fontStyle);
// 		    this.objectiveText.setText("Activate your Spawn Tree power and press \nwhere you would like to place a tree. \nEach spawn depletes your energy.");
// 			levelPlanetState.updateObjectiveText();

	    } else 
	    {
		    this.treeSprite = levelPlanetState.game.add.sprite(this.seedX, this.seedY - this.treeBitmap.y, this.treeBitmap);
	    }
	    
	    game.physics.p2.enable(this.treeSprite, false);
	    this.treeSprite.body.setRectangle(this.treeSprite.width * .1 , this.treeSprite.height - 20);
	    this.treeSprite.body.mass = 1000;
	    this.treeSprite.body.dead = false;
	    treeGroup.add(this.treeSprite);
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.treeSprite.body.setCollisionGroup(treeCollision);
	    this.treeSprite.body.collides([groundCollision], levelPlanetState.treeHitGround, this);
	    this.treeSprite.body.collides([forestGuardianCollision, humanCollision, fireCollision]);

	    
	    // Create a sprite to hold the root structure
	    this.treeRootSprite = levelPlanetState.game.add.sprite(0 - (this.treeSprite.width/2),this.treeSprite.height/2, this.treeRootBitmap);
	    game.physics.enable(this.treeRootSprite, Phaser.Physics.ARCADE);
	    treeRootCollision.add(this.treeRootSprite);
	    this.treeRootSprite.alpha = .5;
	    this.treeSprite.addChild(this.treeRootSprite);

		this.belongsToTree = treeGame.trees.length;
		this.treeSprite.body.roots = this.treeRootSprite;
		this.treeSprite.body.index = treeGame.trees.length;

	    this.treeSprite.body.y += this.treeRootSprite.height;
	    this.treeSprite.body.width = this.treeSprite.width;
	    this.treeSprite.body.height = this.treeSprite.height;
	    
	    treeGame.treeSpriteY = this.treeSprite.y;
	    	
	    // Set the anchor point of the sprite to center of the top edge
	    // This allows us to position the tree by simply specifiying the
	    // x and y coordinate of where we want the tree to appear from.
// 	    this.treeSprite.anchor.setTo(0.5, 1);
	    
	    // Create the tree crown
	    var segments = 20;
	    
	    if (specieOfTree == 'beech')
	    {
		    var segmentWidth = 40;
	    } else 
	    {
		    var segmentWidth = 25;
	    }
	    
	    levelPlanetState.createTreeCrown(this.treeBitmap.width/2, this.treeBitmap.height, segments, segmentWidth + this.randomTrunkSizeVariation, 0, this.treeBitmap, this.treeSprite, specieOfTree);
	    
// 	    this.treeSprite.treeWiggleTween = game.add.tween(this.treeSprite.body).to({angle: '+1'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
	    this.treeRootWiggleTween = game.add.tween(this.treeRootSprite).to({angle: '-1'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
	    this.treeRootMoveTween = game.add.tween(this.treeRootSprite).to({x: '+5', y: '+4'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
	    
	    // Create the tree roots
	    levelPlanetState.createTreeRoots(this.treeRootBitmap.width/2, 0, 20, 15, 0, this.treeRootBitmap, this.treeRootSprite.y);
	    
	    // Add click event
	    this.treeSprite.body.removed = false;
	    this.treeSprite.inputEnabled = true;
	    this.treeSprite.events.onInputDown.add(levelPlanetState.clickedTree, this);
	    
	    // Add a spawnzone around the tree for mushrooms and shade-loving plants
	    treeGame.spawnZoneTreeShades.push(this.fungusSpawnZone = new treeGame.spawnZoneTreeShade(treeGame.spawnZoneTreeShades.length, 0 - (this.treeSprite),0));
	    
	    if (this.spawnedFromSeed == true)
	    {
		    this.treeSprite.scale.x = 0;
		    this.treeSprite.scale.y = 0;
		    this.treeSprite.spawnedFromSeed = this.spawnedFromSeed;
	    }
	    
	    switch (specieOfTree)
	    {
		    case 'oak':
		        treeGame.numberOfTreesOakCreated += 1;
		    case 'beech':
		        treeGame.numberOfTreesBeechCreated += 1;
		    case 'birch':
		        treeGame.numberOfTreesBirchCreated += 1;
		    case 'pine':
		        treeGame.numberOfTreesPineCreated += 1;
		    case 'willow':
		        treeGame.numberOfTreesWillowCreated += 1;
	    }
	    
	    this.treeSprite.clicked = false;
	    
	    levelPlanetState.updateObjectiveText();

	    
	    
	    
	}

	treeGame.leaf = function (index, x, y, angle, alpha, specieOfTree) 
	{	
				
		if (specieOfTree == 'oak')
		{
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'leafOak');
			
		} else if (specieOfTree == 'beech')
		{
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'leafBeech');
		} else if (specieOfTree == 'birch')
		{
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'leafBirch');
		} else if (specieOfTree == 'pine')
		{
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'pineNeedles');	
		} else if (specieOfTree == 'willow')
		{
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'leafWillow');
		} else {
			this.leafSprite = game.add.sprite(x,y, 'textureAtlas', 'leafBeech');
		}
/*
		game.physics.enable(this.leafSprite, Phaser.Physics.ARCADE);
		this.leafSprite.body.enable = true;
		this.leafSprite.body.collideWorldBounds = false;
        this.leafSprite.body.drag.x = 500;
        this.leafSprite.body.drag.y = 500;
*/
        
        this.leafSprite.angle = angle;
        this.leafSprite.alpha = 0;
        
        // Willow "leaves"
        if (specieOfTree == 'willow')
        {
		    this.leafSprite.anchor.setTo(0, 0.5); 
		    this.leafSprite.angle = 90;
		    leafSpriteRandomScale = game.rnd.integerInRange(30, 100);
		    this.leafSprite.scale.x = leafSpriteRandomScale/100;
		    var leafJiggleTween = game.add.tween(this.leafSprite).to({angle:'+3'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true); 
        } else {
		    this.leafSprite.anchor.setTo(0.5, 0.5);
		    var leafJiggleTween = game.add.tween(this.leafSprite).to({angle:'+20'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true); 
        }

        
        var tweenFadeIn = game.add.tween(this.leafSprite).to({alpha:alpha}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this.leafSprite.scale).to({x: 1.1, y: 1.1}, 100, Phaser.Easing.Bounce.InOut, true, 10, 1, true);
        
		leafGroup.add(this.leafSprite);
		
		
		this.belongsToTree = treeGame.trees.length;	
		
		
		// Leaves fall off of trees
		
		this.leafRandomLifespan = game.rnd.integerInRange(0, 3000);
		game.time.events.add(Phaser.Timer.SECOND * this.leafRandomLifespan, function()
		{
	        if (this.leafSprite.parent.alive == true)
	        {
		      
		      
			     // Save information about the leaf
		        var leafX = this.leafSprite.worldPosition.x + levelPlanetState.game.camera.x;
		        var leafY = this.leafSprite.worldPosition.y + levelPlanetState.game.camera.y;
		        var leafAngle = this.leafSprite.angle;
		        var leafKey = this.leafSprite.key;
		        var leafFrameName = this.leafSprite.frameName;
		        var leafAlpha = this.leafSprite.alpha;
		        var leafBelongsToTree = this.belongsToTree;
		        
		        // Destroy the leaf and make a new one to replace it
		        treeGame.trees[treeGame.trees.length - 1].treeSprite.removeChild(this.leafSprite);
		        this.physicsLeafSprite = game.add.sprite(leafX,leafY, leafKey, leafFrameName);
		        this.physicsLeafSprite.x = leafX;
		        this.physicsLeafSprite.y = leafY;
		        this.physicsLeafSprite.angle = leafAngle;
		        this.physicsLeafSprite.alpha = leafAlpha;
		        
		    	// Enable physics for the leaf
		        game.physics.p2.enable(this.physicsLeafSprite, false);
		        this.physicsLeafSprite.body.setRectangle(this.leafSprite.width - 20, this.leafSprite.height - 20);
		        this.physicsLeafSprite.body.angle = leafAngle;
		        this.physicsLeafSprite.body.collideWorldBounds = true;
		        this.physicsLeafSprite.body.mass = 5;
		        
		        // Define the leaf's collision group and make it collide with the ground
			    this.physicsLeafSprite.body.setCollisionGroup(leafCollision);
			    this.physicsLeafSprite.body.collides([leafCollision, seedCollision, deerCollision, crowCollision, squirrelCollision, altarCollision, skullCollision]);
			    this.physicsLeafSprite.body.collides(groundCollision, levelPlanetState.leafHitGround, this);
			    		    
			    this.physicsLeafSprite.body.removed = false;
			    this.physicsLeafSprite.body.specieOfTree = specieOfTree;
		    


		      
		        
	        }
	        
	        		    
        }, this);
		
	}

	treeGame.seed = function (x,y, specieOfTree) 
	{	
		
		if (specieOfTree == 'oak')
		{
			this.seedSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'seedOak');	
		} else if (specieOfTree == 'beech')
		{
			this.seedSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'seedBeech');
		} else if (specieOfTree == 'birch')
		{
			this.seedSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'seedBirch');
		} else if (specieOfTree == 'pine')
		{
			this.seedSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'seedPine');
		} else {
			this.seedSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'seedBirch');
		}
		
		game.time.events.add(Phaser.Timer.SECOND * 4, function(){
			
			 // Enable physics for the seed
	        game.physics.p2.enable(this.seedSprite, false);
	        this.seedSprite.body.collideWorldBounds = true;
	        this.seedSprite.body.mass = 5;
	
	        this.seedSprite.body.setCircle(this.seedSprite.width * .2);
	
	        // Define the tree's collision group and make it collide with the ground
		    this.seedSprite.body.setCollisionGroup(seedCollision);
		    this.seedSprite.body.collides([seedCollision, deerCollision, crowCollision, squirrelCollision, altarCollision, skullCollision]);
		    this.seedSprite.body.collides(groundCollision, levelPlanetState.seedHitGround, this);
		    		    
		    this.seedSprite.body.removed = false;
		    this.seedSprite.body.specieOfTree = specieOfTree;
			
		}, this);
	    
	   
	    
	    // Add the seed to the seed group
        seedGroup.add(this.seedSprite);
		
		
		
		this.seedSprite.scale.x = 0;
        this.seedSprite.scale.y = 0;
        this.seedScaleInTween = levelPlanetState.add.tween(this.seedSprite.scale).to({x: 1, y: 1}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
	    	    
	    
	}

	treeGame.egg = function (x,y) 
	{	
		
		this.eggSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'crowEgg');	
		
		// Enable physics for the egg
        game.physics.p2.enable(this.eggSprite, false);
        this.eggSprite.body.collideWorldBounds = true;
        this.eggSprite.body.mass = 5;

        this.eggSprite.body.setCircle(this.eggSprite.width * .5);

        // Define the tree's collision group and make it collide with the ground
	    this.eggSprite.body.setCollisionGroup(eggCollision);
	    this.eggSprite.body.collides([seedCollision, deerCollision, crowCollision, squirrelCollision, altarCollision, skullCollision, eggCollision, poopCollision]);
	    this.eggSprite.body.collides(groundCollision, levelPlanetState.eggHitGround, this);

	    // Add the seed to the seed group
        eggGroup.add(this.eggSprite);
				
		this.eggSprite.scale.x = 0;
        this.eggSprite.scale.y = 0;
        this.eggScaleInTween = levelPlanetState.add.tween(this.eggSprite.scale).to({x: 1, y: 1}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
	    	    	    
	}
	
	treeGame.poop = function (x,y, animalSpecie, seeds) 
	{	
				
		switch (animalSpecie)
		{
			case 'deer':
			    var randomPoopSprite = game.rnd.integerInRange(0, 5);
		        switch (randomPoopSprite)
		        {
			        case 0:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop');
			            break;
			        case 1:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop2');
			            break;
			        case 2:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop3');
			            break;
			        case 3:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop4');
			            break;
			        case 4:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop5');
			            break;
			        case 5:
			            this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop6');
			            break;
		        }
			    break;
			case 'crow':
			    this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'crowPoop');
			    break;
			case 'squirrel':
			    this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'squirrelPoop');
			    break;
		    default:
			    this.poopSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerPoop');
			    break;
		}
		
		// Enable physics for the egg
        game.physics.p2.enable(this.poopSprite, false);
        this.poopSprite.body.collideWorldBounds = true;
        this.poopSprite.body.mass = 5;

        switch (animalSpecie)
        {
	        case 'crow':
	            this.poopSprite.body.setRectangle(this.poopSprite.width * .25);
	            break;
	        default:
	            this.poopSprite.body.setRectangle(this.poopSprite.width * .25);
	            break
        }

        // Define the tree's collision group and make it collide with the ground
	    this.poopSprite.body.setCollisionGroup(poopCollision);
	    this.poopSprite.body.collides([seedCollision, deerCollision, crowCollision, squirrelCollision, altarCollision, skullCollision, eggCollision, poopCollision]);
	    this.poopSprite.body.collides(groundCollision, levelPlanetState.poopHitGround, this);

	    // Add the seed to the seed group
        poopGroup.add(this.poopSprite);
				
		this.poopSprite.scale.x = 0;
        this.poopSprite.scale.y = 0;
        this.poopScaleInTween = levelPlanetState.add.tween(this.poopSprite.scale).to({x: .75, y: .75}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        
        seeds.forEach(function(seed) {
		    treeGame.seeds.push( new treeGame.seed(this.poopSprite.x, this.poopSprite.y, seed));
		}, this);
        
	}
	
	treeGame.plant = function (x,y, plantSpecie) 
	{	
		this.plantSpecie = plantSpecie;
				
	    // Create a bitmap for the root structure
	    this.randomVariation = game.rnd.integerInRange(-40, 40);
	    this.plantRootBitmap = levelPlanetState.game.add.bitmapData(400 + this.randomVariation, 200 + this.randomVariation);
	
		if (this.plantSpecie == null)
		{
			this.randomPlantType = game.rnd.integerInRange(0, 4);
			
			switch (this.randomPlantType) {
				case 0:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'clover');
				    this.plantSpecie = 'clover';
				    break;
				case 1:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'fern1');
				    this.plantSpecie = 'fern';
				    break;
				case 2:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'fern2');
				    this.plantSpecie = 'fern';
				    break;
				case 3:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'sage1');
				    this.plantSpecie = 'sage';
				    break;
				case 4:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'sage2');
				    this.plantSpecie = 'sage';
				    break;
				default:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'clover');
				    this.plantSpecie = 'clover';
				    break;
			}
			
		} else if (this.plantSpecie == 'fern')
		{
			this.randomFernImage = game.rnd.integerInRange(0, 1);
			switch(this.randomFernImage) 
			{
				case 0:
					this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'fern1');
					break;
				case 1:
					this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'fern2');
					break;
			}
			
		} else if (this.plantSpecie == 'clover')
		{
			this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'clover');
		} else if (this.plantSpecie == 'sage')
		{
			this.randomSageImage = game.rnd.integerInRange(0, 1);
			switch(this.randomSageImage) 
			{
				case 0:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'sage1');
				    break;
				case 1:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'sage2');
				    break;
				default:
				    this.plantSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'sage1');
				    break;
			}
			
		}
	
		
		
    
	    game.physics.p2.enable(this.plantSprite, false);
	    this.plantSprite.body.mass = 100;
	    this.plantSprite.body.collideWorldBounds = true;
	    plantGroup.add(this.plantSprite);
	    
	    // Define the plant's collision group and make it collide with the ground
	    this.plantSprite.body.setCollisionGroup(plantCollision);
	    this.plantSprite.body.collides([groundCollision], levelPlanetState.plantHitGround, this);
	    
	    if (this.plantSpecie == 'sage')
	    {
		    this.plantSprite.body.collides([humanCollision]);
	    }
	    
	    // Add click event
	    this.plantSprite.body.removed = false;
	    this.plantSprite.inputEnabled = true;
	    this.plantSprite.events.onInputDown.add(levelPlanetState.clickedPlant, this);
	    
	    // Create a sprite to hold the root structure
	    this.plantRootSprite = levelPlanetState.game.add.sprite(0 - (this.plantSprite.width*2.5),this.plantSprite.height/2, this.plantRootBitmap);
	    game.physics.enable(this.plantRootSprite, Phaser.Physics.ARCADE);
	    myceliumCollision.add(this.plantRootSprite);
	    this.plantRootSprite.alpha = .25;
	    this.plantSprite.addChild(this.plantRootSprite);

		this.belongsToFungus = treeGame.plants.length;
		
		this.plantSprite.body.removed = false;
		this.plantSprite.clicked = false;

        if (levelPlanetState.game.selectedLevel <= 4)
        {
		    this.plantWiggleTween = game.add.tween(this.plantSprite.body).to({angle: '+2'}, 750, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);
			
			this.plantSprite.scale.x = 0;
	        this.plantSprite.scale.y = 0;        
        }


// 	    this.plantSprite.body.y += this.plantRootSprite.height;
	    this.plantSprite.body.width = this.plantSprite.width;
	    this.plantSprite.body.height = this.plantSprite.height;
	    	    
	    	    

	    // Create the root network
	    switch(this.plantSpecie) {
		    case 'clover':
			    levelPlanetState.createPlantRoots(this.plantRootBitmap.width/2, 0, 20, 5, 0, this.plantRootBitmap, this.plantSprite.y);
			    break;
			case 'fern':
				levelPlanetState.createPlantRoots(this.plantRootBitmap.width/2, 0, 20, 10, 0, this.plantRootBitmap, this.plantSprite.y);
				break;
			default:
				levelPlanetState.createPlantRoots(this.plantRootBitmap.width/2, 0, 20, 5, 0, this.plantRootBitmap, this.plantSprite.y);
				break;
	    }
	    
	    
	    
	    
	    

	}

	
	treeGame.fungus = function (x,y, angle) 
	{	
		
		this.randomVariation = game.rnd.integerInRange(-40, 40);
		
	    // Create a bitmap for the mycelium structure
	    this.myceliumBitmap = levelPlanetState.game.add.bitmapData(400 + this.randomVariation, 200 + this.randomVariation);
	
		this.randomMushroomSpecies = game.rnd.integerInRange(0, 3);
		if (this.randomMushroomSpecies == 0)
		{
			this.mushroomSprite = levelPlanetState.game.add.sprite(x - 400 + this.randomVariation, y - 200 + this.randomVariation, 'textureAtlas', 'bolete');	
		} else if (this.randomMushroomSpecies == 1)
		{
			this.mushroomSprite = levelPlanetState.game.add.sprite(x, y - 200 + this.randomVariation, 'textureAtlas', 'bolete2');
		} else if (this.randomMushroomSpecies == 2)
		{
			this.mushroomSprite = levelPlanetState.game.add.sprite(x, y - 200 + this.randomVariation, 'textureAtlas', 'mushroomMilkCap');
		} else if (this.randomMushroomSpecies == 3)
		{
			this.mushroomSprite = levelPlanetState.game.add.sprite(x, y - 200 + this.randomVariation, 'textureAtlas', 'chanterelle');
		}
		
		if (angle)
		{
			this.mushroomSprite.angle = angle;
		}
	    
	    game.physics.p2.enable(this.mushroomSprite, false);
	    this.mushroomSprite.body.mass = 100;
	    this.mushroomSprite.body.collideWorldBounds = true;
	    this.mushroomSprite.alpha = 0;
	    var mushroomSpriteFadeInTween = game.add.tween(this.mushroomSprite).to({alpha:'1'}, 0, Phaser.Easing.Quadratic.InOut, true, 4000, 0, false);	

	    fungusGroup.add(this.mushroomSprite);
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.mushroomSprite.body.setCollisionGroup(mushroomCollision);
// 	    this.mushroomSprite.body.collides([forestGuardianCollision]);
	    this.mushroomSprite.body.collides([groundCollision], levelPlanetState.fungusHitGround, this);
	    
	    // Add click event
	    this.mushroomSprite.body.removed = false;
	    this.mushroomSprite.inputEnabled = true;
	    this.mushroomSprite.events.onInputDown.add(levelPlanetState.clickedFungus, this);
	    
	    // Create a sprite to hold the mycelium structure
	    this.myceliumSprite = levelPlanetState.game.add.sprite(0 - (this.mushroomSprite.width*4.7),this.mushroomSprite.height/2, this.myceliumBitmap);
	    game.physics.enable(this.myceliumSprite, Phaser.Physics.ARCADE);
	    myceliumCollision.add(this.myceliumSprite);
	    this.myceliumSprite.alpha = .25;
	    this.mushroomSprite.addChild(this.myceliumSprite);
	    this.myceliumSprite.alpha = 0;
	    var myceliumSpriteFadeInTween = game.add.tween(this.myceliumSprite).to({alpha:'.3'}, 0, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);	

		this.belongsToFungus = treeGame.fungi.length;
		
		this.mushroomSprite.body.removed = false;
		
/*
		this.mushroomSprite.scale.x = 0;
        this.mushroomSprite.scale.y = 0;
*/

	    this.mushroomSprite.body.y += this.myceliumSprite.height;
	    this.mushroomSprite.body.width = this.mushroomSprite.width;
	    this.mushroomSprite.body.height = this.mushroomSprite.height;
	    	    
	    	    
// 	    this.mushroomWiggleTween = game.add.tween(this.mushroomSprite.body).to({angle: '+1'}, 750, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);
	    	    
	    // Create the mycelium network
	    levelPlanetState.createMycelium(this.myceliumBitmap.width/2, 0, 20, 5, 0, this.myceliumBitmap, this.myceliumSprite.y);
	    
	    // Emit Spores
/*
	    this.sporeEmitter = levelPlanetState.game.add.emitter(0, 0, 100);
		this.sporeEmitter.width = 40;
		this.sporeEmitter.angle = 0;
		this.sporeEmitter.alpha = .1; 
		this.sporeEmitter.makeParticles('mushroomSporesImage');
		this.sporeEmitter.minParticleScale = 1;
		this.sporeEmitter.maxParticleScale = 1;
		this.sporeEmitter.setYSpeed(-100, -200);
		this.sporeEmitter.setXSpeed(-200, 200);
		this.sporeEmitter.minRotation = 0;
		this.sporeEmitter.maxRotation = 30;
		this.sporeEmitter.start(false, 20000, 5, 0);
		this.mushroomSprite.addChild(this.sporeEmitter);
*/

	}

    treeGame.rain = function (x, y, index) 
	{	
		this.index = index;
		
		this.randomCloudSprite = game.rnd.integerInRange(0, 2);

		switch(this.randomCloudSprite){
			case 0:
			    this.waterToolSprite = game.add.sprite(x,y, 'textureAtlas', 'cloud1');
			    break;
			case 1:
			    this.waterToolSprite = game.add.sprite(x,y, 'textureAtlas', 'cloud2');
			    break;
			case 2:
			    this.waterToolSprite = game.add.sprite(x,y, 'textureAtlas', 'cloud3');
		}
		
        this.waterToolSprite.scale.x = .5;
        this.waterToolSprite.scale.y = .5;
        this.waterToolSprite.alpha = .0;
        this.waterToolSprite.index = index;

        var rainCloudFadeInTween = game.add.tween(this.waterToolSprite).to({alpha:'.5'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, 0, false);	
        
        var rainCloudTween = game.add.tween(this.waterToolSprite).to({y:'+10'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);	

		rainGroup.add(this.waterToolSprite);
		
		// Make it rain
		this.rainEmitter = game.add.emitter(0,0, 100);
		this.rainEmitter.width = this.waterToolSprite.width;
		this.rainEmitter.angle = 0;
		this.rainEmitter.alpha = 0.25; 
		this.rainEmitter.makeParticles('textureAtlas', 'rain');
		this.rainEmitter.minParticleScale = 0.1;
		this.rainEmitter.maxParticleScale = 1;
		this.rainEmitter.setYSpeed(300, 500);
		this.rainEmitter.setXSpeed(-5, 5);
		this.rainEmitter.minRotation = 0;
		this.rainEmitter.maxRotation = 0;
		this.rainEmitter.start(false, 2000, 25, 0);
		rainCollision.add(this.rainEmitter);
		this.rainEmitter.alignIn(this.waterToolSprite, Phaser.CENTER);
		
        // Define the vicinity of the rain		
		this.rainVicinity = game.add.sprite(x+this.waterToolSprite.width/2,y);
		this.rainVicinity.height = 2000;
		this.waterToolSprite.addChild(this.rainVicinity);
        game.physics.p2.enable(this.rainVicinity, false);
        this.rainVicinity.body.collideWorldBounds = false;
        this.rainVicinity.body.setRectangle(this.waterToolSprite.width, 2000);
        this.rainVicinity.body.static = false;
        // Define the collision group
	    this.rainVicinity.body.setCollisionGroup(rainVicinityCollision);
	    this.rainVicinity.body.collides([spawnZoneSeedCollision]);
	    this.rainVicinity.body.collides([fireCollision], levelPlanetState.fireGettingRainedOn, this);
		rainGroup.add(this.rainVicinity);	
		
		// Give rainCloud a finite lifespan
	    rainFadeOutTween = levelPlanetState.add.tween(this.waterToolSprite).to({alpha: 0}, 5000, Phaser.Easing.Quadratic.InOut, true, 15000, 0, false);
	    rainFadeOutTween.onComplete.add(function (deadRainCloud) { 
// 		    deadRainCloud.destroy();





			treeGame.rains.forEach(function (rain)
			{
				if (rain.index == deadRainCloud.index)
				{

					try 
					{
						rain.rainEmitter.destroy();
					    rain.rainVicinity.body.destroy();
					    rain.waterToolSprite.destroy();	
					} 
					catch(err)
					{
						console.log(err.name, err.message);
					}
					
				}
			});






/*
		    this.rainEmitter.destroy();
		    this.waterToolSprite.kill();
*/
		});
						
	}

	treeGame.water = function (x, y, alpha) 
	{	
		this.waterSprite = game.add.sprite(x,y, 'waterImage');
		waterGroup.add(this.waterSprite);
		this.waterSprite.alpha = alpha;
		
        var waterLevelTween = game.add.tween(this.waterSprite).to({y:'+5'}, 0, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);	
			
	}
	
	treeGame.fire = function (x,y, index) 
	{	
		this.index = index;
								        
        this.fireSprite = game.add.sprite(x, y);

        // Enable physics for the fire
        game.physics.p2.enable(this.fireSprite, false);
        this.fireSprite.body.collideWorldBounds = true;

        this.fireSprite.body.setRectangle(25,25);
        this.fireSprite.body.static = true;

        // Define the collision group and make it collide with the ground
	    this.fireSprite.body.setCollisionGroup(fireCollision);
	    this.fireSprite.body.collides([groundCollision, forestGuardianCollision, rainVicinityCollision]);
	    this.fireSprite.body.collides([treeCollision], function(fire, tree){
		    fire.touchingTree = true;
	    }, this);

        // Add to group
        fireGroup.add(this.fireSprite);
        
        // Animate its properties
        var tweenScale = game.add.tween(this.fireSprite.scale).to({x: 1.1, y: 1.1}, 250, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        var tweenAngle = game.add.tween(this.fireSprite.body).to({angle:'+5'}, 250, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        
        if (game.particleEffectsToggle == true)
        {
	        // Emit flames
		    this.fireEmitter = game.add.emitter(0, 0, 50);
		    this.fireEmitter.makeParticles("textureAtlas", ['fire1','fire2','fire3']);
			this.fireEmitter.setRotation(0, 30);
			this.fireEmitter.setAlpha(1, null, 2000);
			this.fireEmitter.setScale(1, 0.5, 1, 0.5, 3000, Phaser.Easing.Quintic.Out);
			this.fireEmitter.gravity = -150;
			this.fireEmitter.blendMode = PIXI.blendModes.SOFT_LIGHT;
			this.fireEmitter.alignIn(this.fireSprite, Phaser.CENTER);   
			this.fireEmitter.start(false, 3000, 250);
        }
        
        this.belongsToTree = treeGame.trees.length;
        this.fireSprite.body.index = this.index;
        this.fireSprite.body.touchingTree = false;
	}
	
	treeGame.lightning = function (x, y) 
	{	
		
		this.x = x;
		this.y = y; 
		this.randomTrunkSizeVariation = game.rnd.integerInRange(-10, 10);
	    
	    // Create a bitmap for the lightning structure
	    this.lightningBitmap = levelPlanetState.game.add.bitmapData(250, 750);
	    
	    // Create a sprite to hold the root structure
	    this.lightningSprite = levelPlanetState.game.add.sprite(this.x,this.y, this.lightningBitmap);
	    
	    game.physics.p2.enable(this.lightningSprite, false);
	    this.lightningSprite.body.setRectangle(this.lightningSprite.width, this.lightningSprite.height);
	    this.lightningSprite.body.mass = 1000;
	    this.lightningSprite.body.static = true;
	    
	    lightningGroup.add(this.lightningSprite);
	    
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.lightningSprite.body.setCollisionGroup(lightningCollision);
	    this.lightningSprite.body.collides([groundCollision, spawnZoneSeedCollision]);
	    
	    // Create the tree crown
	    var segments = 20;
	    
	    var segmentWidth = 40;
	    
	    // Create the lightning
	    levelPlanetState.createLightning(this.lightningBitmap.width/2, 0, 10, 5, 0, this.lightningBitmap, this.lightningSprite.y);
	    
	    // Flash the lightning, then kill it.
	    this.lightningFlashTween = game.add.tween(this.lightningSprite)
        .to({ alpha: 0.5 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 1 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 0.25 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 0.75 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 0 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 0.5 }, 100, Phaser.Easing.Bounce.Out)
        .to({ alpha: 0.5 }, 100, Phaser.Easing.Bounce.Out)
        .start();
        this.lightningFlashTween.onComplete.add(function () 
        {
	        this.lightningSprite.body.destroy();
	        this.lightningSprite.kill();
	    }, this);
	    
	}


	treeGame.birchBarkBit = function (index, x, y, angle, alpha) 
	{	
		
		this.randomBirchBarkBit = game.rnd.integerInRange(0, 3);
		if (this.randomBirchBarkBit == 0)
		{
			this.birchBarkBitSprite = game.add.sprite(x,y, 'textureAtlas', 'birchBarkBit');
		} else if (this.randomBirchBarkBit == 1) {
			this.birchBarkBitSprite = game.add.sprite(x,y, 'textureAtlas', 'birchBarkBit2');
		} else if (this.randomBirchBarkBit == 2) {
			this.birchBarkBitSprite = game.add.sprite(x,y, 'textureAtlas', 'birchBarkBit3');
		} else if (this.randomBirchBarkBit == 3) {
			this.birchBarkBitSprite = game.add.sprite(x,y, 'textureAtlas', 'birchBarkBit4');
		} else {
			this.birchBarkBitSprite = game.add.sprite(x,y, 'textureAtlas', 'birchBarkBit');
		}
		

		game.physics.enable(this.birchBarkBitSprite, Phaser.Physics.ARCADE);
		this.birchBarkBitSprite.body.enable = true;
		this.birchBarkBitSprite.body.collideWorldBounds = true;
        this.birchBarkBitSprite.body.drag.x = 500;
        this.birchBarkBitSprite.body.drag.y = 500;
        this.birchBarkBitSprite.anchor.setTo(0.5, 0.5);
        this.birchBarkBitSprite.angle = angle;
        		
		this.belongsToTree = treeGame.trees.length;
			
	}


	treeGame.sky = function (index, x, y, width, height, alpha) 
	{			

        if (game.selectedLevel <= 4)
        {
	        this.skySprite = game.add.tileSprite(x, y, width, height, 'skyImage');		

        } else
        {

		    //  Our BitmapData (same size as our canvas)
// 		    this.skySprite = game.make.bitmapData(game.world.width*1.5, game.world.height*1.5);
		
		    //  Add it to the world or we can't see it
// 		    this.skySprite.addToWorld();
		
		    //  Create the Circles
/*
		    this.innerCircle = new Phaser.Circle(game.world.width/2, game.world.height/2, 100);
		    this.outerCircle = new Phaser.Circle(game.world.width/2, game.world.height/2, this.skySprite.width);
				
		    game.add.tween(this.innerCircle).to( { x: 100, y: 100, radius: 1}, 3000, "Sine.easeInOut", true, 0, -1, true);
		
		    this.grd = this.skySprite.context.createRadialGradient(this.innerCircle.x, this.innerCircle.y, this.innerCircle.radius, this.outerCircle.x, this.outerCircle.y, this.outerCircle.radius);
		    this.grd.addColorStop(0, 'rgba(78,104,101,.5)');
		    this.grd.addColorStop(1,'rgba(137,167,166,0)');
		
		    this.skySprite.cls();
		    this.skySprite.circle(this.outerCircle.x, this.outerCircle.y, this.outerCircle.radius, this.grd);
*/
		    
// 		    treeGame.grounds[0].groundSprite.addChild(this.skySprite);

		    
        }
        
// 	    this.skySprite.alpha = alpha;

        
		// Day-to-Night Cycle
		
		if (game.dayNightCycleToggle == true && game.selectedLevel <= 4)
		{
			this.skyNightSprite = game.add.tileSprite(x, y, width, height, 'skyNightImage');		
	        this.skyNightSprite.alpha = 0;
	        this.skyToNightTween = game.add.tween(this.skyNightSprite).to({alpha:'.75'}, 5000, Phaser.Easing.Quadratic.InOut, true, 5000, 0, false);
	        this.skyToDayTween = game.add.tween(this.skyNightSprite).to({alpha:'0'}, 5000, Phaser.Easing.Quadratic.InOut, true, 5000, 0, false);
	        this.skyToNightTween.onComplete.add(function () { this.skyToDayTween.start() }, this);
	        this.skyToDayTween.onComplete.add(function () { this.skyToNightTween.start() }, this);
	        // Add the sky to the sky group
	        skyGroup.add(this.skyNightSprite);
	        skyGroup.add(this.skySprite);

	        
		}
        
        
               	
	}
	
	treeGame.cloud = function (index, x, y) 
	{			
        this.index = index;
        
        this.randomSprite = game.rnd.integerInRange(0, 3);
		if (this.randomSprite == 0)
		{
			this.cloudSprite = game.add.sprite(x, y, 'textureAtlas', 'cloud1');
		} else if (this.randomSprite == 1) {
			this.cloudSprite = game.add.sprite(x, y, 'textureAtlas', 'cloud2');
		} else if (this.randomSprite == 2) {
			this.cloudSprite = game.add.sprite(x, y, 'textureAtlas', 'cloud3');
		} else if (this.randomSprite == 3) {
			this.cloudSprite = game.add.sprite(x, y, 'textureAtlas', 'cloud4');
		} else {
			this.cloudSprite = game.add.sprite(x, y, 'textureAtlas', 'cloud1');
		}
		
		this.cloudSprite.alpha = .5;

        game.physics.enable(this.cloudSprite, Phaser.Physics.ARCADE);
		this.cloudSprite.body.enable = true;
		this.cloudSprite.body.collideWorldBounds = false;
        this.cloudSprite.body.drag.x = 500;
        this.cloudSprite.body.drag.y = 500;
        this.cloudSprite.anchor.setTo(0.5, 0.5);
        
        this.randomSpeedVariation = game.rnd.integerInRange(-50, 50);
       
        // Add the cloud to the cloud group
        cloudGroup.add(this.cloudSprite);
        
        if (game.particleEffectsToggle == true)
        {
	        // Make it rain
		this.rainEmitter = game.add.emitter(0, 0, 50);
		this.rainEmitter.width = this.cloudSprite.width;
		this.rainEmitter.angle = 0;
		this.rainEmitter.alpha = 0.25; 
		this.rainEmitter.makeParticles('textureAtlas', 'rain');
		this.rainEmitter.minParticleScale = 0.1;
		this.rainEmitter.maxParticleScale = 1;
		this.rainEmitter.setYSpeed(300, 500);
		this.rainEmitter.setXSpeed(-5, 5);
		this.rainEmitter.minRotation = 0;
		this.rainEmitter.maxRotation = 0;
		this.rainEmitter.start(false, 2000, 150, 0);
		rainCollision.add(this.rainEmitter);
		this.rainEmitter.alignIn(this.cloudSprite, Phaser.CENTER);
        }
        
        
		
	}

	treeGame.ground = function (index, x, y, width, height, alpha) 
	{	
		// Set the image
/*
		this.groundSprite = game.add.graphics(game.world.width/2, game.world.height/2);

	    this.groundSprite.lineStyle(0, 0xffd900, 1);
	    this.groundSprite.beginFill(0xa18656);
	    this.groundSprite.drawCircle(0,0, 1000);
*/

        if (game.selectedLevel <= 4)
        {
	        this.randomSprite = game.rnd.integerInRange(1, 3);
			switch (this.randomSprite)
			{
				case 0:
					this.groundSprite = game.add.sprite(x, y, 'groundImage');
					break;
				case 1:
					this.groundSprite = game.add.sprite(x, y + 150, 'ground2Image');
					break;
				case 2:
					this.groundSprite = game.add.sprite(x, y, 'ground3Image');
					break;
				case 3:
					this.groundSprite = game.add.sprite(x, y, 'ground4Image');
					break;
			}
        } else {
	        this.groundSprite = game.add.sprite(x, y, 'planetImage');
	        
	        this.planetMountainSprite1 = game.add.sprite(300, 300, 'planetMountainImage1');
	        this.planetMountainSprite2 = game.add.sprite(300, 300, 'planetMountainImage2');
	        this.planetMountainSprite3 = game.add.sprite(300, 300, 'planetMountainImage3');
	        
	        this.planetMountainSprite1.alpha = .05;
	        this.planetMountainSprite2.alpha = .1;
	        this.planetMountainSprite3.alpha = .2;
	        
	        this.planetMountainSprite1.scale.x = 1.5;
	        this.planetMountainSprite2.scale.x = 2;
	        this.planetMountainSprite2.scale.x = 2.5;
	        
	        this.planetMountainSprite1.scale.y = 1.5;
	        this.planetMountainSprite2.scale.y = 2;
	        this.planetMountainSprite2.scale.y = 2.5;

	        
/*
	        this.groundSprite.addChild(this.planetMountainSprite1);
		    this.groundSprite.addChild(this.planetMountainSprite2);
		    this.groundSprite.addChild(this.planetMountainSprite3);
*/

	        mountainGroup.add(this.planetMountainSprite1);
	        mountainGroup.add(this.planetMountainSprite2);
	        mountainGroup.add(this.planetMountainSprite3);
        }
		
		
			
		this.groundSprite.enableBody = true;
		game.physics.p2.enable(this.groundSprite, false);
// 		this.groundSprite.body.setCircle(this.groundSprite.width/2);
		
		
		
		// Add our PhysicsEditor bounding shape
		this.groundSprite.body.clearShapes();
		
		// Set the physics shape
		
		if (game.selectedLevel <= 4)
        {
			switch (this.randomSprite)
			{
				case 0:
				    this.groundSprite.body.loadPolygon("groundPhysics", "ground");
					break;
				case 1:
				    this.groundSprite.body.loadPolygon("groundPhysics", "ground2");
					break;
				case 2:
				    this.groundSprite.body.loadPolygon("groundPhysics", "ground3");
					break;
			    case 3:
				    this.groundSprite.body.loadPolygon("groundPhysics", "ground4");
					break;
				default:
					this.groundSprite.body.loadPolygon("groundPhysics", "ground");
					break;
			}
		} else 
		{
			this.groundSprite.body.loadPolygon("groundPhysics", "planet");

		}
	    
		this.groundSprite.body.static = true;
// 		game.physics.enable(this.groundSprite, Phaser.Physics.ARCADE);
// 		this.groundSprite.body.enable = true;
		this.groundSprite.body.collideWorldBounds = false;

		groundGroup.add(this.groundSprite);

		// Define the ground's collision group and make it collide with trees
	    this.groundSprite.body.setCollisionGroup(groundCollision);
	    this.groundSprite.body.collides([
	        treeCollision,
	        lightningCollision,
	        treeGame.waterDropletCollision,
	        mushroomCollision,
	        deerCollision,
	        crowCollision,
	        squirrelCollision,
	        humanCollision,
	        forestGuardianCollision,
	        seedCollision,
	        spawnZoneSeedCollision,
	        plantCollision,
	        leafCollision,
	        altarCollision,
	        boulderCollision,
	        skullCollision,
	        eggCollision,
	        poopCollision,
	        earthenDemigodCollision
	    ]);
	    
	    this.groundSprite.alpha = alpha;
        
        // Rotate the planet	    
// 	    var tweenAngle = game.add.tween(this.groundSprite.body).to({angle:'+360'}, 275000, Phaser.Easing.Linear.InOut, true, 0, -1, false);

	    		
	}
	
	treeGame.mountain = function (index, x, y, width, height, alpha, key) 
	{			
	    this.mountainSprite = game.add.tileSprite(x, y, width, height, key);
        this.mountainSprite.alpha = alpha;
        
        this.mountainSprite.fixedToCamera = true;
        
        // Add the sky to the sky group
        mountainGroup.add(this.mountainSprite);
        
               	
	}
	
	treeGame.skull = function (x,y, species) 
	{	
				
		this.species = species;
		
		switch (this.species) {
			case "deer":
			    this.skullSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerSkull');
			    this.skullSprite.scale.x = .5;
				this.skullSprite.scale.y = .5;	
			    break;
			case "crow":
			    this.skullSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'crowSkull');
			    break;
			case "squirrel":
			    this.skullSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'squirrelSkull');
			    this.skullSprite.scale.x = .75;
				this.skullSprite.scale.y = .75;	
			    break;
			default:
			    this.skullSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'deerSkull');
		}
		
				    

	    game.physics.p2.enable(this.skullSprite, false);
	    this.skullSprite.body.mass = 500;
	    skullGroup.add(this.skullSprite);
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.skullSprite.body.setCollisionGroup(skullCollision);
	    this.skullSprite.body.collides([skullCollision, boulderCollision, altarCollision, leafCollision, seedCollision, crowCollision, humanCollision, squirrelCollision, poopCollision]);
	    this.skullSprite.body.collides([groundCollision]);
	    		
		this.skullSprite.body.removed = false;

	}
	treeGame.boulder = function (x,y) 
	{	
		
		
		var randomBoulderImage = game.rnd.integerInRange(0,1);
		
		switch (randomBoulderImage) {
			case 0:
			    this.boulderSprite = levelPlanetState.game.add.sprite(x, 0, 'textureAtlas', 'boulder1');
			    break;
			case 1:
			    this.boulderSprite = levelPlanetState.game.add.sprite(x, 0, 'textureAtlas', 'boulder2');
			    break;
			default:
			    this.boulderSprite = levelPlanetState.game.add.sprite(x, 0, 'textureAtlas', 'boulder1');
		}
			    
	    game.physics.p2.enable(this.boulderSprite, false);
	    this.boulderSprite.body.mass = 10000;
	    boulderGroup.add(this.boulderSprite);
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.boulderSprite.body.setCollisionGroup(boulderCollision);
	    this.boulderSprite.body.collides([boulderCollision, altarCollision, leafCollision, seedCollision, crowCollision, squirrelCollision, humanCollision, poopCollision]);
	    this.boulderSprite.body.collides([groundCollision], levelPlanetState.altarHitGround, this);
	    		
		this.boulderSprite.body.removed = false;
		
/*
		this.boulderSprite.scale.x = 0;
        this.boulderSprite.scale.y = 0;
*/

        levelPlanetState.game.world.wrap(this.boulderSprite.body, 0, false, true, true);

	}
	
	treeGame.altar = function (x,y) 
	{	
		
	    this.altarSprite = levelPlanetState.game.add.sprite(x, y, 'textureAtlas', 'altar');	
			    
	    game.physics.p2.enable(this.altarSprite, false);
	    this.altarSprite.body.mass = 10000;
	    altarGroup.add(this.altarSprite);
	    
	    // Define the tree's collision group and make it collide with the ground
	    this.altarSprite.body.setCollisionGroup(altarCollision);
	    this.altarSprite.body.collides([altarCollision, leafCollision, seedCollision, mushroomCollision, altarCollision, boulderCollision, humanCollision, crowCollision, squirrelCollision, skullCollision, poopCollision]);
	    this.altarSprite.body.collides([groundCollision], levelPlanetState.altarHitGround, this);
	    		
		this.altarSprite.body.removed = false;
		
		this.altarSprite.scale.x = 0;
        this.altarSprite.scale.y = 0;

	}
	
	treeGame.altar.prototype.update = function() {	
    
		treeGame.altars.forEach(function (altar)
		{
			// If this altar starts tipping, rotate it upright
			if (altar.altarSprite.angle < -20 )
			{
				altar.altarSprite.body.rotateRight(5);
			}
			if (altar.altarSprite.angle > 20 )
			{
				altar.altarSprite.body.rotateLeft(5);
			}

		});
		
	};

	
	treeGame.deer = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("deerJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "deerImages", "deer", 1, 100);
// 	    this._spriterGroup.position.setTo(x, y);
// 	    this._spriterGroup.position.setTo(game.world.width/2 - 200, game.world.height/2 + 120);
	    // adds SpriterGroup to Phaser.World to appear on screen
// 	    game.world.add(this._spriterGroup);
	    
	    this._spriterGroup.alpha = 0;
	    this._spriterGroup.y = -20;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: 1.1, y: 1.1}, 100, Phaser.Easing.Bounce.InOut, true, 10, 1, true);
        
        // Create a sprite to hold the spriterGroup
	    this.deerSprite = levelPlanetState.game.add.sprite(x, y);
	    this.deerSprite.addChild(this._spriterGroup);
	    deerGroup.add(this.deerSprite);
	    
	    // Deer's p2 body
	    game.physics.p2.enableBody(this.deerSprite, false);
	    this.deerSprite.body.setRectangle(this._spriterGroup.width - 40, this._spriterGroup.height - 120);
// 		this.deerSprite.body.loadPolygon("deerPhysics", "deerShape");
	    this.deerSprite.body.mass = 500;

	    this.deerSprite.body.collideWorldBounds = true;
	    
	    // Define the deer's collision group and make it collide with the ground
	    this.deerSprite.body.setCollisionGroup(deerCollision);
	    this.deerSprite.body.collides([groundCollision, deerCollision, crowCollision, squirrelCollision, leafCollision, poopCollision]);
	    this.deerSprite.body.collides([seedCollision], levelPlanetState.deerTouchingSeed, this);
	    
		// Add click event
	    this.deerSprite.body.removed = false;
	    this.deerSprite.inputEnabled = true;
	    this.deerSprite.events.onInputDown.add(levelPlanetState.clickedAnimal, this);
	    
	    this.deerSprite.body.index = treeGame.deers.length;
	    
	    // Deer status variables
	    this.deerSprite.species = "deer";
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 100 + randomStartingEnergy;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.deerSprite.clicked = false;
	    this.deerSprite.body.seedsEaten = [];
	    
        treeGame.numberOfDeerAlive += 1;
        
        levelPlanetState.updateObjectiveText();
	    

	}
	
	
	
	
	
	treeGame.deer.prototype.update = function() {	
    


		treeGame.deers.forEach(function (deer)
		{
			deer._spriterGroup.updateAnimation();
		
			//Deal with hunger
			if (deer.hunger < 1) {
			    deer.hungry = true;
			}
			deer.hunger -= .5;
			if (deer.hunger < -1000)
			{
				deer._spriterGroup.playAnimationById(2);
				levelPlanetState.animalStarved(deer.deerSprite);	
			}
		
			// Deal with energy and resting
			if (deer.currentAction == "walking")
			{
				// If this deer is not out of energy, 
				if (deer.energy >= 1) {
				    

				    deer.tired = false;
				    
				    // Boost the deer to the left for not being tired
				    deer.deerSprite.body.velocity.x = -200;
				} else {
				    if (deer.tired == false) {
					    deer.currentAction = "resting";
				        // play animation by Spriter animation id
				        deer._spriterGroup.playAnimationById(2);
				        
				        
				    }
				    
				    deer.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        deer.energy = 100;
				        deer.currentAction = "walking";
				        // play animation by Spriter animation id
				        deer._spriterGroup.playAnimationById(1);
				    }, this);
				    
				    
				}
				deer.energy -= .25;
			}	
			
            if (game.selectedLevel > 4)
		    {
				var speed = 320000;
				levelPlanetState.accelerateToObject(deer.deerSprite, treeGame.grounds[0].groundSprite, speed);
	        } else
	        {
				// If this deer starts tipping, rotate it back onto its feet.
				if (deer.deerSprite.angle < -20 )
				{
					deer.deerSprite.body.rotateRight(20);
				}
				if (deer.deerSprite.angle > 20 )
				{
					deer.deerSprite.body.rotateLeft(20);
				}	        
			}
		
			game.world.wrap(deer.deerSprite.body, 0, false, true, true);
		});
		
	};
	
	


	treeGame.crow = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("crowJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "crowImages", "entity_crow", 1, 100);
	    this._spriterGroup.scale.x = .5;
	    this._spriterGroup.scale.y = .5;
	    
	    this._spriterGroup.alpha = 0;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: .6, y: .6}, 100, Phaser.Easing.Bounce.InOut, true, 10, 1, true);
        
        // Create a sprite to hold the spriterGroup
	    this.crowSprite = levelPlanetState.game.add.sprite(x, y);
	    this.crowSprite.addChild(this._spriterGroup);
	    crowGroup.add(this.crowSprite);
	    this.crowSprite.anchor.setTo(0, 1);
	    this._spriterGroup.y += 40;
	    
	    
	    // Crow's p2 body
	    game.physics.p2.enableBody(this.crowSprite, false);
	    this.crowSprite.body.setRectangle(this._spriterGroup.width - 40, this._spriterGroup.height);
	    this.crowSprite.body.mass = 250;

	    this.crowSprite.body.collideWorldBounds = true;
	    
	    // Define the crow's collision group and make it collide with the ground
	    this.crowSprite.body.setCollisionGroup(crowCollision);
	    this.crowSprite.body.collides([groundCollision, deerCollision, humanCollision, leafCollision, boulderCollision, altarCollision, skullCollision, squirrelCollision, poopCollision]);
	    this.crowSprite.body.collides([seedCollision], levelPlanetState.crowTouchingSeed, this);
	    this.crowSprite.body.collides([crowCollision], levelPlanetState.crowTouchingCrow, this);
	    this.crowSprite.body.collides([spawnZoneSeedCollision], levelPlanetState.crowTouchingSpawnZoneSeed, this);
	    
	    this.crowSprite.body.index = treeGame.crows.length;
	    
	    // Add click event
	    this.crowSprite.body.removed = false;
	    this.crowSprite.inputEnabled = true;
	    this.crowSprite.events.onInputDown.add(levelPlanetState.clickedAnimal, this);
	    
	    // Crow status variables
	    this.crowSprite.species = "crow";
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 100 + randomStartingEnergy;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.crowSprite.body.numberOfEggsLaid = 0;
	    this.crowSprite.clicked = false;
	    this.crowSprite.body.seedsEaten = [];
	    
	    treeGame.numberOfCrowsAlive += 1;
	    
	    levelPlanetState.updateObjectiveText();

	}
	
	treeGame.crow.prototype.update = function() {	
    

		treeGame.crows.forEach(function (crow)
		{
			crow._spriterGroup.updateAnimation();
		
			//Deal with hunger
			if (crow.hunger < 1) {
			    crow.hungry = true;
			}

			crow.hunger -= .5;
			if (crow.hunger < -1000)
			{
				crow._spriterGroup.playAnimationById(2);
				levelPlanetState.animalStarved(crow.crowSprite);	
			}

		
			// Deal with energy and resting
			if (crow.currentAction == "walking")
			{
				// If this crow is not out of energy, 
				if (crow.energy >= 1) {
				    crow.tired = false;				    
				    // Boost the crow to the right for not being tired
				    crow.crowSprite.body.velocity.x = 100;
				    
				    if (Phaser.Utils.chanceRoll(1)) {
					    crow.currentAction = "flying";
		                crow.crowSprite.body.velocity.y = -750;
		                crow._spriterGroup.playAnimationById(0);
		                crow._spriterGroup._animationSpeed = 2;
		            }
				// Else if the crow is out of energy    
				} else {
				    if (crow.tired == false) {
					    crow.currentAction = "resting";
				        // play animation by Spriter animation id
				        crow._spriterGroup.playAnimationById(2);   
				    }
				    crow.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        crow.energy = 100;
				        crow.currentAction = "walking";
				        // play animation by Spriter animation id
				        crow._spriterGroup.playAnimationById(1);
				    }, this);
				}
				crow.energy -= .25;
			}
		
			if (crow.currentAction == "flying")
			{
				// If this crow is not out of energy, 
				if (crow.energy >= 1) {
				    crow.tired = false;				    
				    // Boost the crow to the right and up for not being tired
				    crow.crowSprite.body.velocity.x = 300;
				    var randomYVelocityVariation = game.rnd.integerInRange(-25, -300);
				    crow.crowSprite.body.velocity.y = randomYVelocityVariation;
				    
				    if (Phaser.Utils.chanceRoll(1)) {
					    crow.currentAction = "walking";
		                crow._spriterGroup.playAnimationById(1);
		                crow._spriterGroup._animationSpeed = 1;
		            }
				// Else if the crow is out of energy    
				} else {
				    if (crow.tired == false) {
					    crow.currentAction = "resting";
				        // play animation by Spriter animation id
				        crow._spriterGroup.playAnimationById(2);   
				    }
				    crow.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        crow.energy = 100;
				        crow.currentAction = "walking";
				        // play animation by Spriter animation id
				        crow._spriterGroup.playAnimationById(1);
				    }, this);
				}
				crow.energy -= .25;
			}

		    if (game.selectedLevel > 4)
			{
			    var speed = 80000;
				levelPlanetState.accelerateToObject(crow.crowSprite, treeGame.grounds[0].groundSprite, speed);	
		    } else
		    {
				// If this crow starts tipping, rotate it back onto its feet.
				if (crow.crowSprite.angle < -20 )
				{
					crow.crowSprite.body.rotateRight(20);
				}
				if (crow.crowSprite.angle > 20 )
				{
					crow.crowSprite.body.rotateLeft(20);
				}		    
			}
		     
			game.world.wrap(crow.crowSprite.body, 0, false, true, true);
		});
		
	};

	treeGame.squirrel = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("squirrelJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "squirrelImages", "entity_squirrel", 1, 200);
	    this._spriterGroup.scale.x = .35;
	    this._spriterGroup.scale.y = .35;
	    
	    this._spriterGroup.alpha = 0;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: .6, y: .6}, 100, Phaser.Easing.Bounce.InOut, true, 10, 1, true);
        
        // Create a sprite to hold the spriterGroup
	    this.squirrelSprite = levelPlanetState.game.add.sprite(x, y);
	    this.squirrelSprite.addChild(this._spriterGroup);
	    squirrelGroup.add(this.squirrelSprite);
	    this.squirrelSprite.anchor.setTo(0, 1);
	    this._spriterGroup.y += 40;
	    
	    
	    // Deer's p2 body
	    game.physics.p2.enableBody(this.squirrelSprite, false);
	    this.squirrelSprite.body.setRectangle(this._spriterGroup.width - 40, this._spriterGroup.height);
	    this.squirrelSprite.body.mass = 250;

	    this.squirrelSprite.body.collideWorldBounds = true;
	    
	    // Define the deer's collision group and make it collide with the ground
	    this.squirrelSprite.body.setCollisionGroup(squirrelCollision);
	    this.squirrelSprite.body.collides([groundCollision, deerCollision, humanCollision, leafCollision, boulderCollision, altarCollision, skullCollision, poopCollision]);
	    this.squirrelSprite.body.collides([seedCollision], levelPlanetState.squirrelTouchingSeed, this);
	    this.squirrelSprite.body.collides([squirrelCollision], levelPlanetState.squirrelTouchingSquirrel, this);
	    this.squirrelSprite.body.collides([spawnZoneSeedCollision], levelPlanetState.squirrelTouchingSpawnZoneSeed, this);
	    
	    this.squirrelSprite.body.index = treeGame.squirrels.length;
	    
	    // Add click event
	    this.squirrelSprite.body.removed = false;
	    this.squirrelSprite.inputEnabled = true;
	    this.squirrelSprite.events.onInputDown.add(levelPlanetState.clickedAnimal, this);
	    
	    // Deer status variables
	    this.squirrelSprite.species = "squirrel";
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 100 + randomStartingEnergy;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.squirrelSprite.body.numberOfBabiesMade = 0;
	    this.squirrelSprite.body.seedsEaten = [];
	    
	    treeGame.numberOfSquirrelsAlive += 1;
	    this.squirrelSprite.clicked = false;
	    
	    levelPlanetState.updateObjectiveText();

	}
	
	treeGame.squirrel.prototype.update = function() {	
    

		treeGame.squirrels.forEach(function (squirrel)
		{
			squirrel._spriterGroup.updateAnimation();
			

		
			//Deal with hunger
			if (squirrel.hunger < 1) {
			    squirrel.hungry = true;
			}

			squirrel.hunger -= .5;
			if (squirrel.hunger < -1000)
			{
				squirrel._spriterGroup.playAnimationByName("idle");
				levelPlanetState.animalStarved(squirrel.squirrelSprite);	
			}

		
			// Deal with energy and resting
			if (squirrel.currentAction == "walking")
			{
				// If this squirrel is not out of energy, 
				if (squirrel.energy >= 1) {
				    squirrel.tired = false;				    
				    // Boost the squirrel to the right for not being tired
				    squirrel.squirrelSprite.body.velocity.x = 150;
				    
		            
				// Else if the squirrel is out of energy    
				} else {
				    if (squirrel.tired == false) {
					    squirrel.currentAction = "resting";
				        // play animation by Spriter animation id
				        squirrel._spriterGroup.playAnimationByName("idle");   
				    }
				    squirrel.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        squirrel.energy = 100;
				        squirrel.currentAction = "walking";
				        // play animation by Spriter animation id
				        squirrel._spriterGroup.playAnimationByName("walk");
				    }, this);
				}
				squirrel.energy -= .25;
		        
		    }
		    
		    if (game.selectedLevel > 4)
		    {
			    var speed = 80000;
				levelPlanetState.accelerateToObject(squirrel.squirrelSprite, treeGame.grounds[0].groundSprite, speed);	
		    }  
		    else 
		    {
				// If this squirrel starts tipping, rotate it back onto its feet.
				if (squirrel.squirrelSprite.angle < -20 )
				{
					squirrel.squirrelSprite.body.rotateRight(20);
				}
				if (squirrel.squirrelSprite.angle > 20 )
				{
					squirrel.squirrelSprite.body.rotateLeft(20);
				}		    
			}   
			game.world.wrap(squirrel.squirrelSprite.body, 0, false, true, true);
		
	    });
	};

	
	treeGame.forestGuardianDestination = function (x,y) 
	{	
					        
        this.forestGuardianDestinationSprite = game.add.sprite(x, y, 'textureAtlas', 'destination');

        // Enable physics for the droplet
        game.physics.p2.enable(this.forestGuardianDestinationSprite, false);
        this.forestGuardianDestinationSprite.body.collideWorldBounds = true;

        this.forestGuardianDestinationSprite.body.setRectangle(this.forestGuardianDestinationSprite.width * .2, 2000);
        this.forestGuardianDestinationSprite.body.static = true;

        // Define the collision group and make it collide with the ground
	    this.forestGuardianDestinationSprite.body.setCollisionGroup(forestGuardianDestinationCollision);
	    this.forestGuardianDestinationSprite.body.collides([groundCollision, forestGuardianCollision]);

        // Add to group
        forestGuardianDestinationGroup.add(this.forestGuardianDestinationSprite);
        
        // Animate its properties
        var tweenScale = game.add.tween(this.forestGuardianDestinationSprite.scale).to({x: 1.1, y: 1.1}, 250, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
//         var tweenAngle = game.add.tween(this.forestGuardianDestinationSprite.body).to({angle:'+5'}, 250, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        
        if (game.particleEffectsToggle == true)
        {
	        // Emit particles
		    this.spiralEmitter = game.add.emitter(0, 0, 4000);
		    this.spiralEmitter.makeParticles("textureAtlas", "spiralParticle");
			this.spiralEmitter.setRotation(0, 360);
			this.spiralEmitter.setAlpha(0.75, null, 2000);
			this.spiralEmitter.setScale(1, 0.5, 1, 0.5, 3000, Phaser.Easing.Quintic.Out);
			this.spiralEmitter.gravity = -15;
			this.spiralEmitter.alignIn(this.forestGuardianDestinationSprite, Phaser.CENTER);   
			this.spiralEmitter.start(false, 1000, 10);
        }

        
		     
	}




	treeGame.forestGuardian = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("forestGuardianJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "forestGuardianImages", "entity_forestGuardian", 0, 45);
// 	    this._spriterGroup.position.setTo(x, y);
// 	    this._spriterGroup.position.setTo(game.world.width/2 - 200, game.world.height/2 + 120);
	    // adds SpriterGroup to Phaser.World to appear on screen
// 	    game.world.add(this._spriterGroup);
	    
	    this._spriterGroup.alpha = 0;
	    this._spriterGroup.scale.x = .4;
	    this._spriterGroup.scale.y = .4;
	    this._spriterGroup.y = 40;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: .4, y: .4}, 100, Phaser.Easing.Quadratic.InOut, true, 10, 0, true);
        
        // Create a sprite to hold the spriterGroup
	    this.forestGuardianSprite = levelPlanetState.game.add.sprite(x, y);
	    this.forestGuardianSprite.addChild(this._spriterGroup);
	    forestGuardianGroup.add(this.forestGuardianSprite);
	    
	    // forestGuardian's p2 body
	    game.physics.p2.enableBody(this.forestGuardianSprite, false);
	    this.forestGuardianSprite.body.setRectangle(200,350,0,40);
// 		this.forestGuardianSprite.body.loadPolygon("forestGuardianPhysics", "forestGuardianShape");
	    this.forestGuardianSprite.body.mass = 1500;
	    this.forestGuardianSprite.body.damping = 0.5;
	    this.forestGuardianSprite.body.inertia = 1500;

	    this.forestGuardianSprite.body.collideWorldBounds = true;
	    
	    // Define the forestGuardian's collision group and make it collide with the ground
	    this.forestGuardianSprite.body.setCollisionGroup(forestGuardianCollision);
	    this.forestGuardianSprite.body.collides([groundCollision, forestGuardianCollision, leafCollision]);
// 	    this.forestGuardianSprite.body.collides([mushroomCollision], levelPlanetState.forestGuardianTouchedMushroom, this);
	    this.forestGuardianSprite.body.collides([forestGuardianDestinationCollision], levelPlanetState.forestGuardianReachedDestination, this);
	    this.forestGuardianSprite.body.collides([treeCollision], levelPlanetState.forestGuardianTouchingTree, this);
	    this.forestGuardianSprite.body.collides([energyZoneCollision], levelPlanetState.forestGuardianTouchingEnergyZone, this);
	    
		// Add click event
	    this.forestGuardianSprite.body.removed = false;
	    this.forestGuardianSprite.inputEnabled = true;
// 	    this.forestGuardianSprite.events.onInputDown.add(levelPlanetState.clickedAnimal, this);
	    
	    this.forestGuardianSprite.body.index = treeGame.forestGuardians.length;
	    
	    // forestGuardian status variables
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 100;
	    this.previousEnergy = this.energy;
	    this.casting = false;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.previousAction = "";
	    this.currentDirection = "right";
	    this.isChangingDirection = false;
	    this.forestGuardianSprite.body.walkingSpeed = 300;
	    
	    // Create a bar to track life energy
	    var barConfig = {
			x: this.forestGuardianSprite.x, 
			y: this.forestGuardianSprite.y,
			width: 100,
			height: 15,
			bg: {color: '#8aa8a7'},
			bar: {color: '#634241'},
			animationDuration: 200,
		};
		
		this.powerBar = new HealthBar(game, barConfig);
        this.powerBar.setPercent(this.energy);
        this.powerBar.barSprite.alpha = .75;
        this.powerBar.bgSprite.alpha = .5;
        
		// Create a loop to decrease Forest Guardian scale slightly
/*
		this.forestGuardianSprite.forestGuardianScaleNumber = 0;
		
        levelPlanetState.time.events.loop(Phaser.Timer.SECOND * 2, function()
        {
	        if (this.forestGuardianSprite.scale.x >= .8)
	        {
		        if (this.forestGuardianSprite.forestGuardianScaleNumber < 10)
		        {
			        this.forestGuardianSprite.forestGuardianScaleNumber += 1;
		        }
		        
		        var forestGuardianScaleDown = levelPlanetState.add.tween(this.forestGuardianSprite.scale).to({x:"-.03",y:"-.03"}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);

				this.forestGuardianSprite.body.setRectangle(200 - (10*this.forestGuardianSprite.forestGuardianScaleNumber), 400 - (10*this.forestGuardianSprite.forestGuardianScaleNumber), 0, 30);
			    this.forestGuardianSprite.body.mass = 1500;
		
			    this.forestGuardianSprite.body.collideWorldBounds = true;
			    
			    // Define the forestGuardian's collision group and make it collide with the ground
			    this.forestGuardianSprite.body.setCollisionGroup(forestGuardianCollision);
			    this.forestGuardianSprite.body.collides([groundCollision, forestGuardianCollision, leafCollision]);
			    this.forestGuardianSprite.body.collides([forestGuardianDestinationCollision], levelPlanetState.forestGuardianReachedDestination, this);
			    this.forestGuardianSprite.body.collides([treeCollision], levelPlanetState.forestGuardianTouchingTree, this);
			    this.forestGuardianSprite.body.collides([energyZoneCollision], levelPlanetState.forestGuardianTouchingEnergyZone, this);


	        }
        }, this);
*/

	}
	
    treeGame.forestGuardian.prototype.update = function() {    
    


        treeGame.forestGuardians.forEach(function (forestGuardian)
        {
            forestGuardian._spriterGroup.updateAnimation();
            

            
            // Move toward the destination marker if it's visible
            // Move to the left if the destination has a lower x-value than you
            if (treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.alpha == 1 && 
                treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.x < forestGuardian.forestGuardianSprite.x) 
            {
	            
	            // Switch directions if facing the wrong way
	            if (forestGuardian.currentDirection == "right" && forestGuardian.isChangingDirection == false)
                {
                    forestGuardian.currentDirection = "left";
                    forestGuardian.isChangingDirection = true;
                    var tweenChangeDirection = game.add.tween(forestGuardian._spriterGroup.scale).to({x: forestGuardian._spriterGroup.scale.x * -1}, 250, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
                    tweenChangeDirection.onComplete.add(function () 
                    { 
// 		                console.log("forestGuardian._spriterGroup.scale = ",forestGuardian._spriterGroup.scale.x, " ", forestGuardian._spriterGroup.scale.y);
		                forestGuardian._spriterGroup.scale.x = -.4;
		                forestGuardian.isChangingDirection = false;
		            });
                } 
                
                if (forestGuardian.casting == false)
                {
	                forestGuardian.currentAction = "walking";
                } else
                {
	                forestGuardian.currentAction = "walkingAndCasting";

	                game.time.events.add(Phaser.Timer.SECOND * 3.25, function() 
		            {
			            forestGuardian.currentAction = "resting";
			            treeGame.forestGuardians[0].casting = false;
			        }, this);

                }
                
                if ( forestGuardian.energy > 0)
                {
	                
	                
	                
	                
	                
	                
	                
	                if (game.selectedLevel > 4)
	                {
		                if (forestGuardian.forestGuardianSprite.body.y > 2000)
		                {
			                forestGuardian.forestGuardianSprite.body.velocity.x = -( forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50) );    
		                }
		                else
		                {
			                forestGuardian.forestGuardianSprite.body.velocity.y = -( forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50) );    
		                }
	                }
	                else
	                {
	    	            forestGuardian.forestGuardianSprite.body.velocity.x = -( forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50) );    
	                }
	                
	                
	                
	                
	                
	                
	                
	                
//     	            forestGuardian.forestGuardianSprite.body.velocity.x = -( forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50) );    
                } else
                {
	                forestGuardian.currentAction = "resting";
	                forestGuardian.energy = 0;
	                levelPlanetState.forestGuardianReachedDestination(forestGuardian.body, treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body);
                }
                
                if (forestGuardian.energyZoneSprite > 0){
// 	                forestGuardian.energy -= .1;   
                } 
            
            // Move to the right if the destination has a higher x-value than you 
            } else if (treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.alpha == 1 && 
                treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.x > forestGuardian.forestGuardianSprite.x)
            {
	            
	            // Switch directions if facing the wrong way
	            if (forestGuardian.currentDirection == "left" && forestGuardian.isChangingDirection == false)
                {
                    forestGuardian.currentDirection = "right";
                    forestGuardian.isChangingDirection = true;
                    var tweenChangeDirection = game.add.tween(forestGuardian._spriterGroup.scale).to({x: forestGuardian._spriterGroup.scale.x * -1}, 250, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
                    tweenChangeDirection.onComplete.add(function () 
                    { 
// 		                console.log("forestGuardian._spriterGroup.scale = ",forestGuardian._spriterGroup.scale.x, " ", forestGuardian._spriterGroup.scale.y);
		                forestGuardian._spriterGroup.scale.x = .4;
	                    forestGuardian.isChangingDirection = false;
		            });
                }
                
                if (forestGuardian.casting == false)
                {
	                forestGuardian.currentAction = "walking";
                } else
                {
	                forestGuardian.currentAction = "walkingAndCasting";
	                game.time.events.add(Phaser.Timer.SECOND * 3.25, function() 
		            {
			            forestGuardian.currentAction = "resting";
			            treeGame.forestGuardians[0].casting = false;
			        }, this);
                }
                
                if ( forestGuardian.energy > 0)
                {
	                if (game.selectedLevel > 4)
	                {
		                if (forestGuardian.forestGuardianSprite.body.y < 2000)
		                {
			                forestGuardian.forestGuardianSprite.body.velocity.x = forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50);    
		                }
		                else
		                {
			                forestGuardian.forestGuardianSprite.body.velocity.y = forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50);    
		                }
	                }
	                else
	                {
		                forestGuardian.forestGuardianSprite.body.velocity.x = forestGuardian.forestGuardianSprite.body.walkingSpeed * (forestGuardian.energy / 50);    
	                }
                } else
                {
	                forestGuardian.currentAction = "resting";
	                forestGuardian.energy = 0;
	                levelPlanetState.forestGuardianReachedDestination(forestGuardian.body, treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body);
                }
                
                
                
                if (forestGuardian.energyZoneSprite > 0){
// 	                forestGuardian.energy -= .1;   
                }
                
            
            } else if (forestGuardian.currentAction == "casting"){
	            game.time.events.add(Phaser.Timer.SECOND * 3.25, function() 
	            {
		            forestGuardian.currentAction = "resting";
		            treeGame.forestGuardians[0].casting = false;
		        }, this);
		    } else {
			    forestGuardian.currentAction = "resting";
		    }
        
	        // Change animation if action changes
	        if (forestGuardian.currentAction != forestGuardian.previousAction)
	        {
		        forestGuardian.previousAction = forestGuardian.currentAction;
		        switch(forestGuardian.currentAction) 
				{
					case "walking":
						forestGuardian._spriterGroup.playAnimationById(1);
						 // Play Sound
				        treeGame.forestGuardianFootstepsSoundLoop.resume();
						break;
					case "resting":
						forestGuardian._spriterGroup.playAnimationById(0);
						// Pause Sound
				        treeGame.forestGuardianFootstepsSoundLoop.pause();
						break;
					case "casting":
						forestGuardian._spriterGroup.playAnimationById(2);
						// Pause Sound
				        treeGame.forestGuardianFootstepsSoundLoop.pause();
						break;
					case "walkingAndCasting":
						forestGuardian._spriterGroup.playAnimationById(3);
						 // Play Sound
				        treeGame.forestGuardianFootstepsSoundLoop.resume();						
				        break;
				}
	        }
	        

	        if(forestGuardian.forestGuardianSprite.body.walkingSpeed > 500)
	        {
		        forestGuardian.forestGuardianSprite.body.walkingSpeed = 500;
	        }

			if(forestGuardian.forestGuardianSprite.body.walkingSpeed >= 150)
	        {
// 		        forestGuardian.forestGuardianSprite.body.walkingSpeed -= 1;
	        }
	        
// 	        forestGuardian.forestGuardianSprite.body.walkingSpeed -= .5;
        
                  
            game.world.wrap(forestGuardian.forestGuardianSprite.body, 0, false, true, false);
            
            if (forestGuardian.energy > 100)
            {
	            forestGuardian.energy = 100;
            }
            
            // Decrease energy when walking
/*
            switch(forestGuardian.currentAction)
            {
	            case  "walking":
	                forestGuardian.energy -= .25;
	                break;
	            case "walkingAndCasting":
	                forestGuardian.energy -= .25;
	                break;
	            default:
	                break;
            }
*/
            
            // Update percent of energy on powerBar
            if (forestGuardian.energy != forestGuardian.previousEnergy) 
            {
	            forestGuardian.previousEnergy = forestGuardian.energy;
                forestGuardian.powerBar.setPercent(forestGuardian.energy); 
            }
            
            forestGuardian.powerBar.setPosition(forestGuardian.forestGuardianSprite.x, forestGuardian.forestGuardianSprite.y - 325);
            
            if (game.selectedLevel > 4)
		    {
				var speed = 1000000;
			    levelPlanetState.accelerateToObject(forestGuardian.forestGuardianSprite, treeGame.grounds[0].groundSprite, speed);			
		    } else
		    {
	            // If this forestGuardian starts tipping, rotate it back onto its feet.
	            if (forestGuardian.forestGuardianSprite.angle < -5 )
	            {
	                forestGuardian.forestGuardianSprite.body.rotateRight(10);
	            }
	            if (forestGuardian.forestGuardianSprite.angle > 5 )
	            {
	                forestGuardian.forestGuardianSprite.body.rotateLeft(10);
	            }			    
		    }
            
            
        });
        
    };
    
    treeGame.earthenDemigod = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("earthenDemigodJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "earthenDemigodImages", "entity_earthenDemigod", 0, 45);
// 	    this._spriterGroup.position.setTo(x, y);
// 	    this._spriterGroup.position.setTo(x - 600, y + 550);
	    
	    this._spriterGroup.alpha = 0;
	    this._spriterGroup.scale.x = .5;
	    this._spriterGroup.scale.y = .5;
	    this._spriterGroup.y = 240;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: .4, y: .4}, 100, Phaser.Easing.Quadratic.InOut, true, 10, 0, true);
        
        // Create a sprite to hold the spriterGroup
	    this.earthenDemigodSprite = levelPlanetState.game.add.sprite(x, y);
	    this.earthenDemigodSprite.addChild(this._spriterGroup);
	    earthenDemigodGroup.add(this.earthenDemigodSprite);
	    
	    // forestGuardian's p2 body
	    game.physics.p2.enableBody(this.earthenDemigodSprite, false);
	    this.earthenDemigodSprite.body.setRectangle(150,350,0,40);
	    this.earthenDemigodSprite.body.mass = 1500;

	    this.earthenDemigodSprite.body.collideWorldBounds = true;
	    
	    // Define the earthenDemigod's collision group and make it collide with the ground
	    this.earthenDemigodSprite.body.setCollisionGroup(earthenDemigodCollision);
	    this.earthenDemigodSprite.body.collides([groundCollision, forestGuardianCollision, leafCollision]);
	    
		// Add click event
	    this.earthenDemigodSprite.body.removed = false;
	    this.earthenDemigodSprite.inputEnabled = true;
	    
	    this.earthenDemigodSprite.body.index = treeGame.earthenDemigods.length;
	    
	    // earthenDemigod status variables
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 50;
	    this.previousEnergy = this.energy;
	    this.casting = false;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.previousAction = "";
	    this.currentDirection = "right";
	    this.isChangingDirection = false;
	    this.earthenDemigodSprite.body.walkingSpeed = 100;

	}
	
	treeGame.earthenDemigod.prototype.update = function() {	
    


		treeGame.earthenDemigods.forEach(function (earthenDemigod)
		{
			earthenDemigod._spriterGroup.updateAnimation();
			

			
			
			
			
			

		
			// Deal with energy and resting
			if (earthenDemigod.currentAction == "walking")
			{
				// If this earthenDemigod is not out of energy, 
				if (earthenDemigod.energy >= 1) {

				    earthenDemigod.tired = false;
				    
				    // Boost the earthenDemigod for not being tired
				    if (earthenDemigod.currentDirection == "right")
				    {
					    earthenDemigod.earthenDemigodSprite.body.velocity.x = 100;
				    } else {
					    earthenDemigod.earthenDemigodSprite.body.velocity.x = -100;
				    }
				    
				} else {
				    if (earthenDemigod.tired == false) {
					    
					    var randomAction = game.rnd.integerInRange(0, 2);
					    switch(randomAction)
					    {
						    case 0:
						        earthenDemigod.currentAction = "resting";
					            // play animation by Spriter animation id
					            earthenDemigod._spriterGroup.playAnimationByName("idle");
					            break;
					        case 1:
					            earthenDemigod.currentAction = "stomping";
						        // play animation by Spriter animation id
						        earthenDemigod._spriterGroup.playAnimationByName("stomp");
						        levelPlanetState.game.cameraShake.shake();
						        break;
						    case 2:
					            earthenDemigod.currentAction = "casting";
						        // play animation by Spriter animation id
						        earthenDemigod._spriterGroup.playAnimationByName("magic");
						        break;
					    }
					    
					    
				        
				        
				    }
				    
				    earthenDemigod.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        earthenDemigod.energy = 100;
				        earthenDemigod.currentAction = "walking";
				        // play animation by Spriter animation id
				        earthenDemigod._spriterGroup.playAnimationByName("walk");
				    }, this);
				    
				    
				}
				earthenDemigod.energy -= .25;
			}
		    
		    if (game.selectedLevel > 4)
		    {      
			    var speed = 300000;
			    levelPlanetState.accelerateToObject(earthenDemigod.earthenDemigodSprite, treeGame.grounds[0].groundSprite, speed);
		    } else
		    {
				// If this earthenDemigod starts tipping, rotate it back onto its feet.
				if (earthenDemigod.earthenDemigodSprite.angle < -10 )
				{
					earthenDemigod.earthenDemigodSprite.body.rotateRight(5);
				}
				if (earthenDemigod.earthenDemigodSprite.angle > 10 )
				{
					earthenDemigod.earthenDemigodSprite.body.rotateLeft(5);
				}		    
			}   
		    
			game.world.wrap(earthenDemigod.earthenDemigodSprite.body, 0, false, true, true);
		});
		
	};	
	
	
	
	


	treeGame.human = function (x,y) 
	{	
		
        // Load Spriter
		// create Spriter loader - class that can change Spriter file into internal structure
	    var spriterLoader = new Spriter.Loader();
	    // create Spriter file object - it wraps XML/JSON loaded with Phaser Loader
	    var spriterFile = new Spriter.SpriterJSON(game.cache.getJSON("humanJson"), /* optional parameters */ { imageNameType: Spriter.eImageNameType.NAME_AND_EXTENSION });
	    // proces Spriter file (XML/JSON) with Spriter loader - outputs Spriter animation which you can instantiate multiple times with SpriterGroup
	    var spriterData = spriterLoader.load(spriterFile);
	    // create actual renderable object - it is extension of Phaser.Group
	    this._spriterGroup = new Spriter.SpriterGroup(game, spriterData, "humanImages", "entity_human", 1, 100);
	    
	    // Assign this person their skin and clothing
	    this._spriterGroup.clearCharMaps();
	    var randomCharMap = game.rnd.integerInRange(0, 1);
	    switch(randomCharMap) {
		    case 0:
		        this._spriterGroup.pushCharMap("darkSkin");
		        break;
		    case 1:
		        this._spriterGroup.pushCharMap("lightSkin");
		        break;
		    default:
		        this._spriterGroup.pushCharMap("darkSkin");
		        break;
		}
		
		// Assign this person as a tree killer or worshipper
		var randomRole = game.rnd.integerInRange(0, 1);
	    switch(randomRole) {
		    case 0:
		        this.role = "woodcutter";
		        break;
		    case 1:
		        this.role = "worshipper";
		        this._spriterGroup.pushCharMap("noAxe");
		        break;
		    default:
		        this.role = "woodcutter";
		        break;
		}
		
		// Don't show them holding objects they don't have
		this._spriterGroup.pushCharMap("noSmudgeStick");
		    
// 	    this._spriterGroup.position.setTo(x, y);
// 	    this._spriterGroup.position.setTo(game.world.width/2 - 200, game.world.height/2 + 120);
	    // adds SpriterGroup to Phaser.World to appear on screen
// 	    game.world.add(this._spriterGroup);
	    
	    this._spriterGroup.alpha = 0;
	    this._spriterGroup.scale.x = .8;
	    this._spriterGroup.scale.y = .8;
	    this._spriterGroup.y = 150;
        var tweenFadeIn = game.add.tween(this._spriterGroup).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
        var tweenScaleIn = game.add.tween(this._spriterGroup.scale).to({x: 1.1, y: 1.1}, 100, Phaser.Easing.Bounce.InOut, true, 10, 1, true);
        
        // Create a sprite to hold the spriterGroup
	    this.humanSprite = levelPlanetState.game.add.sprite(x, y);
	    this.humanSprite.addChild(this._spriterGroup);
	    humanGroup.add(this.humanSprite);
	    
	    // human's p2 body
	    game.physics.p2.enableBody(this.humanSprite, false);
	    this.humanSprite.body.setRectangle(this._spriterGroup.width - 40, this._spriterGroup.height - 120);
	    this.humanSprite.body.mass = 500;

	    this.humanSprite.body.collideWorldBounds = true;
	    
	    // Define the human's collision group and make it collide with the ground
	    this.humanSprite.body.setCollisionGroup(humanCollision);
	    this.humanSprite.body.collides([groundCollision, crowCollision, leafCollision, skullCollision, poopCollision]);
	    if (this.role == "woodcutter")
	    {
		    this.humanSprite.body.collides([treeCollision], levelPlanetState.humanTouchingTree, this);
	    }
	    
	    if (this.role == "worshipper")
	    {
		    this.humanSprite.body.collides([plantCollision], levelPlanetState.humanTouchingPlant, this);
		    this.humanSprite.body.collides([boulderCollision], levelPlanetState.humanTouchingBoulder, this);
	    }
	    
		// Add click event
	    this.humanSprite.body.removed = false;
	    this.humanSprite.inputEnabled = true;
	    this.humanSprite.events.onInputDown.add(levelPlanetState.clickedAnimal, this);

	    this.humanSprite.body.index = treeGame.humans.length;
	    
	    // Thought Bubble
/*
	    this.thoughtBubbleMainSprite = levelPlanetState.game.add.sprite(-100, -475,  'textureAtlas', 'thoughtBubbleMain');
	    this.thoughtBubbleLeadingSprite1 = levelPlanetState.game.add.sprite(0, 150,  'textureAtlas', 'thoughtBubbleLeading1');
	    this.thoughtBubbleLeadingSprite2 = levelPlanetState.game.add.sprite(0, 200,  'textureAtlas', 'thoughtBubbleLeading2');
	    this.thoughtBubbleMainSprite.blendMode = Phaser.blendModes.SCREEN;
	    this.thoughtBubbleLeadingSprite1.blendMode = Phaser.blendModes.SCREEN;
	    this.thoughtBubbleLeadingSprite2.blendMode = Phaser.blendModes.SCREEN;
	    this.humanSprite.addChild(this.thoughtBubbleMainSprite);
	    this.thoughtBubbleMainSprite.addChild(this.thoughtBubbleLeadingSprite1);
	    this.thoughtBubbleMainSprite.addChild(this.thoughtBubbleLeadingSprite2);
*/
	    
	    // human status variables
	    var randomStartingEnergy = game.rnd.integerInRange(-50, 100);
	    this.energy = 100 + randomStartingEnergy;
	    this.tired = false;
	    this.hunger = 100;
	    this.hungry = false;
	    this.currentAction = "walking";
	    this.hasAxe = true;
	    this.hasSmudgeStick = false;
	    this.currentDirection = "right";
	    this.isChangingDirection = false;
	    this.humanSprite.clicked = false;
	    this.humanSprite.role = this.role;
	    
	    // Create a timed loop to change directions
	    
	    var randomDirection = game.rnd.integerInRange(0, 1);
			        
		if (randomDirection == 1)
        {
            this.currentDirection = "left";
            this.isChangingDirection = true;
            var tweenChangeDirection = game.add.tween(this.humanSprite.scale).to({x: this.humanSprite.scale.x * -1}, 250, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
// 	            this._spriterGroup.scale.x = -.8;
            this.isChangingDirection = false;
        }
				            

	}
	
	treeGame.human.prototype.update = function() {	
    


		treeGame.humans.forEach(function (human)
		{
			human._spriterGroup.updateAnimation();
			
			
			
			// Deal with energy and resting
			if (human.currentAction == "walking")
			{
				// If this human is not out of energy, 
				if (human.energy >= 1) {
				    

				    human.tired = false;
				    
				    // Boost the human for not being tired
				    if (human.currentDirection == "right")
				    {
					    human.humanSprite.body.velocity.x = 200;
				    } else {
					    human.humanSprite.body.velocity.x = -200;
				    }
				    
				} else {
				    if (human.tired == false) {
					    human.currentAction = "resting";
				        // play animation by Spriter animation id
				        human._spriterGroup.playAnimationByName("idle");
				        
				        
				    }
				    
				    human.tired = true;
				    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        human.energy = 100;
				        human.currentAction = "walking";
				        // play animation by Spriter animation id
				        human._spriterGroup.playAnimationByName("walk");
				    }, this);
				    
				    
				}
				human.energy -= .25;
			}

			if (game.selectedLevel > 4)
		    {
				var speed = 160000;
				levelPlanetState.accelerateToObject(human.humanSprite, treeGame.grounds[0].groundSprite, speed);	
		    } else {
			    // If this human starts tipping, rotate it back onto its feet.
	            if (human.humanSprite.angle < -5 )
	            {
	                human.humanSprite.body.rotateRight(5);
	            }
	            if (human.humanSprite.angle > 5 )
	            {
	                human.humanSprite.body.rotateLeft(5);
	            }
		    }
		    
			game.world.wrap(human.humanSprite.body, 0, false, true, true);
		});
		
	};

	

	// 	Spawn Zones
	
	console.log("Loading spawn zones...");

	treeGame.spawnZoneTreeShade = function (index, x, y) 
	{	
	    this.spawnZoneTreeShadeVicinity = game.add.sprite(x,y, null);
	    game.physics.enable(this.spawnZoneTreeShadeVicinity, Phaser.Physics.ARCADE);
	    this.spawnZoneTreeShadeVicinity.anchor.setTo(0.5, 0.5);
	    this.spawnZoneTreeShadeVicinity.body.enable = true;
	    this.spawnZoneTreeShadeVicinity.body.setSize(700, 10);
	    this.spawnZoneTreeShadeVicinity.body.collideWorldBounds = true;
	    
	    this.belongsToTree = treeGame.trees.length;	
	} 
	
	treeGame.spawnZoneSeed = function (index, x, y, angle, alpha, specieOfTree) 
	{	
	    this.spawnZoneSeedVicinity = game.add.sprite(x,y, null);
	    
	    // Set P2 Body
	    game.physics.p2.enableBody(this.spawnZoneSeedVicinity, false);
	    this.spawnZoneSeedVicinity.body.setRectangle(50, 50);
	    this.spawnZoneSeedVicinity.body.mass = 250;
	    this.spawnZoneSeedVicinity.body.static = false;

	    this.spawnZoneSeedVicinity.body.collideWorldBounds = true;
	    
	    // Define the collision group and make it collide with the ground
	    this.spawnZoneSeedVicinity.body.setCollisionGroup(spawnZoneSeedCollision);
	    this.spawnZoneSeedVicinity.body.collides([crowCollision, squirrelCollision, energyZoneCollision, spawnZoneSeedCollision]);
	    this.spawnZoneSeedVicinity.body.collides([groundCollision], levelPlanetState.spawnZoneSeedTouchingGround, this);
	    this.spawnZoneSeedVicinity.body.collides([lightningCollision], levelPlanetState.spawnZoneSeedTouchingLightning, this);
	    this.spawnZoneSeedVicinity.body.collides([rainVicinityCollision], levelPlanetState.spawnZoneSeedGettingRainedOn, this);
	    
	    this.belongsToTree = treeGame.trees.length;
	    this.specieOftree = specieOfTree;
	    
	    this.index = treeGame.spawnZoneSeedsCounter;
	    this.spawnZoneSeedVicinity.body.index = treeGame.spawnZoneSeedsCounter;
	    treeGame.spawnZoneSeedsCounter += 1;
	    
	    this.onFire = false;
	    this.spawnZoneSeedVicinity.body.onFire = false;
	    this.spawnZoneSeedVicinity.body.wet = false;
	    this.hitGround = false;
	    

	    
	} 


 };     
	
		
treeGame.levelPlanet.prototype = { 
	
	goFull: function() 
	{
	
	    if (levelPlanetState.game.scale.isFullScreen)
	    {
	        levelPlanetState.game.scale.stopFullScreen();
	    }
	    else
	    {
	        levelPlanetState.game.scale.startFullScreen(false);
	    }
	},
    
    preload: function()
    {
		// Set variables
		treeGame.background = null;
		treeGame.overlayTexture = null;
		treeGame.cursors = null;
		treeGame.activeTool = "setForestGuardianDestination";
		treeGame.uiActive = false;
		treeGame.objectives = [];
		
		treeGame.skies = [];
		
		treeGame.clouds = [];
		treeGame.rains = [];
		
		treeGame.mountains = [];
		
		treeGame.grounds = [];
		groundCollision = [];
		
		treeGame.emitter = null;
		treeGame.rainEmitter = null;
		
		treeGame.specieOfTree = ['oak', 'beech', 'birch', 'pine', 'willow'];
		treeGame.selectedTreeSpawn = null;
		
		treeGame.trees = [];
		treeCollision = [];
		treeGame.birchBarkBits = [];
		treeGame.birchBarkBitCollision = null;
		treeGame.leaves = [];
		treeGame.latestLeaves = null;
		treeGame.nextLeafSpawn = 0;
		treeGame.leafSpawnDelay = 5000;
		treeGame.treeRootCollision = [];
		treeGame.treeSpriteY = null;
		
		treeGame.seeds = [];
		treeGame.spawnZoneSeeds = [];
		treeGame.spawnZoneSeedsCounter = 0;
		treeGame.nextSeedSpawn = 0;
		treeGame.seedSpawnDelay = 5000;
		
		treeGame.latestDeadTreeIndex = null;
		
		treeGame.plants = [];
		treeGame.nextFernSpawn = 0;
		treeGame.fernSpawnDelay = 5000;
		treeGame.nextCloverSpawn = 0;
		treeGame.cloverSpawnDelay = 5000;
		
		treeGame.fungi = [];
		treeGame.spawnZoneTreeShades = [];
		treeGame.nextFungusSpawn = 0;
		treeGame.fungusSpawnDelay = 5000;
		treeGame.fungiMaximum = 10;
		
		treeGame.waterDroplets = [];
		treeGame.waterDropletCollision = null;
		
		treeGame.waters = [];
		treeGame.fires = [];
		treeGame.lightnings = [];
		
		treeGame.specieOfAnimal = ['deer', 'crow'];
		treeGame.deers = [];
		treeGame.crows = [];
		treeGame.squirrels = [];
		treeGame.forestGuardians = [];
		treeGame.forestGuardianDestinations = []
		treeGame.humans = [];
		treeGame.earthenDemigods = [];
		
		treeGame.eggs = [];
		treeGame.skulls = [];
		treeGame.poops = [];
		
		treeGame.boulders = [];
		treeGame.altars = [];

        // Stat Collectors
        treeGame.numberOfPlantsAbsorbed = 0;
        treeGame.distanceWalked = 0;
        
        treeGame.currentObjective = "";
        
        treeGame.numberOfTreesCreated = 0;
        treeGame.numberOfTreesOakCreated = 0;
        treeGame.numberOfTreesBeechCreated = 0;
		treeGame.numberOfTreesBirchCreated = 0;
        treeGame.numberOfTreesPineCreated = 0;
        treeGame.numberOfTreesWillowCreated = 0;
        
        treeGame.numberOfMushroomsAbsorbed = 0;
        
        treeGame.numberOfCrowsAlive = 0;
        treeGame.numberOfSquirrelsAlive = 0;
        treeGame.numberOfDeerAlive = 0;
        
        treeGame.numberOfFiresPutOut = 0;
        
        treeGame.numberOfWorshippers = 0;
        treeGame.numberOfCeremoniesAttended = 0;
        treeGame.numberOfWoodcuttersAbsorbed = 0;
        treeGame.numberOfWorshippersAbsorbed = 0;

		
    },
     
    create: function() 
    {
        // Viewport Scaling
		this.game.scale.startFullScreen(false);
		this.game.scale.scaleMode = Phaser.ScaleManager.RESIZE;
		this.game.scale.pageAlignHorizontally = true;
		this.game.scale.pageAlignVertically = true;
		this.game.scale.refresh(); 
		
	    this.game.time.advancedTiming = true;
	    
	    if (this.game.selectedLevel <= 4)
		{
		    this.game.world.setBounds(0, -20, 4000, 2000);
	    }
	    else
	    {
	        this.game.world.setBounds(0, -20, 4000, 4000);
	    }
        
        this.game.kineticScrolling.start();
                
        // Start and configure physics
        this.game.physics.startSystem(Phaser.Physics.ARCADE);
        this.game.physics.startSystem(Phaser.Physics.P2JS);
        this.game.physics.p2.setImpactEvents(true);
        
        // Set the gravity and bounciness
        
        if (this.game.selectedLevel <= 4)
		{
			this.game.physics.p2.applyGravity = true;
			this.game.physics.p2.gravity.y = 1000;
		} else
		{
	        this.game.physics.p2.applyGravity = false;
		}
	    this.game.physics.p2.restitution = .00025;
	    this.game.physics.p2.friction = 10000;

		// Fullscreen Hotkey
		var fullscreenKey = this.game.input.keyboard.addKey(Phaser.Keyboard.F);	
	    fullscreenKey.onDown.add(this.goFull, this);	
	    
		var ambientForest4 = this.game.add.audio('ambientForestSound4', .25, true);
		ambientForest4.play();
		
		if (this.game.selectedLevel > 1)
		{
			var crowsAndCricketsSound = this.game.add.audio('crowsAndCricketsSound2', .25, true);
		    crowsAndCricketsSound.play();
		}
		
        console.log("Generating world...");
        
		// Create Collision Groups
		skyGroup = levelPlanetState.add.group();
		lightningGroup = levelPlanetState.add.group();	
		lightningCollision = levelPlanetState.physics.p2.createCollisionGroup();
		cloudGroup = levelPlanetState.add.group();
		groundCollision = levelPlanetState.physics.p2.createCollisionGroup();
		mountainGroup = levelPlanetState.add.group();
		waterGroup = levelPlanetState.add.group();
		rainCollision = levelPlanetState.add.group();
		rainVicinityCollision = levelPlanetState.physics.p2.createCollisionGroup();
		boulderGroup = levelPlanetState.add.group();
		altarGroup = levelPlanetState.add.group();
		groundGroup = levelPlanetState.add.group();
	    treeCollision = levelPlanetState.physics.p2.createCollisionGroup();
	    treeGroup = levelPlanetState.add.group();	
		treeRootCollision = levelPlanetState.add.group();
		leafGroup = levelPlanetState.add.group();
		treeGame.latestLeaves = levelPlanetState.add.group();
		leafCollision = levelPlanetState.physics.p2.createCollisionGroup();
		skullCollision = levelPlanetState.physics.p2.createCollisionGroup();
		skullGroup = levelPlanetState.add.group();
		fireCollision = levelPlanetState.physics.p2.createCollisionGroup();
		fireGroup = levelPlanetState.add.group();
		waterDropletGroup = levelPlanetState.add.group();
		treeGame.waterDropletCollision = levelPlanetState.physics.p2.createCollisionGroup();
		plantCollision = levelPlanetState.physics.p2.createCollisionGroup();
		plantGroup = levelPlanetState.add.group();
		altarCollision = levelPlanetState.physics.p2.createCollisionGroup();
		boulderCollision = levelPlanetState.physics.p2.createCollisionGroup();
		energyZoneCollision = levelPlanetState.physics.p2.createCollisionGroup();
		deerCollision = levelPlanetState.physics.p2.createCollisionGroup();
		deerGroup = levelPlanetState.add.group();
		humanCollision = levelPlanetState.physics.p2.createCollisionGroup();
		humanGroup = levelPlanetState.add.group();
		earthenDemigodCollision = levelPlanetState.physics.p2.createCollisionGroup();
		earthenDemigodGroup = levelPlanetState.add.group();
		spawnZoneSeedCollision = levelPlanetState.physics.p2.createCollisionGroup();
		crowCollision = levelPlanetState.physics.p2.createCollisionGroup();
		crowGroup = levelPlanetState.add.group();
		squirrelCollision = levelPlanetState.physics.p2.createCollisionGroup();
		squirrelGroup = levelPlanetState.add.group();
		myceliumCollision = levelPlanetState.add.group();
		fungusGroup = levelPlanetState.add.group();
		mushroomCollision = levelPlanetState.physics.p2.createCollisionGroup();
		seedCollision = levelPlanetState.physics.p2.createCollisionGroup();
		seedGroup = levelPlanetState.add.group();
		eggGroup = levelPlanetState.add.group();
		poopGroup = levelPlanetState.add.group();
		poopCollision = levelPlanetState.physics.p2.createCollisionGroup();
		rainGroup = levelPlanetState.add.group();
		eggCollision = levelPlanetState.physics.p2.createCollisionGroup();
		forestGuardianCollision = levelPlanetState.physics.p2.createCollisionGroup();
		forestGuardianGroup = levelPlanetState.add.group();
		forestGuardianDestinationCollision = levelPlanetState.physics.p2.createCollisionGroup();
		forestGuardianDestinationGroup = levelPlanetState.add.group();
		
		uiGroup = levelPlanetState.add.group();
		spawnTreeSpeciesGroup = levelPlanetState.add.group();
		spawnAnimalSpeciesGroup = levelPlanetState.add.group();
		
		overlayTexture = levelPlanetState.add.group();

		// Create buttons n' stuff
		this.createUI();
// 		this.createMessageBox();

		// Overlay a texture over the top of the game world
		this.texture = this.game.add.tileSprite(0,-50,4000,4000,'textureImage');
		this.texture.worldPosition.y = 0;
        this.texture.blendMode = Phaser.blendModes.COLOR_BURN;
        this.texture.alpha = .25;
        this.texture.fixedToCamera = true;
        overlayTexture.add(this.texture);
	
	    // Trigger mouse clicks and taps
	    this.game.input.onTap.add(this.mouseClick, this);
	    
	    
        
        // Create Clouds
        var numberOfClouds = this.game.rnd.integerInRange(3, 10);

        for (var i = 0; i < numberOfClouds; i++)
	    {
		    var yRandomVariation = this.game.rnd.integerInRange(-200, 200);
            treeGame.clouds.push( new treeGame.cloud(treeGame.clouds.length, this.world.randomX, 300 + yRandomVariation, 1));
	    }
	    
	    // Create Mountains
	    if (this.game.selectedLevel <= 4)
	    {
// 			treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 250, this.game.world.width, this.game.world.height, .25, 'mountainImage4'));
	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, -150, this.game.world.width, this.game.world.height, .05, 'mountainImage3'));
	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, -200, this.game.world.width, this.game.world.height, .075, 'mountainImage2'));
	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, -50, this.game.world.width, this.game.world.height, .1, 'mountainImage1'));
// 	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .25, 'mountainImage')); 
		   
	    } else
	    {
/*
		    treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .05, 'planetMountainImage1'));
	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .075, 'planetMountainImage2'));
	        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .1, 'planetMountainImage3'));
*/
	    }
	    
        
	    
        // Create Ground
        treeGame.grounds.enableBody = true;
        if (this.game.selectedLevel <= 4)
        {
	        treeGame.grounds.push( new treeGame.ground(treeGame.grounds.length, this.game.world.width/2, this.game.world.height/2 + 700, this.game.width, 200, 1));
        }
        else {
            treeGame.grounds.push( new treeGame.ground(treeGame.grounds.length, this.game.world.width/2, this.game.world.height/2, this.game.width, this.game.height, 1));
        }
        
        // Create Sky
	    treeGame.skies.push( new treeGame.sky(treeGame.skies.length, 0, 0, this.game.world.width, this.game.world.height, 1));

	    
        // Create Water
        if (this.game.selectedLevel <= 4)
        {
	        treeGame.waters.push( new treeGame.water(0, this.game.world.height/2 + 250, .5));
        }
        
        if (this.game.selectedLevel > 1)
        {
	        // Create Deer
// 	        var numberOfStarterDeer = this.game.rnd.integerInRange(2,5);
			var numberOfStarterDeer = 10;
	        for (var i = 0; i < numberOfStarterDeer; i++)
		    {
			    var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
		        treeGame.deers.push( new treeGame.deer(xRandomVariation, 0));
	        }
	        
	        // Create Crows
	        var numberOfStarterCrows = this.game.rnd.integerInRange(2,6);
	        for (var i = 0; i < numberOfStarterCrows; i++)
		    {
		        treeGame.crows.push( new treeGame.crow(this.game.world.width/2 - 400, 0));
	        }
	        
	        // Create Squirrels
	        var numberOfStarterSquirrels = this.game.rnd.integerInRange(2,6);
	        for (var i = 0; i < numberOfStarterSquirrels; i++)
		    {
			    var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
	            treeGame.squirrels.push( new treeGame.squirrel(xRandomVariation, 0));
		    }
	        
	        // Create Eggs
	        this.game.randomNumberOfCrowEggs = this.game.rnd.integerInRange(2, 6);
		    for (var i = 0; i < this.game.randomNumberOfCrowEgg; i++)
		    {
			    var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
	            treeGame.eggs.push( new treeGame.egg(xRandomVariation, 0));
		    }
		    
		    // Create Seeds
	        var numberOfSeeds = 0;
		    for (var i = 0; i < numberOfSeeds; i++)
		    {
			    var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
	            treeGame.seeds.push( new treeGame.seed(xRandomVariation, 0, "pine"));
		    }
	        
	        // Create Animal Spawner
	        this.time.events.loop(Phaser.Timer.SECOND * 20, this.animalSpawner, this);
	        
	        // Sometimes animals poop
		    this.time.events.loop(Phaser.Timer.SECOND * 10, this.animalsPoop, this);	
	        
        }
        
        if (this.game.selectedLevel > 2)
        {
	        
	        // Create Human
	        var numberOfStarterHumans = this.game.rnd.integerInRange(1,4);
	        for (var i = 0; i < numberOfStarterHumans; i++)
		    {
	            treeGame.humans.push( new treeGame.human(200, 0));
	        }
        }        

		// Create Plant Spawner
        this.time.events.loop(Phaser.Timer.SECOND * 20, this.plantSpawner, this);

        // Create Forest Guardian
        treeGame.forestGuardians.push( new treeGame.forestGuardian(100, 0));
        this.camera.follow(treeGame.forestGuardians[treeGame.forestGuardians.length - 1].forestGuardianSprite, Phaser.Camera.FOLLOW_PLATFORMER, 0.1, 0.1);
		treeGame.forestGuardianFootstepsSoundLoop = levelPlanetState.add.audio('forestGuardianFootstepsSound', 1, true);
		treeGame.forestGuardianFootstepsSoundLoop.play();

        //Create Forest Guardian Destination Marker
        treeGame.forestGuardianDestinations.push( new treeGame.forestGuardianDestination(100, 0));

        if (this.game.selectedLevel > 3)
        {
	        // Create Earthen Demigod
	        var numberOfStarterEarthenDemigods = this.game.rnd.integerInRange(1,1);
	        for (var i = 0; i < numberOfStarterEarthenDemigods; i++)
		    {
	            treeGame.earthenDemigods.push( new treeGame.earthenDemigod(600, 0));
	        }
// 	        this.camera.follow(treeGame.earthenDemigods[treeGame.earthenDemigods.length - 1].earthenDemigodSprite, Phaser.Camera.FOLLOW_PLATFORMER, 0.1, 0.1);
        }   
        
        // Create Plants
        var numberOfStarterPlants = this.game.rnd.integerInRange(40,80);
        for (var i = 0; i < numberOfStarterPlants; i++) 
        {
	        if (this.game.selectedLevel <= 4)
	        {
		        var plantsStartDirection = 0;
	        } else
	        {
		        var plantsStartDirection = this.game.rnd.integerInRange(0,3);
	        }
	        switch (plantsStartDirection)
	        {
		        case 0:
			            var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
					    treeGame.plants.push( new treeGame.plant(xRandomVariation, 0));
			        break;
			    case 1:
			            var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
					    treeGame.plants.push( new treeGame.plant(xRandomVariation, this.game.world.height));
			        break;
			    case 2:
			            var yRandomVariation = this.game.rnd.integerInRange(0, this.game.world.height);
					    treeGame.plants.push( new treeGame.plant(0, yRandomVariation));
			        break;
			    case 3:
			            var yRandomVariation = this.game.rnd.integerInRange(0, this.game.world.height);
					    treeGame.plants.push( new treeGame.plant(this.game.world.width, yRandomVariation));
			        break;
	        }
        }

        
        
	    
	     // Create Fire
        for (var i = 0; i < 0; i++) {
	        var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
		
			treeGame.fires.push( new treeGame.fire(xRandomVariation, this.game.world.height/2, i));
		    
	    }
	    
// 	    this.time.events.loop(Phaser.Timer.SECOND * 2, this.checkIfFireIsTouchingTree, this);
	    
	    // Create Lightning
	    this.time.events.loop(Phaser.Timer.SECOND * 5, this.lightningSpawner, this);
	    	    
	    // Create Boulders
	    var numberOfStarterBoulders = this.game.rnd.integerInRange(5,20);
	    for (var i = 0; i < numberOfStarterBoulders; i++)
	    {
		    var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
            treeGame.boulders.push( new treeGame.boulder(xRandomVariation, 0));
	    }
    
	    console.log("World generated.");
	    
// 	    this.game.camera.x = levelPlanetState.game.world.width/2;
	    this.game.camera.y = levelPlanetState.game.world.height/2 - treeGame.grounds[0].groundSprite.height/2;
	    
	    treeGame.cursors = this.game.input.keyboard.createCursorKeys();

    },
    
    createUI: function() {
	    		
		var uiAlpha = .90;
		var uiMainButtonsY = window.innerHeight * .02;
		
		treeGame.activeTool = 'setForestGuardianDestination';
		
		// Main Buttons
		this.spawnTreeButton = this.add.button(60, uiMainButtonsY);
		this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
		this.spawnTreeButton.fixedToCamera = true;
		uiGroup.add(this.spawnTreeButton);
		this.spawnTreeButton.alpha = uiAlpha;
		this.spawnTreeButton.events.onInputDown.add(function() {
			
			if (treeGame.activeTool != 'spawnTree')
			{
				treeGame.activeTool = 'spawnTree';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButtonSelected');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
				this.waterButton.loadTexture('textureAtlas', 'waterButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				
				spawnTreeSpeciesGroup.visible = true;
				spawnAnimalSpeciesGroup.visible = false;
			} else {
				treeGame.activeTool = 'setForestGuardianDestination';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
				this.waterButton.loadTexture('textureAtlas', 'waterButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			}
		}, this);
		this.spawnTreeButton.events.onInputUp.add(function() {
			treeGame.uiActive = false;
		}, this);

		this.firstButton = this.spawnTreeButton;
		
/*
		this.spawnAnimalButton = this.add.button(this.firstButton.x + (this.firstButton.width) + 20, (window.innerHeight * .02), 'spawnAnimalButtonImage');
		this.spawnAnimalButton.fixedToCamera = true;
		this.spawnAnimalButton.alpha = uiAlpha;
		this.spawnAnimalButton.events.onInputDown.add(function() {
			if (treeGame.activeTool != 'spawnAnimal')
			{
				treeGame.activeTool = 'spawnAnimal';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('spawnTreeButtonImage');
				this.removeToolButton.loadTexture('absorbLifeButtonImage');
				this.spawnAnimalButton.loadTexture('spawnAnimalButtonSelectedImage');
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = true;
			} else {
				treeGame.activeTool = 'setForestGuardianDestination';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('spawnTreeButtonImage');
				this.removeToolButton.loadTexture('absorbLifeButtonImage');
				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			}
			
		}, this);
		
		this.spawnAnimalButton.events.onInputUp.add(function() {
			treeGame.uiActive = false;
		}, this);
*/
		


		this.removeToolButton = this.add.button(this.firstButton.x + (this.firstButton.width) + 20, uiMainButtonsY, null);
		this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
		this.removeToolButton.fixedToCamera = true;
		this.removeToolButton.alpha = uiAlpha;
		this.removeToolButton.events.onInputDown.add(function() {
			if (treeGame.activeTool != 'removeTool')
			{
				treeGame.activeTool = 'removeTool';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButtonSelected');
				this.waterButton.loadTexture('textureAtlas', 'waterButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			} else {
				treeGame.activeTool = 'setForestGuardianDestination';
				treeGame.uiActive = true;
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
				this.waterButton.loadTexture('textureAtlas', 'waterButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			}
		}, this);
		this.removeToolButton.events.onInputUp.add(function() {
			treeGame.uiActive = false;
		}, this);
		
		
		// Water Tool Button
		this.waterButton = this.add.button(this.firstButton.x + (this.firstButton.width * 2) + 40, uiMainButtonsY);
		this.waterButton.loadTexture('textureAtlas', 'waterButton');
		this.waterButton.fixedToCamera = true;
		uiGroup.add(this.waterButton);
		this.waterButton.alpha = uiAlpha;
		this.waterButton.events.onInputDown.add(function() {
			
			if (treeGame.activeTool != 'water')
			{
				treeGame.activeTool = 'water';
				treeGame.uiActive = true;
				this.waterButton.loadTexture('textureAtlas', 'waterButtonSelected');
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			} else {
				treeGame.activeTool = 'setForestGuardianDestination';
				treeGame.uiActive = true;
				this.waterButton.loadTexture('textureAtlas', 'waterButton');
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			}
		}, this);
		this.waterButton.events.onInputUp.add(function() {
			treeGame.uiActive = false;
		}, this);

		

		
		// Tree Specie Buttons
		
		treeGame.selectedTreeSpawn = 'randomSpecie';
		
		// Draw a line connecting the selected button to the list of species
		var selectedLine = this.game.add.graphics(this.firstButton.x + this.firstButton.width/2, this.firstButton.y + this.firstButton.height -2);
	
	    // set a fill and line style
	    selectedLine.fixedToCamera = true;
	    selectedLine.alpha = uiAlpha;
	    selectedLine.lineStyle(10, 0x634241);
	    selectedLine.moveTo(0,0);
	    selectedLine.lineTo(0, 22);
	    spawnTreeSpeciesGroup.add(selectedLine);
	    spawnTreeSpeciesGroup.visible = false;
	    	    
		this.speciesBackground = this.add.sprite(this.spawnTreeButton.x, this.firstButton.y + this.firstButton.height + 20, 'textureAtlas', 'speciesBackground');
		this.speciesBackground.fixedToCamera = true;
		this.speciesBackground.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.speciesBackground);
				
		this.randomSpeciesButton = this.add.button(this.speciesBackground.x + 80 , this.speciesBackground.y + 12, null);
		this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpeciesSelected');
		this.randomSpeciesButton.fixedToCamera = true;
		this.randomSpeciesButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.randomSpeciesButton);
		this.randomSpeciesButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.randomSpeciesButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'randomSpecie';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpeciesSelected');
			this.oakButton.loadTexture('textureAtlas', 'oakButton');
			this.beechButton.loadTexture('textureAtlas', 'beechButton');
			this.birchButton.loadTexture('textureAtlas', 'birchButton');
			this.pineButton.loadTexture('textureAtlas', 'pineButton');
			this.willowButton.loadTexture('textureAtlas', 'willowButton');
			treeGame.uiActive = false;
		}, this);
		
		this.oakButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width + 100, this.speciesBackground.y + 12, null);
		this.oakButton.loadTexture('textureAtlas', 'oakButton');
		this.oakButton.fixedToCamera = true;
		this.oakButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.oakButton);
		this.oakButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.oakButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'oak';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpecies');
			this.oakButton.loadTexture('textureAtlas', 'oakButtonSelected');
			this.beechButton.loadTexture('textureAtlas', 'beechButton');
			this.birchButton.loadTexture('textureAtlas', 'birchButton');
			this.pineButton.loadTexture('textureAtlas', 'pineButton');
			this.willowButton.loadTexture('textureAtlas', 'willowButton');
			treeGame.uiActive = false;
		}, this);
	    
		this.beechButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width*2 + 120, this.speciesBackground.y + 12, null);
		this.beechButton.loadTexture('textureAtlas', 'beechButton');
		this.beechButton.fixedToCamera = true;
		this.beechButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.beechButton);
		this.beechButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.beechButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'beech';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpecies');
			this.oakButton.loadTexture('textureAtlas', 'oakButton');
			this.beechButton.loadTexture('textureAtlas', 'beechButtonSelected');
			this.birchButton.loadTexture('textureAtlas', 'birchButton');
			this.pineButton.loadTexture('textureAtlas', 'pineButton');
			this.willowButton.loadTexture('textureAtlas', 'willowButton');
			treeGame.uiActive = false;
		}, this);
		
		this.birchButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width*3 + 140, this.speciesBackground.y + 12, null);
		this.birchButton.loadTexture('textureAtlas', 'birchButton');
		this.birchButton.fixedToCamera = true;
		this.birchButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.birchButton);
		this.birchButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.birchButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'birch';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpecies');
			this.oakButton.loadTexture('textureAtlas', 'oakButton');
			this.beechButton.loadTexture('textureAtlas', 'beechButton');
			this.birchButton.loadTexture('textureAtlas', 'birchButtonSelected');
			this.pineButton.loadTexture('textureAtlas', 'pineButton');
			this.willowButton.loadTexture('textureAtlas', 'willowButton');
			treeGame.uiActive = false;
		}, this);
		
		this.pineButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width*4 + 160, this.speciesBackground.y + 12, null);
		this.pineButton.loadTexture('textureAtlas', 'pineButton');
		this.pineButton.fixedToCamera = true;
		this.pineButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.pineButton);
		this.pineButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.pineButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'pine';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpecies');
			this.oakButton.loadTexture('textureAtlas', 'oakButton');
			this.beechButton.loadTexture('textureAtlas', 'beechButton');
			this.birchButton.loadTexture('textureAtlas', 'birchButton');
			this.pineButton.loadTexture('textureAtlas', 'pineButtonSelected');
			this.willowButton.loadTexture('textureAtlas', 'willowButton');
			treeGame.uiActive = false;
		}, this);
		
		this.willowButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width*5 + 180, this.speciesBackground.y + 12, null);
		this.willowButton.loadTexture('textureAtlas', 'willowButton');
		this.willowButton.fixedToCamera = true;
		this.willowButton.alpha = uiAlpha;
		spawnTreeSpeciesGroup.add(this.willowButton);
		this.willowButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.willowButton.events.onInputUp.add(function() {
			treeGame.selectedTreeSpawn = 'willow';
			this.randomSpeciesButton.loadTexture('textureAtlas', 'randomSpecies');
			this.oakButton.loadTexture('textureAtlas', 'oakButton');
			this.beechButton.loadTexture('textureAtlas', 'beechButton');
			this.birchButton.loadTexture('textureAtlas', 'birchButton');
			this.pineButton.loadTexture('textureAtlas', 'pineButton');
			this.willowButton.loadTexture('textureAtlas', 'willowButtonSelected');
			treeGame.uiActive = false;
		}, this);




/*


		// Animal Specie Buttons
		
		treeGame.selectedAnimalSpawn = 'randomSpecie';
		
		// Draw a line connecting the selected button to the list of animal species
		var selectedLineAnimals = this.game.add.graphics(this.firstButton.x + (this.firstButton.width) + (this.firstButton.width/2) + 20 , this.firstButton.y + this.firstButton.height -2);
	
	    // set a fill and line style
	    selectedLineAnimals.fixedToCamera = true;
	    selectedLineAnimals.alpha = uiAlpha;
	    selectedLineAnimals.lineStyle(10, 0x634241);
	    selectedLineAnimals.moveTo(0,0);
	    selectedLineAnimals.lineTo(0, 22);
	    spawnAnimalSpeciesGroup.add(selectedLineAnimals);
	    spawnAnimalSpeciesGroup.visible = false;
	    	    
		this.animalSpeciesBackground = this.add.sprite(this.spawnTreeButton.x, this.firstButton.y + this.firstButton.height + 20, 'speciesBackgroundImage');
		this.animalSpeciesBackground.fixedToCamera = true;
		this.animalSpeciesBackground.alpha = uiAlpha;
		spawnAnimalSpeciesGroup.add(this.animalSpeciesBackground);
				
		this.randomAnimalSpeciesButton = this.add.button(this.speciesBackground.x + 80 , this.speciesBackground.y + 12, 'randomSpeciesButtonSelectedImage');
		this.randomAnimalSpeciesButton.fixedToCamera = true;
		this.randomAnimalSpeciesButton.alpha = uiAlpha;
		spawnAnimalSpeciesGroup.add(this.randomAnimalSpeciesButton);
		this.randomAnimalSpeciesButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.randomAnimalSpeciesButton.events.onInputUp.add(function() {
			treeGame.selectedAnimalSpawn = 'randomSpecie';
			this.randomAnimalSpeciesButton.loadTexture('randomSpeciesButtonSelectedImage');
			this.deerButton.loadTexture('deerButtonImage');
			this.crowButton.loadTexture('crowButtonImage');
			treeGame.uiActive = false;
		}, this);
		
		this.deerButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width + 100, this.speciesBackground.y + 12, 'deerButtonImage');
		this.deerButton.fixedToCamera = true;
		this.deerButton.alpha = uiAlpha;
		spawnAnimalSpeciesGroup.add(this.deerButton);
		this.deerButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.deerButton.events.onInputUp.add(function() {
			treeGame.selectedAnimalSpawn = 'deer';
			this.randomAnimalSpeciesButton.loadTexture('randomSpeciesButtonImage');
			this.deerButton.loadTexture('deerButtonSelectedImage');
			this.crowButton.loadTexture('crowButtonImage');
			treeGame.uiActive = false;
		}, this);
	    
		this.crowButton = this.add.button(this.speciesBackground.x + this.randomSpeciesButton.width*2 + 120, this.speciesBackground.y + 12, 'crowButtonImage');
		this.crowButton.fixedToCamera = true;
		this.crowButton.alpha = uiAlpha;
		spawnAnimalSpeciesGroup.add(this.crowButton);
		this.crowButton.events.onInputDown.add(function() {
			treeGame.uiActive = true;
		}, this);
		this.crowButton.events.onInputUp.add(function() {
			treeGame.selectedAnimalSpawn = 'crow';
			this.randomAnimalSpeciesButton.loadTexture('randomSpeciesButtonImage');
			this.deerButton.loadTexture('deerButtonImage');
			this.crowButton.loadTexture('crowButtonSelectedImage');
			treeGame.uiActive = false;
		}, this);
*/
		
		// Show / Hide UI Button
		this.hideUIButton = this.add.button(this.firstButton.x - 40, (window.innerHeight * .02), null);
		this.hideUIButton.loadTexture('textureAtlas', 'hideUIButton');
		this.hideUIButton.fixedToCamera = true;
		this.hideUIButton.alpha = uiAlpha;

		this.hideUIButton.events.onInputDown.add(function() {
			
			treeGame.uiActive = true;
			
			if (uiAlpha == .75) {
				uiAlpha = 0;
				treeGame.activeTool = 'setForestGuardianDestination';
				this.hideUIButton.loadTexture('textureAtlas', 'showUIButton');
			} else {
				uiAlpha = .75;
				this.hideUIButton.loadTexture('textureAtlas', 'hideUIButton');
				this.spawnTreeButton.loadTexture('textureAtlas', 'spawnTreeButton');
				this.removeToolButton.loadTexture('textureAtlas', 'absorbLifeButton');
// 				this.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
				
				spawnTreeSpeciesGroup.visible = false;
				spawnAnimalSpeciesGroup.visible = false;
			}

// 			spawnTreeButtonTween = levelPlanetState.add.tween(this.spawnTreeButton.alpha).to({uiAlpha}, 5000, Phaser.Easing.Quadratic.InOut, true, 15000, 0, false);
			this.spawnTreeButton.alpha = uiAlpha;
			this.removeToolButton.alpha = uiAlpha;
			this.waterButton.alpha = uiAlpha;
// 			this.spawnAnimalButton.alpha = uiAlpha;		
			this.randomSpeciesButton.alpha = uiAlpha;
			this.oakButton.alpha = uiAlpha;
			this.beechButton.alpha = uiAlpha;
			this.birchButton.alpha = uiAlpha;
			this.pineButton.alpha = uiAlpha;
			this.willowButton.alpha = uiAlpha;
			
// 			this.randomAnimalSpeciesButton.alpha = uiAlpha;
// 			this.deerButton.alpha = uiAlpha;
// 			this.crowButton.alpha = uiAlpha;
			
			selectedLine.alpha = uiAlpha;
// 			selectedLineAnimals.alpha = uiAlpha;
			this.speciesBackground.alpha = uiAlpha;
// 			this.animalSpeciesBackground.alpha = uiAlpha;

			this.soundToggleButton.alpha = uiAlpha;
			this.menuButton.alpha = uiAlpha;
			
			
			
			
			treeGame.objectives[0].objectiveBox.alpha = uiAlpha;
			treeGame.objectives[0].objectiveText.alpha = uiAlpha;
			treeGame.objectives[0].tutorialText.alpha = uiAlpha;
			treeGame.objectives[0].nextButton.alpha = uiAlpha;
			treeGame.objectives[0].closedButton.alpha = uiAlpha;
			
			

			
				
			
		}, this);

		this.hideUIButton.events.onInputUp.add(function() {
			
			treeGame.uiActive = false;
			
		}, this);
		
		
		// Sound Toggle Button
		this.soundToggleButton = this.add.button((window.innerWidth - 100), (window.innerHeight * .02), null,this.toggleMute,this,null,null,null);
		this.soundToggleButton.loadTexture('textureAtlas', 'soundOn');
		this.soundToggleButton.fixedToCamera = true;
		this.soundToggleButton.alpha = .25;
		
		this.soundToggleButton.events.onInputDown.add(function() {
			
			treeGame.uiActive = true;
	
			switch(this.soundToggleButton.frameName)
			{
				case "soundOn":
					this.soundToggleButton.loadTexture('textureAtlas', 'soundOff');
					break;
				case "soundOff":
				    this.soundToggleButton.loadTexture('textureAtlas', 'soundOn');
					break;
			}
								
		}, this);
		
		this.menuButton = this.add.button(((window.innerWidth) - 180), (window.innerHeight * .02), null);
		this.menuButton.loadTexture('textureAtlas', 'menuButton');
		this.menuButton.fixedToCamera = true;
		this.menuButton.alpha = .25;
		this.menuButton.events.onInputUp.add(function() {
	        this.game.state.start("TitleMenu");
		}, this);
		
		
		// Create a message for being out of energy
	    var x = (window.innerWidth * .5);
	    var y = (window.innerHeight * .5);

	    var message = "You have run out of energy.";
		
		this.outOfEnergyText = this.add.text(x, y, message, this.fontStyle);
		this.outOfEnergyText.x = (x - (this.outOfEnergyText.width/2));	    
	    this.outOfEnergyText.lineSpacing = -10;
		this.outOfEnergyText.anchor.setTo(0.0, 0.0);
		this.outOfEnergyText.align = 'left';
		this.outOfEnergyText.alpha = 0;
	    this.outOfEnergyText.fill = '#EBDDA1';
	    this.outOfEnergyText.addFontStyle('italic', 6);
	    this.outOfEnergyText.font = 'Palatino';
	    this.outOfEnergyText.fontSize = 23;
	    this.outOfEnergyText.fixedToCamera = true;
		
		if (this.game.selectedLevel <= 4)
		{
			treeGame.objectives.push( new treeGame.objective(this.game.selectedLevel));
		}
		
		
		
		
    },
    
    createMessageBox: function(){
		
		// Tutorial Message Box
/*
		this.messageBoxSprite = this.add.sprite((window.innerWidth*.5), (window.innerHeight-120), null);
		this.messageBoxSprite.loadTexture('textureAtlas', 'messageWindow');
*/

			
		
	},
    
	mouseClick: function()
	{	
		
		if (treeGame.uiActive == false)
		{
			
			// Spawn Tree Tool
			if (treeGame.activeTool == 'spawnTree')
			{
				if (treeGame.forestGuardians[0].energy >= 25)
				{
					treeGame.forestGuardians[0].energy -= 25;
					
					if (treeGame.selectedTreeSpawn == 'randomSpecie')
					{
						var treeSpecieSpawn = treeGame.specieOfTree[Math.floor(Math.random() * treeGame.specieOfTree.length)];					
						
					} else 
					{
						var treeSpecieSpawn = treeGame.selectedTreeSpawn;
					} 
					
					// Forest Guardian Casting Animation
					switch(treeGame.forestGuardians[0].currentAction)
					{
						case "resting":
							treeGame.forestGuardians[0].currentAction = "casting";
							break;
						case "walking":
							treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
							break;
							
					}

					treeGame.forestGuardians[0].casting = true;
					var summoningSound = this.game.add.audio('summonSound', .25, false);
			        summoningSound.play();
								
					treeGame.trees.push( new treeGame.tree(treeSpecieSpawn, false, null, null));
			
					treeGame.birchBarkBits.forEach(function (birchBarkBit)
					{
						if (birchBarkBit.belongsToTree == treeGame.trees.length - 1)
						{
							treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(birchBarkBit.birchBarkBitSprite);
						}
					});
			
					treeGame.leaves.forEach(function (leaf)
					{
						if (leaf.belongsToTree == treeGame.trees.length - 1)
						{
							treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(leaf.leafSprite);
						}
					});
					
					treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed)
					{
						if (spawnZoneSeed.belongsToTree == treeGame.trees.length - 1)
						{
							treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(spawnZoneSeed.spawnZoneSeedVicinity);
							spawnZoneSeed.spawnZoneSeedVicinity.body.x += treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.x;
						    spawnZoneSeed.spawnZoneSeedVicinity.body.y += treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.y + treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.height/2;
						    
						}
					});
					
					treeGame.spawnZoneTreeShades.forEach(function (spawnZoneTreeShade)
					{
						if (spawnZoneTreeShade.belongsToTree == treeGame.trees.length - 1)
						{
							treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(spawnZoneTreeShade.spawnZoneTreeShadeVicinity);
							treeGame.trees[treeGame.trees.length - 1].treeSprite.body.spawnZoneTreeShade = spawnZoneTreeShade.spawnZoneTreeShadeVicinity;
						}
					});
				} else {
					// Player tried to spawn a tree, but doesn't have enough energy.
					levelPlanetState.showEnergyWarning();
				}
			}
			// Spawn Animal Tool
			if (treeGame.activeTool == 'spawnAnimal')
			{
				if (treeGame.forestGuardians[0].energy >= 25)
				{
					treeGame.forestGuardians[0].energy -= 25;
					
					if (treeGame.selectedAnimalSpawn == 'randomSpecie')
					{
						var animalSpecieSpawn = treeGame.specieOfAnimal[Math.floor(Math.random() * treeGame.specieOfAnimal.length)];
						if (animalSpecieSpawn == 'deer')
						{
							treeGame.deers.push( new treeGame.deer(levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, this.game.world.height/2 + 120));
						}
						if (animalSpecieSpawn == 'crow')
						{
							treeGame.crows.push( new treeGame.crow(levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, this.game.world.height/2 + 120));
						}
						
					} else if (treeGame.selectedAnimalSpawn == 'deer')
					{
						// Create Deer
						treeGame.deers.push( new treeGame.deer(levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, this.game.world.height/2 + 120));
					} else if (treeGame.selectedAnimalSpawn == 'crow')
					{
						treeGame.crows.push( new treeGame.crow(levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, this.game.world.height/2 + 120));
					}
	
					switch(treeGame.forestGuardians[0].currentAction)
					{
						case "resting":
							treeGame.forestGuardians[0].currentAction = "casting";
							break;
						case "walking":
							treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
							break;
							
					}

					treeGame.forestGuardians[0].casting = true;
					var summoningSound = this.game.add.audio('summonSound', 1, false);
			        summoningSound.play();
				}
			}
			
			// Guardian of the Forest Destination Tool
			if (treeGame.activeTool == 'setForestGuardianDestination')
			{
/*
				if (treeGame.forestGuardians[0].energy > 0)
				{
*/
				
					var tweenFadeInDestinationMarker = levelPlanetState.add.tween(treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
					if (this.game.selectedLevel > 4)
					{
						treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body.angle = treeGame.forestGuardians[0].forestGuardianSprite.body.angle;
					}
					treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body.x = levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x;
					treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body.y = levelPlanetState.game.input.activePointer.y + levelPlanetState.game.camera.y;
					treeGame.forestGuardianDestinations[0].forestGuardianDestinationSprite.body.collides([forestGuardianCollision]);
					if (levelPlanetState.game.particleEffectsToggle == true)
					{
						treeGame.forestGuardianDestinations[0].spiralEmitter.x = levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x;
						treeGame.forestGuardianDestinations[0].spiralEmitter.y = treeGame.forestGuardians[0].forestGuardianSprite.y;
						var tweenFadeInEmitter = levelPlanetState.add.tween(treeGame.forestGuardianDestinations[0].spiralEmitter).to({alpha:1}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
					}
/*
				} else {
					// Player tried to move, but doesn't have enough energy.
					levelPlanetState.showEnergyWarning();
				}
*/
				

				
			}
	
	        // Water Tool
	        if (treeGame.activeTool == 'water')
			{
				if (treeGame.forestGuardians[0].energy >= 10)
				{
					treeGame.forestGuardians[0].energy -= 10;
	                treeGame.rains.push( new treeGame.rain(
	                    levelPlanetState.game.input.activePointer.x + levelPlanetState.game.camera.x, 
	                    treeGame.forestGuardians[0].forestGuardianSprite.y - 300,
	                    treeGame.rains.length
	                ));
	                
	                
	                // Forest Guardian Casting Animation
					switch(treeGame.forestGuardians[0].currentAction)
					{
						case "resting":
							treeGame.forestGuardians[0].currentAction = "casting";
							break;
						case "walking":
							treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
							break;
							
					}

					treeGame.forestGuardians[0].casting = true;
					var summoningSound = this.game.add.audio('summonSound', .25, false);
			        summoningSound.play();
	                
	                
	                
	            } else {
					// Player tried to spawn a rain cloud, but doesn't have enough energy.
					levelPlanetState.showEnergyWarning();
				}
	        }
	    
		}  // End check for UI being active


		
	},
	
    deactivateButtons: function() {
	    		    
		    treeGame.activeTool = "setForestGuardianDestination";
			levelPlanetState.spawnTreeButton.loadTexture('spawnTreeButtonImage');
			levelPlanetState.removeToolButton.loadTexture('absorbLifeButtonImage');
// 			levelPlanetState.spawnAnimalButton.loadTexture('spawnAnimalButtonImage');
			spawnTreeSpeciesGroup.visible = false;
			spawnAnimalSpeciesGroup.visible = false;
	    
    },
    
    toggleMute: function() {
	    		    
		    switch(levelPlanetState.soundToggleButton.frameName) 
		    {
			    case "soundOff":
				    levelPlanetState.sound.mute = true;
				    break;
				case "soundOn":
					levelPlanetState.sound.mute = false;
					break;
		    }
		    
		    treeGame.uiActive = false;
	    
    },
	
	createTreeCrown: function(x, y, segments, segmentWidth, branchLevel, treeBitmap, treeSprite, specieOfTree)
	{
		// Get the canvas drawing context for the treeBitmap
	    var ctx = treeBitmap.context;
	    var width = treeBitmap.width;
	    var height = treeBitmap.height;
	
	    // Our tree will be made up of several line segments starting at
	    // the center of the bottom edge of the bitmap and ending at the top edge
	    // of the bitmap.
		
	    // Draw each of the segments
	    for(var i = 0; i < segments; i++) {
	        // Set the tree color and width
	        ctx.strokeStyle = 'rgb(108, 89, 51)';
	        
	        if (specieOfTree == 'birch')
	        {
		        ctx.strokeStyle = 'rgb(208, 223, 215)';
	        }
	        
	        ctx.lineWidth = segmentWidth;
	        segmentWidth -= 1;
	
	        ctx.beginPath();
	        ctx.moveTo(x, y);
	
	        // Calculate an x offset from the end of the last line segment and
	        // keep it within the bounds of the bitmap
	        if (branchLevel != 0) {
	            // For a branch
	            x += this.game.rnd.integerInRange(-40, 40);
	        } else {
	            // For the main trunk
	            if (specieOfTree == 'pine')
		        {
			        x += this.game.rnd.integerInRange(-5, 5);
		        } else {
			        // For branches
			        if (specieOfTree == 'pine')
			        {
				        x += this.game.rnd.integerInRange(-10, 10 - i);
			        } else {
					    x += this.game.rnd.integerInRange(-15, 15);
			        }
		        }
	        }
	        if (x <= 10) x = 10;
	        if (x >= width-10) x = width-10;
	
	        // Calculate a y offset from the end of the last line segment.
	        // When we've reached the ground or there are no more segments left,
	        // set the y position to the height of the bitmap. For branches, we
	        // don't care if they reach the ground so don't set the last coordinate
	        // to the ground if it's hanging in the air.
	        if (branchLevel != 0) {
	            // For a branch
	            if (specieOfTree == 'pine')
		        {
			        y -= this.game.rnd.integerInRange(0, 5);
		        } else {
			        y -= this.game.rnd.integerInRange(0, 20);
		        }
	        } else if (branchLevel == 0) {
	            // For the main trunk
	            y -= this.game.rnd.integerInRange(20, 40);
	        }
	        if (((branchLevel == 0) && i == segments - 1) || y < 0) {
	            y = 0;
	        }
	
	        // Draw the line segment
	        ctx.lineTo(x, y);
	        ctx.stroke();
	        
	        // Find the angle between the previous point and the current one
	        var p1x = x;
	        var p1y = y;
	        if (p2x)
	        {
		       // angle in degrees
				var angleDeg = Math.atan2(p2y - p1y, p2x - p1x) * 180 / Math.PI;
			
			
				// Place the black bits on birch trunks
				if (branchLevel == 0)
				{
					if (specieOfTree == 'birch')
					{
						if (Phaser.Utils.chanceRoll(50)) {
			                treeGame.birchBarkBits.push(currentBirchBarkBit = new treeGame.birchBarkBit(treeGame.birchBarkBits.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2, 0));
			            }
					}
				}
			
			
				// Create leaves and seed spawners
				if (branchLevel != 0)
				{
					var currentTree = treeGame.trees.length - 1;
					var currentLeaf = null;
					var currentSpawnZoneSeed = null;
					
					if (this.game.leafDensityToggle == "low")
					{
						if (Phaser.Utils.chanceRoll(15)) {
		                treeGame.spawnZoneSeeds.push(currentSpawnZoneSeed = new treeGame.spawnZoneSeed(treeGame.spawnZoneSeedsCounter, x - treeBitmap.width/2, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
						
						if (Phaser.Utils.chanceRoll(5)) {
			                treeGame.leaves.push(currentLeaf = new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(2.5)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2 + 20, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(2.5)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2 - 20, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(2.5)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2 + 20, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(2.5)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2 - 20, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
		                }
					} else
					{
						if (Phaser.Utils.chanceRoll(50)) {
		                treeGame.spawnZoneSeeds.push(currentSpawnZoneSeed = new treeGame.spawnZoneSeed(treeGame.spawnZoneSeedsCounter, x - treeBitmap.width/2, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
						
						if (Phaser.Utils.chanceRoll(25)) {
			                treeGame.leaves.push(currentLeaf = new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(25)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2 + 20, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(25)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2, y - treeBitmap.height/2 - 20, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(25)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2 + 20, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
			            }
			            
			            if (Phaser.Utils.chanceRoll(25)) {
			                treeGame.leaves.push( new treeGame.leaf(treeGame.leaves.total + 1, x - treeBitmap.width/2 - 20, y - treeBitmap.height/2, angleDeg + 180, .75, specieOfTree));
		                }
					}
					
					
		            

				}
				
				
				
				
	        }
	        var p2x = x;
	        var p2y = y;
			
	        // Quit when we've reached the ground
	        if (y <= 0) break;
	
	        // Draw a branch 20% of the time off the main trunk only
	        if (branchLevel == 0) {
		        if (specieOfTree == 'pine')
		        {
			        if (Phaser.Utils.chanceRoll(75)) {
				        // Draws another, thinner, branch starting from this position
			            this.createTreeCrown(x, y, 10, 10, 1, treeBitmap, treeSprite, specieOfTree);
			        }   
		        } else 
		        {
			        if (Phaser.Utils.chanceRoll(25)) {
		                // Draws another, thinner, branch starting from this position
		                this.createTreeCrown(x, y, 20, 10, 1, treeBitmap, treeSprite, specieOfTree);
		            }
			        
		        }
		        
	            
	        } else if (branchLevel == 1) {
		        if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createTreeCrown(x, y, 10, 5, 2, treeBitmap, treeSprite, specieOfTree);
	            }
	        }
	    }
	
	    // This just tells the engine it should update the texture cache
	    treeBitmap.dirty = true;
	},
	
	
	
	
	createTreeRoots: function(x, y, segments, segmentWidth, branchLevel, treeRootBitmap, treeSpriteY)
	{
		// Get the canvas drawing context for the treeRootBitmap
	    var ctx = treeRootBitmap.context;
	    var width = treeRootBitmap.width;
	    var height = treeRootBitmap.height;
	
	    // Our tree will be made up of several line segments starting at
	    // the center of the bottom edge of the bitmap and moving down.
		
	    // Draw each of the segments
	    for(var i = 0; i < segments; i++) {
	        // Set the tree color and width
	        ctx.strokeStyle = 'rgb(162, 135, 86)';
	        ctx.lineWidth = segmentWidth;
	        segmentWidth -= 1;
	
	        ctx.beginPath();
	        ctx.moveTo(x, y);
	
	        // Calculate an x offset from the end of the last line segment and
	        // keep it within the bounds of the bitmap
	        if (branchLevel != 0) {
	            // For a branch
	            x += this.game.rnd.integerInRange(-80, 80);
	        } else {
	            // For the main branch
	            x += this.game.rnd.integerInRange(-35, 35);
	        }
	        if (x <= 10) x = 10;
	        if (x >= width-10) x = width-10;
	
	        // Calculate a y offset from the end of the last line segment.
	        // When we've reached the ground or there are no more segments left,
	        // set the y position to the height of the bitmap. For branches, we
	        // don't care if they reach the ground so don't set the last coordinate
	        // to the ground if it's hanging in the air.
	        if (branchLevel != 0) {
	            // For a branch
	            y += this.game.rnd.integerInRange(0, 20);
	        } else {
	            // For the main trunk
	            y += this.game.rnd.integerInRange(20, height/segments);
	        }
	        if (((branchLevel == 0) && i == segments - 1) || y > height) {
	            y = height;
	        }
	
	        // Draw the line segment
	        ctx.lineTo(x, y);
	        ctx.stroke();
	        
	        // Find the angle between the previous point and the current one
	        var p1x = x;
	        var p1y = y;
	        if (p2x)
	        {
		       // angle in degrees
				var angleDeg = Math.atan2(p2y - p1y, p2x - p1x) * 180 / Math.PI;
				
				// I will place root sprites here using the angle of angleDeg
	        }
	        var p2x = x;
	        var p2y = y;
			
	        // Quit when we've reached the ground
	        if (y >= height) break;
	
	        // Draw a branch 20% of the time off the main trunk only
	        if (branchLevel == 0) {
	            if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createTreeRoots(x, y, 10, 5, 1, treeRootBitmap, treeGame.treeSpriteY);
	            }
	        } else if (branchLevel == 1) {
		        if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createTreeRoots(x, y, 10, 5, 2, treeRootBitmap, treeGame.treeSpriteY);
	            }
	        }
	    }
	
	    // This just tells the engine it should update the texture cache
	    treeRootBitmap.dirty = true;
	},

	createPlantRoots: function(x, y, segments, segmentWidth, branchLevel, plantRootBitmap, plantSpriteY)
	{
		// Get the canvas drawing context for the treeRootBitmap
	    var ctx = plantRootBitmap.context;
	    var width = plantRootBitmap.width;
	    var height = plantRootBitmap.height;
	
	    // Our tree will be made up of several line segments starting at
	    // the center of the bottom edge of the bitmap and moving down.
		
	    // Draw each of the segments
	    for(var i = 0; i < segments; i++) {
	        // Set the tree color and width
	        ctx.strokeStyle = 'rgb(162, 135, 86)';
	        ctx.lineWidth = segmentWidth;
	        segmentWidth -= 1;
	
	        ctx.beginPath();
	        ctx.moveTo(x, y);
	
	        // Calculate an x offset from the end of the last line segment and
	        // keep it within the bounds of the bitmap
	        if (branchLevel != 0) {
	            // For a branch
	            x += this.game.rnd.integerInRange(-80, 80);
	        } else {
	            // For the main branch
	            x += this.game.rnd.integerInRange(-35, 35);
	        }
	        if (x <= 10) x = 10;
	        if (x >= width-10) x = width-10;
	
	        // Calculate a y offset from the end of the last line segment.
	        // When we've reached the ground or there are no more segments left,
	        // set the y position to the height of the bitmap. For branches, we
	        // don't care if they reach the ground so don't set the last coordinate
	        // to the ground if it's hanging in the air.
	        if (branchLevel != 0) {
	            // For a branch
	            y += this.game.rnd.integerInRange(0, 20);
	        } else {
	            // For the main trunk
	            y += this.game.rnd.integerInRange(20, height/segments);
	        }
	        if (((branchLevel == 0) && i == segments - 1) || y > height) {
	            y = height;
	        }
	
	        // Draw the line segment
	        ctx.lineTo(x, y);
	        ctx.stroke();
	        
	        // Find the angle between the previous point and the current one
	        var p1x = x;
	        var p1y = y;
	        if (p2x)
	        {
		       // angle in degrees
				var angleDeg = Math.atan2(p2y - p1y, p2x - p1x) * 180 / Math.PI;
				
				// I will place root sprites here using the angle of angleDeg
	        }
	        var p2x = x;
	        var p2y = y;
			
	        // Quit when we've reached the ground
	        if (y >= height) break;
	
	        // Draw a branch 20% of the time off the main trunk only
	        if (branchLevel == 0) {
	            if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createPlantRoots(x, y, 10, 2, 1, plantRootBitmap, treeGame.plantSpriteY);
	            }
	        } else if (branchLevel == 1) {
		        if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createPlantRoots(x, y, 10, 1, 2, plantRootBitmap, treeGame.plantSpriteY);
	            }
	        }
	    }
	
	    // This just tells the engine it should update the texture cache
	    plantRootBitmap.dirty = true;
	},

	
	createMycelium: function(x, y, segments, segmentWidth, branchLevel, myceliumBitmap, myceliumSpriteY)
	{
		// Get the canvas drawing context for the treeRootBitmap
	    var ctx = myceliumBitmap.context;
	    var width = myceliumBitmap.width;
	    var height = myceliumBitmap.height;
	
	    // Our tree will be made up of several line segments starting at
	    // the center of the bottom edge of the bitmap and moving down.
		
	    // Draw each of the segments
	    for(var i = 0; i < segments; i++) {
	        // Set the tree color and width
	        ctx.strokeStyle = 'rgb(208, 223, 215)';
	        ctx.lineWidth = segmentWidth;
	        segmentWidth -= 1;
	
	        ctx.beginPath();
	        ctx.moveTo(x, y);
	
	        // Calculate an x offset from the end of the last line segment and
	        // keep it within the bounds of the bitmap
	        if (branchLevel != 0) {
	            // For a branch
	            x += this.game.rnd.integerInRange(-30, 30);
	        } else {
	            // For the main branch
	            x += this.game.rnd.integerInRange(-35, 35);
	        }
	        if (x <= 10) x = 10;
	        if (x >= width-10) x = width-10;
	
	        // Calculate a y offset from the end of the last line segment.
	        // When we've reached the ground or there are no more segments left,
	        // set the y position to the height of the bitmap. For branches, we
	        // don't care if they reach the ground so don't set the last coordinate
	        // to the ground if it's hanging in the air.
	        if (branchLevel != 0) {
	            // For a branch
	            y += this.game.rnd.integerInRange(0, 20);
	        } else {
	            // For the main trunk
	            y += this.game.rnd.integerInRange(20, height/segments);
	        }
	        if (((branchLevel == 0) && i == segments - 1) || y > height) {
	            y = height;
	        }
	
	        // Draw the line segment
	        ctx.lineTo(x, y);
	        ctx.stroke();
	        
	        // Find the angle between the previous point and the current one
	        var p1x = x;
	        var p1y = y;
	        if (p2x)
	        {
		       // angle in degrees
				var angleDeg = Math.atan2(p2y - p1y, p2x - p1x) * 180 / Math.PI;
				
				// I will place root sprites here using the angle of angleDeg
	        }
	        var p2x = x;
	        var p2y = y;
			
	        // Quit when we've reached the ground
	        if (y >= height) break;
	
	        // Draw a branch 20% of the time off the main trunk only
	        if (branchLevel == 0) {
	            if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createMycelium(x, y, 10, 3, 1, myceliumBitmap, myceliumSpriteY);
	            }
	        } else if (branchLevel == 1) {
		        if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createMycelium(x, y, 10, 3, 2, myceliumBitmap, myceliumSpriteY);
	            }
	        }
	    }
	
	    // This just tells the engine it should update the texture cache
	    myceliumBitmap.dirty = true;
	},
	
	createLightning: function(x, y, segments, segmentWidth, branchLevel, lightningBitmap, lightningSpriteY)
	{
		// Get the canvas drawing context for the treeRootBitmap
	    var ctx = lightningBitmap.context;
	    var width = lightningBitmap.width;
	    var height = lightningBitmap.height;
	
	    // Our tree will be made up of several line segments starting at
	    // the center of the bottom edge of the bitmap and moving down.
		
	    // Draw each of the segments
	    for(var i = 0; i < segments; i++) {
	        // Set the tree color and width
	        ctx.strokeStyle = 'rgb(208, 223, 215)';
	        ctx.shadowColor = '#bf9a8b';
			ctx.shadowBlur = 40;
			ctx.lineWidth = segmentWidth;
	        segmentWidth -= 1;
	
	        ctx.beginPath();
	        ctx.moveTo(x, y);
	
	        // Calculate an x offset from the end of the last line segment and
	        // keep it within the bounds of the bitmap
	        if (branchLevel != 0) {
	            // For a branch
	            x += this.game.rnd.integerInRange(-30, 30);
	        } else {
	            // For the main branch
	            x += this.game.rnd.integerInRange(-35, 35);
	        }
	        if (x <= 10) x = 10;
	        if (x >= width-10) x = width-10;
	
	        // Calculate a y offset from the end of the last line segment.
	        // When we've reached the ground or there are no more segments left,
	        // set the y position to the height of the bitmap. For branches, we
	        // don't care if they reach the ground so don't set the last coordinate
	        // to the ground if it's hanging in the air.
	        if (branchLevel != 0) {
	            // For a branch
	            y += this.game.rnd.integerInRange(0, 20);
	        } else {
	            // For the main trunk
	            y += this.game.rnd.integerInRange(20, height/segments);
	        }
	        if (((branchLevel == 0) && i == segments - 1) || y > height) {
	            y = height;
	        }
	
	        // Draw the line segment
	        ctx.lineTo(x, y);
	        ctx.stroke();
	        
	        // Find the angle between the previous point and the current one
	        var p1x = x;
	        var p1y = y;
	        if (p2x)
	        {
		       // angle in degrees
				var angleDeg = Math.atan2(p2y - p1y, p2x - p1x) * 180 / Math.PI;
				
				// I will place root sprites here using the angle of angleDeg
	        }
	        var p2x = x;
	        var p2y = y;
			
	        // Quit when we've reached the ground
	        if (y >= height) break;
	
	        // Draw a branch 20% of the time off the main trunk only
	        if (branchLevel == 0) {
	            if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createLightning(x, y, 10, 5, 1, lightningBitmap, treeGame.lightningSpriteY);
	            }
	        } else if (branchLevel == 1) {
		        if (Phaser.Utils.chanceRoll(50)) {
	                // Draws another, thinner, branch starting from this position
	                this.createLightning(x, y, 10, 5, 2, lightningBitmap, treeGame.lightningSpriteY);
	            }
	        }
	    }
	
	    // This just tells the engine it should update the texture cache
	    lightningBitmap.dirty = true;
	},

	
	spawnZoneTreeShadeCreate: function(spawnZoneTreeShade) 
	{
		
/*
	    for (var i = 0; i < 2; i++)
	    {                
            var randomValueX = this.rnd.integerInRange(-400, 400);
		    var x = spawnZoneTreeShade.x + randomValueX;
		    var y = spawnZoneTreeShade.y + randomValueX;
		    treeGame.fungi.push( new treeGame.fungus(treeGame.fungi.total + 1, x, y));
	    } 
*/

	},
	
    treeHitGround: function(tree, ground) {
	    
	    if (tree.sprite.spawnedFromSeed == true)
	    {
		    var treeScaleInTween = levelPlanetState.add.tween(tree.sprite.scale).to({x:1,y:1}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
	    } else
	    {
		    // Play Sound
		    var randomTreeFallSound = levelPlanetState.rnd.integerInRange(0,5);
		    
		    switch(randomTreeFallSound)
		    {
			    case 0:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound1', .5, false);
			        break;
			    case 1:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound2', .5, false);
			        break;
			    case 2:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound3', .5, false);
			        break;
			    case 3:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound4', .5, false);
			        break;
			    case 4:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound5', .5, false);
			        break;
			    case 5:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound6', .5, false);
			        break;
			    default:
			        var treeFallSound = levelPlanetState.add.audio('treeFallSound1', .5, false);
			        break;
		    }
			
	        treeFallSound.play();
		    
		    levelPlanetState.game.cameraShake.shake();
		    
/*
		    if (levelPlanetState.game.particleEffectsToggle == true)
		    {
*/
			    // Emit dust particles
			    var dirtDustEmitter = levelPlanetState.add.emitter(tree.x, tree.y + (tree.height/2), 5);
			    dirtDustEmitter.makeParticles("textureAtlas", ['dirtDust1','dirtDust2','dirtDust3','dirtDust4']);
				dirtDustEmitter.setRotation(0, 360);
				dirtDustEmitter.setAlpha(0.25, null, 2000);
				dirtDustEmitter.setScale(1, 0.5, 1, 0.5, 3000, Phaser.Easing.Quintic.Out);
				dirtDustEmitter.gravity = -150;
				dirtDustEmitter.start(true, 500, null, 5);	
// 		    }
		    
		    
	    }
	    
	    treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed)
		{
			if (spawnZoneSeed.belongsToTree == tree.index && spawnZoneSeed.spawnZoneSeedVicinity.body != null)
			{
				spawnZoneSeed.spawnZoneSeedVicinity.body.static = true;
				spawnZoneSeed.spawnZoneSeedVicinity.body.angularVelocity = 0;
				spawnZoneSeed.spawnZoneSeedVicinity.body.velocity.mx = 0;
				spawnZoneSeed.spawnZoneSeedVicinity.body.velocity.my = 0;
			    
			    if (spawnZoneSeed.onFire == false && spawnZoneSeed.hitGround == false)
			    {
				    spawnZoneSeed.hitGround = true;
/*
				    if (Phaser.Utils.chanceRoll(10)) {
					    treeGame.fires.push(new treeGame.fire(
					        spawnZoneSeed.spawnZoneSeedVicinity.body.x, 
					        spawnZoneSeed.spawnZoneSeedVicinity.body.y, 
					        spawnZoneSeed.index
					    ));
					    spawnZoneSeed.onFire = true;
				    }
*/
			    }
			}
		});
	    
	    levelPlanetState.time.events.add(500, function()
	    {
	    
		    if (tree.removed == false && tree.dead == false)
		    {		
				
			    levelPlanetState.game.cameraShake.shake();
			    tree.sprite.treeWiggleTween = levelPlanetState.add.tween(tree).to({angle: '+2'}, 750, Phaser.Easing.Quadratic.InOut, true, 750, -1, true);
			    
			    if (levelPlanetState.game.particleEffectsToggle == true)
			    {
					// Emit dust particles
				    var dirtDustEmitter = levelPlanetState.add.emitter(tree.x, tree.y + (tree.height/2), 5);
				    dirtDustEmitter.makeParticles("textureAtlas", ['dirtDust1','dirtDust2','dirtDust3','dirtDust4']);
					dirtDustEmitter.setRotation(0, 360);
					dirtDustEmitter.setAlpha(0.25, null, 2000);
					dirtDustEmitter.setScale(1, 0.5, 1, 0.5, 3000, Phaser.Easing.Quintic.Out);
					dirtDustEmitter.gravity = -150;
					dirtDustEmitter.start(true, 500, null, 5);			    
				    	    
				}	 
			
			    // Stick tree to the ground.
			    tree.static = true;
				tree.angularVelocity = 0;
				tree.velocity.mx = 0;
				tree.velocity.my = 0;	   
				
				// Give the tree a lifespan
				var timeUntilDeath = null;
			    switch (treeGame.trees[tree.index].specieOfTree)
			    {
				    case "birch":
					    timeUntilDeath = 20000;
					    break;
				    case "pine":
					    timeUntilDeath = 50000;
					    break;
					case "beech":
					    timeUntilDeath = 50000;
					    break;
				    default:
					    timeUntilDeath = 30000;
					    break;
			    }
				
				levelPlanetState.time.events.add(timeUntilDeath, function()
			    {
				    levelPlanetState.treeDied(tree);					    
			    }, this);
				    
		    }
		 }, this);    
    },
    
    seedHitGround: function(seed, ground) {
	    
		// Play Sound
	    var randomSeedFallSound = levelPlanetState.rnd.integerInRange(0,1);
	    
	    switch(randomSeedFallSound)
	    {
		    case 0:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
		    case 1:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound2', .5, false);
		        break;
		    default:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
	    }
		
        seedFallSound.play();	    
	    
	    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
			
		    if (seed.removed == false)
		    {
			    seed.static = true;
				seed.angularVelocity = 0;
				seed.velocity.mx = 0;
				seed.velocity.my = 0;	
				
				// Seed germinates in a few seconds after going static
				levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
					
					// Give the tree a lifespan
					var likelihoodOfGermination = null;
				    switch (seed.specieOfTree)
				    {
					    case "birch":
						    likelihoodOfGermination = 62.5;
						    break;
					    default:
						    likelihoodOfGermination = 25;
						    break;
				    }
					
/*
					// decrease the chance of successful germination the more trees exist in the world to prevent population explosions
					if (Phaser.Utils.chanceRoll(20 - treeGame.trees.length)) {
*/
						
					if (Phaser.Utils.chanceRoll(likelihoodOfGermination)) {
						
						// Spawn a tree from the seed	
						treeGame.trees.push( new treeGame.tree(seed.specieOfTree, true, seed.x, seed.y));
						
						// Set children of the new tree.
						treeGame.birchBarkBits.forEach(function (birchBarkBit)
						{
							if (birchBarkBit.belongsToTree == treeGame.trees.length - 1)
							{
								treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(birchBarkBit.birchBarkBitSprite);
							}
						});
				
						treeGame.leaves.forEach(function (leaf)
						{
							if (leaf.belongsToTree == treeGame.trees.length - 1)
							{
								treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(leaf.leafSprite);
							}
						});
						
						treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed)
						{
							if (spawnZoneSeed.belongsToTree == treeGame.trees.length - 1)
							{
								treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(spawnZoneSeed.spawnZoneSeedVicinity);
								spawnZoneSeed.spawnZoneSeedVicinity.body.x += treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.x;
							    spawnZoneSeed.spawnZoneSeedVicinity.body.y += treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.y + treeGame.trees[spawnZoneSeed.belongsToTree].treeSprite.height/2;
							    
							}
						});
						
						treeGame.spawnZoneTreeShades.forEach(function (spawnZoneTreeShade)
						{
							if (spawnZoneTreeShade.belongsToTree == treeGame.trees.length - 1)
							{
								treeGame.trees[treeGame.trees.length - 1].treeSprite.addChild(spawnZoneTreeShade.spawnZoneTreeShadeVicinity);
								treeGame.trees[treeGame.trees.length - 1].treeSprite.body.spawnZoneTreeShade = spawnZoneTreeShade.spawnZoneTreeShadeVicinity;
							}
						});

		            }
					
					
					
					
					
					
					
					
					
							
				
				}, this);
						
		    }
			
		}, this);
		

    },

    eggHitGround: function(egg, ground) {
	    
		// Play Sound
	    var randomSeedFallSound = levelPlanetState.rnd.integerInRange(0,1);
	    
	    switch(randomSeedFallSound)
	    {
		    case 0:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
		    case 1:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound2', .5, false);
		        break;
		    default:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
	    }
		
        seedFallSound.play();	    
	    
	    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
			
/*
		    if (egg.removed == false)
		    {
				
*/
				// Egg hatches in a few seconds
				levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
								
								
					// Play Sound
				    var randomEggCrackSound = levelPlanetState.rnd.integerInRange(0,2);
				    
				    switch(randomEggCrackSound)
				    {
					    case 0:
					        var eggCrackSound = levelPlanetState.add.audio('eggCrackingSound1', .5, false);
					        break;
					    case 1:
					        var eggCrackSound = levelPlanetState.add.audio('eggCrackingSound2', .5, false);
					        break;
					    case 2:
					        var eggCrackSound = levelPlanetState.add.audio('eggCrackingSound3', .5, false);
					        break;
					    default:
					        var eggCrackSound = levelPlanetState.add.audio('eggCrackingSound3', .5, false);
					        break;
				    }
					
			        eggCrackSound.play();	
											
					// Spawn a tree from the seed	
					treeGame.crows.push( new treeGame.crow(egg.x, egg.y));
				    egg.sprite.kill();
						
				}, this);
						
/* 		    } */
			
		}, this);
		

    },
    
    poopHitGround: function(poop, ground) {
	    
		// Play Sound
	    var randomSeedFallSound = levelPlanetState.rnd.integerInRange(0,1);
	    
	    switch(randomSeedFallSound)
	    {
		    case 0:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
		    case 1:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound2', .5, false);
		        break;
		    default:
		        var seedFallSound = levelPlanetState.add.audio('seedFallSound1', .5, false);
		        break;
	    }
		
        seedFallSound.play();	    
	    
	    
	    // Give poop a finite lifespan
	    poopFadeOutTween = levelPlanetState.add.tween(poop.sprite).to({alpha: 0}, 5000, Phaser.Easing.Quadratic.InOut, true, 15000, 0, false);
	    poopFadeOutTween.onComplete.add(function () 
	    { 
		    poop.sprite.kill(); 
		    if (Phaser.Utils.chanceRoll(25)) 
		    {
			    treeGame.fungi.push(new treeGame.fungus(poop.x, poop.y, poop.angle));
		    };
		});	

    },


    fungusHitGround: function(fungus, ground) {
	    
	    if (fungus.removed == false)
	    {
		    fungus.static = true;
			fungus.angularVelocity = 0;
			fungus.velocity.mx = 0;
			fungus.velocity.my = 0;	
// 			treeGame.grounds[0].groundSprite.addChild(fungus.sprite);
			
			fungusScaleInTween = levelPlanetState.add.tween(fungus.sprite.scale).to({x: 1, y: 1}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
			
		    fungusFadeOutTween = levelPlanetState.add.tween(fungus.sprite).to({alpha: 0}, 5000, Phaser.Easing.Quadratic.InOut, true, 15000, 0, false);
		    fungusFadeOutTween.onComplete.add(function () { fungus.sprite.kill() });			
				    
	    }
    },

    plantHitGround: function(plant, ground) {
	    
	    levelPlanetState.time.events.add(500, function()
	    {
	    
		    if (plant.removed == false)
		    {
			    plant.static = true;
				plant.angularVelocity = 0;
				plant.velocity.mx = 0;
				plant.velocity.my = 0;	
				
				plant.y += 7;
							
				var randomScaleVariation = levelPlanetState.rnd.integerInRange(100, 100);
				
				// Make sure it hasn't already been removed from the world
				if (plant.sprite)
				{
					// Scale in plant when it hits ground and has waited a moment
					if (Phaser.Utils.chanceRoll(50)) {
			                plantScaleInTween = levelPlanetState.add.tween(plant.sprite.scale).to({x: randomScaleVariation/100, y: randomScaleVariation/100}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
			        } else {
				        plantScaleInTween = levelPlanetState.add.tween(plant.sprite.scale).to({x: randomScaleVariation/-100, y: randomScaleVariation/100}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
			        }
					
					
				}
					
			
					    
		    }
		}, this);

    },
    
    leafHitGround: function(leaf) {
	    
	    if (leaf.removed == false)
	    {
		    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
			    leaf.removed = true;
			    leafFadeOutTween = levelPlanetState.add.tween(leaf.sprite).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
			    leafFadeOutTween.onComplete.add(function () 
			    {        
				    leaf.sprite.kill();
				    
				    // Chance of a mushroom spawning where the leaf was
					if (Phaser.Utils.chanceRoll(25)) {
					    var x = leaf.x;
					    var y = leaf.y;
					    treeGame.fungi.push(new treeGame.fungus(x, y, leaf.angle));
					    
// 					    console.log("Leaf.x: ", leaf.x, " Leaf.y: ", leaf.y, "Fungus.x: ", treeGame.fungi[treeGame.fungi.length -1].mushroomSprite.x, "Fungus.y: ", treeGame.fungi[treeGame.fungi.length -1].mushroomSprite.y);
					}
				});			    
		    });

	    }
	    
	    
    },
    
    altarHitGround: function(altar, ground) {
	    

		    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 1, function(){
			    altar.static = false;
				altar.angularVelocity = 0;
				altar.velocity.mx = 0;
				altar.velocity.my = 0;	
				if (altar.sprite != null)
				{
					altarScaleInTween = levelPlanetState.add.tween(altar.sprite.scale).to({x: 1, y: 1}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
				}
				
			});	
				    
    },
       
    sacrificeAtAltar: function(human, altar) {
	    
	    // Remove sacrificial item from the human
	    this._spriterGroup.pushCharMap("noSmudgeStick");
	    treeGame.humans[human.index].hasSmudgeStick = false;
	    
	    // The human can no longer collide with altars
	    human.clearCollision();
		human.setCollisionGroup(humanCollision);
	    human.collides([groundCollision, crowCollision, leafCollision, skullCollision]);
	    human.collides([plantCollision], levelPlanetState.humanTouchingPlant, this);
	    
		if (treeGame.humans[human.index].currentAction != "worshipping")
		{
			treeGame.humans[human.index].currentAction = "worshipping";
			
			// play animation by Spriter animation name
			treeGame.humans[human.index]._spriterGroup.playAnimationByName("worship");	
			
			// Add a timer for how long they worship for before walking
			levelPlanetState.time.events.add(Phaser.Timer.SECOND * 5, function()
			{		
	            treeGame.humans[human.index]._spriterGroup.playAnimationByName("walk");
	            treeGame.humans[human.index].currentAction = "walking";
				            
		    }, this);
		        
		}	    
	    
	    // Create a zone for increasing forest guardian energy
	    var energyZoneSprite = levelPlanetState.game.add.sprite(altar.x, altar.y, null);	
			    
	    levelPlanetState.physics.p2.enable(energyZoneSprite, false);
	    energyZoneSprite.body.setRectangle(500,500);
	    altarGroup.add(energyZoneSprite);
	    
	    // Define the collision group
	    energyZoneSprite.body.setCollisionGroup(energyZoneCollision);
	    energyZoneSprite.body.collides([forestGuardianCollision]);
	    energyZoneSprite.body.collides([spawnZoneSeedCollision], levelPlanetState.energyZoneTouchingSpawnZoneSeed, this);
	    
	    energyZoneSprite.body.static = true;
	    energyZoneSprite.body.attendedByForestGuardian = false;
	    
	    if (levelPlanetState.game.particleEffectsToggle == true)
		{
			// Emit smoke
		    var smokeEmitter = levelPlanetState.game.add.emitter(0, 0, 1000);
			smokeEmitter.width = 40;
			smokeEmitter.alpha = .75;
			smokeEmitter.makeParticles("textureAtlas", ['smoke1','smoke2','smoke3','smoke4', 'fire1']);
			smokeEmitter.minParticleScale = .75;
			smokeEmitter.maxParticleScale = 1;
			smokeEmitter.setYSpeed(-300, -400);
			smokeEmitter.setXSpeed(-50, 50);
			smokeEmitter.minRotation = 0;
			smokeEmitter.maxRotation = 100;
			smokeEmitter.start(false, 1000, 50);
			smokeEmitter.alignIn(altar.sprite, Phaser.CENTER, 0, -100);
			altarGroup.add(smokeEmitter);
			levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				if (energyZoneSprite.body.attendedByForestGuardian == true) 
				{
					treeGame.numberOfCeremoniesAttended += 1;
					levelPlanetState.updateObjectiveText();
				}
				smokeEmitter.killAll();
				smokeEmitter.kill();
				energyZoneSprite.body.removeFromWorld();
				energyZoneSprite.kill();
			});
		}
	    
	    
	    
    },
    
    
    
    energyZoneTouchingSpawnZoneSeed: function(energyZone, spawnZoneSeed) {
	    
/*
	    console.log("energyZone is: ", energyZone);
	    console.log("spawnZoneSeed is: ", spawnZoneSeed);
*/
	    
	    if (spawnZoneSeed.onFire == false)
		    {
			    if (Phaser.Utils.chanceRoll(100)) {
				    treeGame.fires.push(new treeGame.fire(
				        spawnZoneSeed.x, 
				        spawnZoneSeed.y, 
				        spawnZoneSeed.index
				    ));
				    spawnZoneSeed.onFire = true;
				    spawnZoneSeed.collides([spawnZoneSeedCollision], levelPlanetState.spawnZoneSeedTouchingSpawnZoneSeed, this);
			    }
		    }

	    	    
    },

    spawnZoneSeedTouchingSpawnZoneSeed: function(spawnZoneSeedOnFire, spawnZoneSeed) {
	    	    
	    if (spawnZoneSeed.onFire == false)
		    {
			    if (Phaser.Utils.chanceRoll(100)) {
				    treeGame.fires.push(new treeGame.fire(
				        spawnZoneSeed.x, 
				        spawnZoneSeed.y, 
				        spawnZoneSeed.index
				    ));
				    spawnZoneSeed.onFire = true;
				    spawnZoneSeed.collides([spawnZoneSeedCollision], levelPlanetState.spawnZoneSeedTouchingSpawnZoneSeed, this);
			    }
		    }

	    	    
    },
    
    spawnZoneSeedTouchingLightning: function(spawnZoneSeed, lightning) {
	    
	    	    
	    if (spawnZoneSeed.onFire == false)
		    {
			    if (Phaser.Utils.chanceRoll(100)) {
				    treeGame.fires.push(new treeGame.fire(
				        spawnZoneSeed.x, 
				        spawnZoneSeed.y, 
				        spawnZoneSeed.index
				    ));
				    spawnZoneSeed.onFire = true;
				    spawnZoneSeed.collides([spawnZoneSeedCollision], levelPlanetState.spawnZoneSeedTouchingSpawnZoneSeed, this);
			    }
		    }

	    	    
    },

    spawnZoneSeedGettingRainedOn: function(spawnZoneSeed, rainVicinity) {
	    
	    
	    spawnZoneSeed.onFire = false;
	    
	    if (spawnZoneSeed.wet == false) 
	    {
		    spawnZoneSeed.wet = true;
		    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){			    
			    spawnZoneSeed.wet = false;
		    });
	    }

	    	    
    },
      
    fireGettingRainedOn: function(rainVicinity, fire) {
	    
	        var indexOfFire = fire.index;
	        	        
			// Remove the fire belonging to each spawnZoneSeed
			treeGame.fires.forEach(function (fire)
			{
				if (fire.index == indexOfFire)
				{
					fire.fireEmitter.on = false;
					levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){			    
					    try 
				        {
					        fire.fireEmitter.destroy();
				            fire.fireSprite.destroy();	
				        } catch(err)
				        {
					        console.log(err.name, err.message);
				        }
				    });
				}
			});	        
	    	
    },
 
     checkIfFireIsTouchingTree: function() {
   
        // Check if fire is touching a tree.
		treeGame.fires.forEach(function (fire) 
		{
			console.log("Testing to see if fire is touching tree.");
            if (fire.fireSprite.body && fire.fireSprite.body.touchingTree == false)
            {
	            console.log("This fire was not touching a tree. It must die.");
	            fire.fireEmitter.kill();
	            fire.fireSprite.kill();
            }
		});	
	},
    
        
    deerTouchingSeed: function(deer, seed) {
    
	    if (seed.removed == false)
	    {
			if (treeGame.deers[deer.index].currentAction == "walking")
			{
				if (treeGame.deers[deer.index].hungry == true)
				{
										    
					treeGame.deers[deer.index].currentAction = "headDown";
				    // play animation by Spriter animation id
			        treeGame.deers[deer.index]._spriterGroup.playAnimationById(3);
			        
			        treeGame.deers[deer.index]._spriterGroup.onFinish.add(function () {
				        treeGame.deers[deer.index].currentAction = "eating";
			            treeGame.deers[deer.index]._spriterGroup.playAnimationById(0);
			            
			            levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
					        treeGame.deers[deer.index].hunger = 100;
					        treeGame.deers[deer.index].hungry = false;
					        
					        seed.removed = true;
							var seedFadeOutTween = levelPlanetState.add.tween(seed.sprite).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
							seedFadeOutTween.onComplete.add(function () 
							{        
								seed.sprite.kill();
								deer.seedsEaten.push(seed.specieOfTree);   
							});
					        
					         treeGame.deers[deer.index].currentAction = "headUp";
		                    // play animation by Spriter animation id
		                    treeGame.deers[deer.index]._spriterGroup.playAnimationById(4);
		                    treeGame.deers[deer.index]._spriterGroup.onLoop.add(function () {
		                        treeGame.deers[deer.index].currentAction = "walking";
		                        treeGame.deers[deer.index]._spriterGroup.playAnimationById(1);

		                    }, this);

					        
					    }, this);
			            
			        }, this);
				    					    
				} 	
			}	
		}				

	},
	
    crowTouchingSeed: function(crow, seed) {
		
	    if (seed.removed == false)
	    {
			if (treeGame.crows[crow.index].currentAction == "walking")
			{
				if (treeGame.crows[crow.index].hungry == true)
				{
		        
			        treeGame.crows[crow.index].currentAction = "eating";
		            treeGame.crows[crow.index]._spriterGroup.playAnimationById(3);
		            treeGame.crows[crow.index]._spriterGroup._animationSpeed = .5;
		            
		            levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        treeGame.crows[crow.index].hunger = 100;
				        treeGame.crows[crow.index].hungry = false;
				        
				        seed.removed = true;
						var seedFadeOutTween = levelPlanetState.add.tween(seed.sprite).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
						seedFadeOutTween.onComplete.add(function () 
						{        
							seed.sprite.kill(); 
							crow.seedsEaten.push(seed.specieOfTree);    
						});
				        
	                    treeGame.crows[crow.index]._spriterGroup.onLoop.add(function () {
	                        treeGame.crows[crow.index].currentAction = "walking";
	                        treeGame.crows[crow.index]._spriterGroup.playAnimationById(1);
	                        treeGame.crows[crow.index]._spriterGroup._animationSpeed = 1;
	                    }, this);
				        
				    }, this);
			            
				} 	
			}	
		}				

	},
	
	squirrelTouchingSeed: function(squirrel, seed) {
		
	    if (seed.removed == false)
	    {
			if (treeGame.squirrels[squirrel.index].currentAction == "walking")
			{
				if (treeGame.squirrels[squirrel.index].hungry == true)
				{
		        
			        treeGame.squirrels[squirrel.index].currentAction = "eating";
		            treeGame.squirrels[squirrel.index]._spriterGroup.playAnimationByName("eating");
		            treeGame.squirrels[squirrel.index]._spriterGroup._animationSpeed = .5;
		            
		            levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        treeGame.squirrels[squirrel.index].hunger = 100;
				        treeGame.squirrels[squirrel.index].hungry = false;
				        
				        seed.removed = true;
						var seedFadeOutTween = levelPlanetState.add.tween(seed.sprite).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
						seedFadeOutTween.onComplete.add(function () 
						{        
							seed.sprite.kill();
							squirrel.seedsEaten.push(seed.specieOfTree);  
						});
				        
	                    treeGame.squirrels[squirrel.index]._spriterGroup.onLoop.add(function () {
	                        treeGame.squirrels[squirrel.index].currentAction = "walking";
	                        treeGame.squirrels[squirrel.index]._spriterGroup.playAnimationByName("walk");
	                        treeGame.squirrels[squirrel.index]._spriterGroup._animationSpeed = 1;
	                    }, this);

				    }, this);
			            
				} 	
			}	
		}				

	},
	
    crowTouchingCrow: function(crow, crow2) {
		
        if ( (Phaser.Utils.chanceRoll(.25)) && (crow.numberOfEggsLaid <= 1) )
		{
		    treeGame.eggs.push( new treeGame.egg(crow.x, crow.y));
		    crow.numberOfEggsLaid += 1;
	    }	

	},
	
    crowTouchingSpawnZoneSeed: function(crow, spawnZoneSeed) {

			if (treeGame.crows[crow.index].currentAction == "walking")
			{
				
				if (treeGame.crows[crow.index].hungry == true)
				{
		        
			        treeGame.crows[crow.index].currentAction = "eating";
		            treeGame.crows[crow.index]._spriterGroup.playAnimationById(3);
		            treeGame.crows[crow.index]._spriterGroup._animationSpeed = .5;
		            
		            levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
				        treeGame.crows[crow.index].hunger = 100;
				        treeGame.crows[crow.index].hungry = false;
				        					        
	                    treeGame.crows[crow.index]._spriterGroup.onLoop.add(function () {
	                        treeGame.crows[crow.index].currentAction = "walking";
	                        treeGame.crows[crow.index]._spriterGroup.playAnimationById(1);
	                        treeGame.crows[crow.index]._spriterGroup._animationSpeed = 1;
	                    }, this);

				        
				    }, this);
			            
				    					    
				} 	
			}
		
	    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 1, function(){
	        spawnZoneSeed.setRectangle(50,0);
	        levelPlanetState.time.events.add(Phaser.Timer.SECOND * 2, function(){
		        spawnZoneSeed.setRectangle(50,50);
		    }, this);
	    }, this);
		   
	},
	
	squirrelTouchingSpawnZoneSeed: function(squirrel, spawnZoneSeed) {

		if (treeGame.squirrels[squirrel.index].currentAction == "walking")
		{
			squirrel.velocity.y = -500;
			
			if (treeGame.squirrels[squirrel.index].hungry == true)
			{
	        
		        treeGame.squirrels[squirrel.index].currentAction = "eating";
	            treeGame.squirrels[squirrel.index]._spriterGroup.playAnimationByName("eating");
	            treeGame.squirrels[squirrel.index]._spriterGroup._animationSpeed = 1;
	            
	            levelPlanetState.time.events.add(Phaser.Timer.SECOND * 4, function(){
			        treeGame.squirrels[squirrel.index].hunger = 100;
			        treeGame.squirrels[squirrel.index].hungry = false;
			        					        
                    treeGame.squirrels[squirrel.index]._spriterGroup.onLoop.add(function () {
                        treeGame.squirrels[squirrel.index].currentAction = "walking";
                        treeGame.squirrels[squirrel.index]._spriterGroup.playAnimationByName("walk");
                        treeGame.squirrels[squirrel.index]._spriterGroup._animationSpeed = 1;
                    }, this);

			        
			    }, this);
		            
			    					    
			} 	
		}
		
/*
	    levelPlanetState.time.events.add(Phaser.Timer.SECOND * 1, function(){
	        spawnZoneSeed.setRectangle(50,0);
	        levelPlanetState.time.events.add(Phaser.Timer.SECOND * 2, function(){
		        spawnZoneSeed.setRectangle(50,50);
		    }, this);
	    }, this);
*/
		   
	},


    spawnZoneSeedTouchingGround: function(spawnZoneSeed, ground) {
    
		spawnZoneSeed.sprite.kill();				

	},

	forestGuardianReachedDestination: function(forestGuardian, forestGuardianDestination) {
		var tweenScaleOutDestinationMarker = levelPlanetState.add.tween(forestGuardianDestination.sprite.scale).to({x:0,y:0}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		var tweenFadeOutDestinationMarker = levelPlanetState.add.tween(forestGuardianDestination.sprite).to({alpha:0}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		if (levelPlanetState.game.particleEffectsToggle == true)
		{
			var tweenFadeOutEmitter = levelPlanetState.add.tween(treeGame.forestGuardianDestinations[0].spiralEmitter).to({alpha:0}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);

		}
		
		forestGuardianDestination.clearCollision();
		forestGuardianDestination.setCollisionGroup(forestGuardianDestinationCollision);
		
	},
	
/*
	forestGuardianTouchedMushroom: function(forestGuardian, mushroom) {
		
		// Play Sound
		var summoningSound = levelPlanetState.add.audio('absorbLifeSound', .25, false);
        summoningSound.play();
		
		mushroomFadeOutTween = levelPlanetState.add.tween(mushroom.sprite).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		mushroomFadeOutTween.onComplete.add(function () 
		{
			mushroom.sprite.kill()
			treeGame.forestGuardians[0].energy += 5; 
		});
		
	},
*/
	
	forestGuardianTouchingTree: function(forestGuardian, tree) {
		
		forestGuardian.walkingSpeed += 50;

/*
		if (forestGuardian.sprite.scale.x <= 1)
		{
			if (forestGuardian.sprite.forestGuardianScaleNumber > 1)
			{
				forestGuardian.sprite.forestGuardianScaleNumber -= 1;
			}
			
			var forestGuardianScaleUp = levelPlanetState.add.tween(forestGuardian.sprite.scale).to({x:"+.1",y:"+.1"}, 300, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
			
			if (200 - (40*this.forestGuardianSprite.forestGuardianScaleNumber) > 50)
			{
				forestGuardian.sprite.body.setRectangle(200 - (40*this.forestGuardianSprite.forestGuardianScaleNumber), 400 - (40*this.forestGuardianSprite.forestGuardianScaleNumber), 0, 30);
			}

		}
*/		
		forestGuardian.clearCollision();
		// Define the forestGuardian's collision group and make it collide with the ground
	    forestGuardian.setCollisionGroup(forestGuardianCollision);
	    forestGuardian.collides([groundCollision, forestGuardianCollision, leafCollision]);
	    forestGuardian.collides([mushroomCollision], levelPlanetState.forestGuardianTouchedMushroom, this);
	    forestGuardian.collides([forestGuardianDestinationCollision], levelPlanetState.forestGuardianReachedDestination, this);
	    forestGuardian.collides([energyZoneCollision], levelPlanetState.forestGuardianTouchingEnergyZone, this);
	    
		levelPlanetState.time.events.add(Phaser.Timer.SECOND * 1, function()
		{
		   forestGuardian.collides([treeCollision], levelPlanetState.forestGuardianTouchingTree, this);

        }, this);
		
	},
	
	forestGuardianTouchingEnergyZone: function(forestGuardian, energyZone) {
		
		treeGame.forestGuardians[0].energy += 10;
		energyZone.attendedByForestGuardian = true;
		forestGuardian.clearCollision();
		// Define the forestGuardian's collision group and make it collide with the ground
	    forestGuardian.setCollisionGroup(forestGuardianCollision);
	    forestGuardian.collides([groundCollision, forestGuardianCollision, leafCollision]);
	    forestGuardian.collides([mushroomCollision], levelPlanetState.forestGuardianTouchedMushroom, this);
	    forestGuardian.collides([forestGuardianDestinationCollision], levelPlanetState.forestGuardianReachedDestination, this);
	    forestGuardian.collides([treeCollision], levelPlanetState.forestGuardianTouchingTree, this);
	    
		levelPlanetState.time.events.add(Phaser.Timer.SECOND * 1, function()
		{
		   forestGuardian.collides([energyZoneCollision], levelPlanetState.forestGuardianTouchingEnergyZone, this);

        }, this);
		
	},	
	humanTouchingTree: function(human, tree) {
		
		if (treeGame.humans[human.index].currentAction != "chopping" || 
		    treeGame.humans[human.index].currentAction != "pullOutAxe")
		{
			treeGame.humans[human.index].currentAction = "chopping";
			
			// play animation by Spriter animation name
			treeGame.humans[human.index]._spriterGroup.playAnimationByName("pullOutAxe");
			
			treeGame.humans[human.index]._spriterGroup.onFinish.add(function () {
				
	            treeGame.humans[human.index]._spriterGroup.playAnimationByName("chop");
			            
	        }, this);
		
			
			
			// Add a timer for how long they chop for before putting away their axe and walking
			levelPlanetState.time.events.add(Phaser.Timer.SECOND * 5, function()
			{
				
			    // play animation by Spriter animation name
				treeGame.humans[human.index]._spriterGroup.playAnimationByName("putBackAxe");
				
				treeGame.humans[human.index]._spriterGroup.onFinish.add(function () {
					
		            treeGame.humans[human.index]._spriterGroup.playAnimationByName("walk");
		            treeGame.humans[human.index].currentAction = "walking";
				            
		        }, this);
		        
		        // If the human's life hasn't already been absorbed at the end of its action, kill the tree
			    if (human.alive == true)
			    {
				    levelPlanetState.treeDied(tree);
			    }
			   
	        }, this);
			
		}
		
		
		
	},
	
	humanTouchingPlant: function(human, plant) {
		
		if (treeGame.humans[human.index].currentAction != "gather" && treeGame.humans[human.index].hasSmudgeStick == false && plant.static == true)
		{
			treeGame.humans[human.index].currentAction = "gather";
			
			// play animation by Spriter animation name
			treeGame.humans[human.index]._spriterGroup.playAnimationByName("gather");			            
			
			// Add a timer for how long they gather for before walking away with their newly-gathered plant matter
			levelPlanetState.time.events.add(Phaser.Timer.SECOND * 5, function()
			{
				// Show the smudge stick in hand
				this._spriterGroup.removeCharMap("noSmudgeStick");
				treeGame.humans[human.index].hasSmudgeStick = true;
				
				// Now the human can sacrifice at altars
				human.clearCollision();
				human.setCollisionGroup(humanCollision);
			    human.collides([groundCollision, humanCollision, crowCollision, leafCollision]);
			    human.collides([boulderCollision], levelPlanetState.humanTouchingBoulder, this);
			    human.collides([altarCollision], levelPlanetState.sacrificeAtAltar, this);
				
				treeGame.humans[human.index]._spriterGroup.playAnimationByName("walk");
		        treeGame.humans[human.index].currentAction = "walking";
			   
			    levelPlanetState.plantDied(plant);
	        }, this);
			
		}
		
		
		
	},
	
	humanTouchingBoulder: function(human, boulder) {
		
		if (treeGame.humans[human.index].currentAction != "chisel")
		{
			treeGame.humans[human.index].currentAction = "chisel";
			
			// play animation by Spriter animation name
			this._spriterGroup.pushCharMap("hasHammer");
			this._spriterGroup.pushCharMap("hasChisel");
			treeGame.humans[human.index]._spriterGroup.playAnimationByName("chisel");			            
			
			// Add a timer for how long they chisel for
			levelPlanetState.time.events.add(Phaser.Timer.SECOND * 5, function()
			{
				// Show the smudge stick in hand
				this._spriterGroup.removeCharMap("hasHammer");
				this._spriterGroup.removeCharMap("hasChisel");
				
				treeGame.humans[human.index]._spriterGroup.playAnimationByName("walk");
		        treeGame.humans[human.index].currentAction = "walking";
			   
			    
			    
			    var boulderFadeOutTween = levelPlanetState.add.tween(boulder.sprite).to({alpha: 0}, 500, Phaser.Easing.Quadratic.InOut, true, 1500, 0, false);
			    boulderFadeOutTween.onComplete.add(function () 
			    {
				    if (boulder.sprite != null)
				    {
					    // Create Altars
						treeGame.altars.push( new treeGame.altar(boulder.x, boulder.y));
											    
					    // Remove boulder from world
					    boulder.sprite.kill();
					    boulder.destroy();
				    }
				    
				});
			    
			    
			    
	        }, this);
			
		}
		
		
		
	},
		    
    clickedTree: function(tree) {
	    
	    if (treeGame.activeTool == "removeTool" && tree.clicked == false)
	    {
		    tree.clicked = true;
		    
		    // Play Animation Animation
		    switch(treeGame.forestGuardians[0].currentAction)
			{
				case "resting":
					treeGame.forestGuardians[0].currentAction = "casting";
					break;
				case "walking":
					treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
					break;
					
			}

			treeGame.forestGuardians[0].casting = true;
			
			// Play Sound
			var summoningSound = levelPlanetState.add.audio('absorbLifeSound', .25, false);
	        summoningSound.play();
		    
		    tree.body.removed = true;
		    tree.body.static = false;
		    tree.body.spawnZoneTreeShade.destroy();
		    tree.treeWiggleTween.stop();
		    treeCutDownTween = levelPlanetState.add.tween(tree.body).to({angle: '+90'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    treeFadeOutTween = levelPlanetState.add.tween(tree).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    treeFadeOutTween.onComplete.add(function () 
		    {
			    tree.kill();
			    treeGame.forestGuardians[0].energy += 5; 
			});
// 			tree.removeChild(tree.body.roots);

			treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed)
			{
				if (spawnZoneSeed.belongsToTree == tree.body.index)
				{
					
					// Remove the fire belonging to each spawnZoneSeed
					treeGame.fires.forEach(function (fire)
					{
						if (fire.index == spawnZoneSeed.index)
						{
							fire.fireEmitter.destroy();
							fire.fireSprite.destroy();
						}
					});
					
					spawnZoneSeed.spawnZoneSeedVicinity.destroy();
				}
				
				
				
				
				
				
				
			});
			
	    }
	    
    },
    
    clickedPlant: function(plant) {
	    
	    if (treeGame.activeTool == "removeTool" && plant.clicked == false)
	    {
		    plant.clicked = true;
		    
		    // Play Animation Animation
		    switch(treeGame.forestGuardians[0].currentAction)
			{
				case "resting":
					treeGame.forestGuardians[0].currentAction = "casting";
					break;
				case "walking":
					treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
					break;
					
			}

			treeGame.forestGuardians[0].casting = true;
			
			// Play Sound
			var absorbingSound = levelPlanetState.add.audio('absorbLifeSound', .25, false);
	        absorbingSound.play();
		    
		    plant.body.removed = true;
		    plant.body.static = false;
		    plantRemovedTween = levelPlanetState.add.tween(plant.body).to({angle: '+90'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    plantFadeOutTween = levelPlanetState.add.tween(plant).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    plantFadeOutTween.onComplete.add(function () 
		    {        
			    plant.kill();
			    treeGame.forestGuardians[0].energy += 5; 
			});			
	    }
	    
    },
    
    clickedFungus: function(fungus) {
	    
	    if (treeGame.activeTool == "removeTool")
	    {
		    // Play Animation Animation
		    switch(treeGame.forestGuardians[0].currentAction)
			{
				case "resting":
					treeGame.forestGuardians[0].currentAction = "casting";
					break;
				case "walking":
					treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
					break;
					
			}

			treeGame.forestGuardians[0].casting = true;
			
			// Play Sound
			var summoningSound = levelPlanetState.add.audio('absorbLifeSound', .25, false);
	        summoningSound.play();
		    
		    fungus.body.removed = true;
		    fungus.body.static = false;
		    fungusRemovedTween = levelPlanetState.add.tween(fungus.body).to({angle: '+180'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    fungusFadeOutTween = levelPlanetState.add.tween(fungus).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    fungusFadeOutTween.onComplete.add(function () 
		    {        
			    fungus.kill();
			    treeGame.forestGuardians[0].energy += 10;
			    
			    treeGame.numberOfMushroomsAbsorbed += 1;
			    levelPlanetState.updateObjectiveText();   
			});			
	    }
	    
    },
    
    
    clickedAnimal: function(animal) {
	    
	    if (treeGame.activeTool == "removeTool" && animal.clicked == false)
	    {
		    animal.clicked = true;
		    
		    // Play Animation Animation
		    switch(treeGame.forestGuardians[0].currentAction)
			{
				case "resting":
					treeGame.forestGuardians[0].currentAction = "casting";
					break;
				case "walking":
					treeGame.forestGuardians[0].currentAction = "walkingAndCasting";
					break;
					
			}

			treeGame.forestGuardians[0].casting = true;
			
			// Play Sound
			var summoningSound = levelPlanetState.add.audio('absorbLifeSound', .25, false);
	        summoningSound.play();
		    
		    animal.body.removed = true;
		    animal.body.static = false;
		    animalRemovedTween = levelPlanetState.add.tween(animal.body).to({angle: '+180'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    animalFadeOutTween = levelPlanetState.add.tween(animal).to({alpha: 0}, 1000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    animalFadeOutTween.onComplete.add(function () 
		    {        
			    animal.kill();
			    treeGame.forestGuardians[0].energy += 10;
			    
			    
			    switch (animal.species)
				{
					case "deer":
					    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "deer"));
					    treeGame.numberOfDeerAlive -= 1;
					    break;
					case "crow":
					    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "crow"));
					    treeGame.numberOfCrowsAlive -= 1;
					    break;
					case "squirrel":
					    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "squirrel"));
					    treeGame.numberOfSquirrelsAlive -= 1;
					    break;
				}
				
				switch (animal.role)
				{
					case "woodcutter":
					    treeGame.numberOfWoodcuttersAbsorbed += 1;
				}
				
				levelPlanetState.updateObjectiveText();    
			      
			});			
	    }
	    
    },
    
    animalStarved: function(animal) {
	    if (animal.body.removed == false) {
		    animal.body.removed = true;
		    animal.body.static = false;
		    animalRemovedTween = levelPlanetState.add.tween(animal.body).to({angle: '+180'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    animalFadeOutTween = levelPlanetState.add.tween(animal).to({alpha: 0}, 4000, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    animalFadeOutTween.onComplete.add(function () 
		    {        
			    animal.kill();
			});	
			
			switch (animal.species)
			{
				case "deer":
				    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "deer"));
				    treeGame.numberOfDeerAlive -= 1;
				    break;
				case "crow":
				    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "crow"));
				    treeGame.numberOfCrowsAlive -= 1;
				    break;
				case "squirrel":
				    treeGame.skulls.push( new treeGame.skull(animal.x, animal.y, "squirrel"));
				    treeGame.numberOfSquirrelsAlive -= 1;
				    break;
			}
			levelPlanetState.updateObjectiveText();
			
	    }
		
    },
    
	treeDied: function(tree) {

		treeGame.latestDeadTreeIndex = tree.index;
				    
	    // Kill children of the dead tree.
		
		treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed)
		{
			if (spawnZoneSeed.belongsToTree == treeGame.latestDeadTreeIndex)
			{
				
				
		        // Remove the fire belonging to each spawnZoneSeed
				treeGame.fires.forEach(function (fire)
				{
					if (fire.index == spawnZoneSeed.index)
					{

						try 
						{
							fire.fireEmitter.destroy();
						    fire.fireSprite.destroy();	
						} 
						catch(err)
						{
							console.log(err.name, err.message);
						}
						
					}
				});
				
				
				
				spawnZoneSeed.spawnZoneSeedVicinity.destroy();
			}
		});
		
		treeGame.spawnZoneTreeShades.forEach(function (spawnZoneTreeShade)
		{
			if (spawnZoneTreeShade.belongsToTree == treeGame.latestDeadTreeIndex)
			{
				spawnZoneTreeShade.spawnZoneTreeShadeVicinity.destroy();
			}
		});
		
/*
		treeGame.fires.forEach(function (fire)
		{
			if (fire.belongsToTree == treeGame.latestDeadTreeIndex)
			{
				fire.fireSprite.destroy();
			}
		});
*/
	    
	    tree.dead = true;
	    tree.static = false;
	    tree.setRectangle(20,tree.height);
	    tree.setCollisionGroup(treeCollision);
	    tree.collides([groundCollision]);
	    tree.spawnZoneTreeShade.destroy();
	    
	    if (tree.sprite)
	    {
		    tree.sprite.treeWiggleTween.stop();
	    }
	    
	    // Push it over
	    var randomFallDirection = levelPlanetState.rnd.integerInRange(0, 1);
	    switch(randomFallDirection) 
	    {
		    case 0:
		    treeFallOverTween = levelPlanetState.add.tween(tree).to({angle: '+10'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    break;
		    case 1:
		    treeFallOverTween = levelPlanetState.add.tween(tree).to({angle: '-10'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		    break;
	    }
	    
	    // Fade it out
	    treeFadeOutTween = levelPlanetState.add.tween(tree.sprite).to({alpha: 0}, 5000, Phaser.Easing.Quadratic.InOut, true, 1500, 0, false);
	    treeFadeOutTween.onComplete.add(function () 
	    {
		    if (tree.sprite != null)
		    {
			    // Chance of mushrooms spawning where the tree died
			    for (var i = 0; i < 10; i++)
			    {
				    var xRandomVariation = levelPlanetState.rnd.integerInRange(-100, 100);
				    if (Phaser.Utils.chanceRoll(25)) 
				    {
					    var x = tree.x + xRandomVariation;
					    var y = levelPlanetState.world.height/2 - 50;
					    treeGame.fungi.push(new treeGame.fungus(x, y, tree.angle));
					}
		            
			    }
			    
			    // Remove leaves and bark bits
				treeGame.birchBarkBits.forEach(function (birchBarkBit)
				{
					if (birchBarkBit.belongsToTree == treeGame.latestDeadTreeIndex)
					{
						birchBarkBit.birchBarkBitSprite.kill();
					}
				});
		
				treeGame.leaves.forEach(function (leaf)
				{
					if (leaf.belongsToTree == treeGame.latestDeadTreeIndex)
					{
						leaf.leafSprite.kill();
					}
				});
				
			    // Remove tree from world
			    tree.sprite.kill();
			    tree.destroy();
		    }
		    
		});


	},    
    
	plantDied: function(plant) {

	    plant.dead = true;
	    plant.static = false;
	    
	    // Push it over
	    var randomFallDirection = levelPlanetState.rnd.integerInRange(0, 1);
	    switch(randomFallDirection) 
	    {
		    case 0:
		        var plantFallOverTween = levelPlanetState.add.tween(plant).to({angle: '+10'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		        break;
		    case 1:
		        var plantFallOverTween = levelPlanetState.add.tween(plant).to({angle: '-10'}, 750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		        break;
	    }
	    
	    // Fade it out
	    var plantFadeOutTween = levelPlanetState.add.tween(plant.sprite).to({alpha: 0}, 5000, Phaser.Easing.Quadratic.InOut, true, 1500, 0, false);
	    plantFadeOutTween.onComplete.add(function () 
	    {
		    if (plant.sprite != null)
		    {	
			    // Remove plant from world
			    plant.sprite.kill();
			    plant.destroy();
		    }
		    
		});


	},    
     
  
    
    plantSpawner: function() {
	    
	    var randomPlantType = levelPlanetState.rnd.integerInRange(0, 1);
	    var randomSpawnLocationX = levelPlanetState.rnd.integerInRange(0, levelPlanetState.world.width);
	    
	    switch(randomPlantType)
	    {
		    case 0:
			    treeGame.plants.push( new treeGame.plant(randomSpawnLocationX, 0, "sage"));
			    break;
			case 1:
		        treeGame.plants.push( new treeGame.plant(randomSpawnLocationX, 0, "clover"));
				break;
		    default:
			    treeGame.plants.push( new treeGame.plant(randomSpawnLocationX, 0, "sage"));
			    break;
	    }
        
    },
    
    animalSpawner: function() {
	    
	    
	    if (levelPlanetState.game.selectedLevel > 2)
	    {
		    var randomAnimalType = levelPlanetState.rnd.integerInRange(0, 3);
	    } else
	    {
		    var randomAnimalType = levelPlanetState.rnd.integerInRange(0, 2);    
	    }
	    
	    
	    var randomSpawnLocationX = levelPlanetState.rnd.integerInRange(0, levelPlanetState.world.width);
	    
	    switch(randomAnimalType)
	    {
		    case 0:
			    treeGame.deers.push( new treeGame.deer(randomSpawnLocationX, 0));
			    break;
			case 1:
		        treeGame.crows.push( new treeGame.crow(randomSpawnLocationX, 0));
				break;
			case 2:
		        treeGame.squirrels.push( new treeGame.squirrel(randomSpawnLocationX, 0));
				break;
			case 3:
		        treeGame.humans.push( new treeGame.human(randomSpawnLocationX, 0));
				break;
		    default:
			    treeGame.crows.push( new treeGame.crow(randomSpawnLocationX, 0));
			    break;
	    }
        
    },
    
    animalsPoop: function() {
	    
	    treeGame.deers.forEach(function (deer) 
		{
			if (deer.deerSprite.alive == true)
			{
				if (Phaser.Utils.chanceRoll(25)) {
					var numberOfDeerPoops = levelPlanetState.rnd.integerInRange(2, 5);
					for (var i = 0; i < numberOfDeerPoops; i++)
					{
				        treeGame.poops.push(new treeGame.poop(deer.deerSprite.x, deer.deerSprite.y, 'deer', deer.deerSprite.body.seedsEaten));
				        deer.deerSprite.body.seedsEaten = [];
				    }
				}	
			}
			
		});	
		
        treeGame.crows.forEach(function (crow) 
		{
			if (crow.crowSprite.alive == true)
			{
				if (Phaser.Utils.chanceRoll(25)) {
				    treeGame.poops.push(new treeGame.poop(crow.crowSprite.x, crow.crowSprite.y, 'crow', crow.crowSprite.body.seedsEaten));
				    crow.crowSprite.body.seedsEaten = [];
				}	
			}
			
		});	
		
		treeGame.squirrels.forEach(function (squirrel) 
		{
			if (squirrel.squirrelSprite.alive == true)
			{
				if (Phaser.Utils.chanceRoll(25)) {
				    treeGame.poops.push(new treeGame.poop(squirrel.squirrelSprite.x, squirrel.squirrelSprite.y, 'squirrel', squirrel.squirrelSprite.body.seedsEaten));
				    squirrel.squirrelSprite.body.seedsEaten = [];
				}	
			}
			
		});	
        
    },
    
        
    lightningSpawner: function() {
	    
// 	    var randomSpawnLocationX = levelPlanetState.rnd.integerInRange(0, levelPlanetState.world.width);
	    
		treeGame.lightnings.push( new treeGame.lightning(
		    treeGame.clouds[0].cloudSprite.x,
		    treeGame.clouds[0].cloudSprite.y + treeGame.clouds[0].cloudSprite.height * 1.5
		));

        
    },
    
            
    showEnergyWarning: function() {
	    
        var energyWarningFadeIn = levelPlanetState.add.tween(levelPlanetState.outOfEnergyText).to({alpha: 1}, 0, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);
		energyWarningFadeIn.onComplete.add(function () 
        {
	        this.energyWarningFadeOut = levelPlanetState.add.tween(levelPlanetState.outOfEnergyText).to({alpha: 0}, 1750, Phaser.Easing.Quadratic.InOut, true, 0, 0, false);

	    }, this);
        

        
    },
    
    distanceBetween: function(spriteA, spriteB) {
	    
	    if (spriteA.body != null)
	    {
		    var dx = spriteA.body.x - spriteB.body.x;  //distance ship X to planet X
		    var dy = spriteA.body.y - spriteB.body.y;  //distance ship Y to planet Y
		    var dist = Math.sqrt(dx*dx + dy*dy);     //pythagoras ^^  (get the distance to each other)
		    return dist;
	    }
		        
    },
    
    accelerateToObject: function(obj1, obj2, speed) {
    
		if (typeof speed === 'undefined') 
		{ 
			speed = 2000; 
		}
		if (obj1 && obj1.body)
		{
		    var angle = Math.atan2(obj2.y - obj1.y, obj2.x - obj1.x);
			obj1.body.rotation = angle + levelPlanetState.math.degToRad(-90);  // correct angle if wanted
			obj1.body.force.x = Math.cos(angle) * speed;    // accelerateToObject 
			obj1.body.force.y = Math.sin(angle) * speed;
		} else
		{
// 			console.log("Obj1.body was null", obj1);
		}
		

    },
    
    updateObjectiveText: function() {
	  
	    switch (treeGame.currentObjective) 
	    {
		    case "treesCreated":
		        treeGame.objectives[0].objectiveText.setText("Trees Created: " + treeGame.numberOfTreesCreated);
		        break;
		    case "treesCreatedOak":
		        treeGame.objectives[0].objectiveText.setText("Oak Trees Created: " + treeGame.numberOfTreesOakCreated);
		        break;
		    case "treesCreatedBeech":
		        treeGame.objectives[0].objectiveText.setText("Beech Trees Created: " + treeGame.numberOfTreesBeechCreated);
		        break;
		    case "treesCreatedBirch":
		        treeGame.objectives[0].objectiveText.setText("Birch Trees Created: " + treeGame.numberOfTreesBirchCreated);
		        break;
		    case "treesCreatedPine":
		        treeGame.objectives[0].objectiveText.setText("Pine Trees Created: " + treeGame.numberOfTreesPineCreated);
		        break;
		    case "treesCreatedWillow":
		        treeGame.objectives[0].objectiveText.setText("Willow Trees Created: " + treeGame.numberOfTreesWillowCreated);
		        break;
		    case "mushroomsAbsorbed":
		        treeGame.objectives[0].objectiveText.setText("Mushrooms Absorbed: " + treeGame.numberOfMushroomsAbsorbed);
		        break;
		    case "crowsAlive":
		        treeGame.objectives[0].objectiveText.setText("Crows Alive: " + treeGame.numberOfCrowsAlive);
		        break;
		    case "squirrelsAlive":
		        treeGame.objectives[0].objectiveText.setText("Squirrels Alive: " + treeGame.numberOfSquirrelsAlive);
		        break;
		    case "deerAlive":
		        treeGame.objectives[0].objectiveText.setText("Deer Alive: " + treeGame.numberOfDeerAlive);
		        break;
		    case "woodcuttersAbsorbed":
		        treeGame.objectives[0].objectiveText.setText("Woodcutters Absorbed: " + treeGame.numberOfWoodcuttersAbsorbed);
		        break;
		    case "ceremoniesAttended":
		        treeGame.objectives[0].objectiveText.setText("Ceremonies Attended: " + treeGame.numberOfCeremoniesAttended);
		        break;
	    }
	    
    },
    
	update: function(game) {
		
		
/*
		if (treeGame.forestGuardians[0].currentAction == "walking" || treeGame.forestGuardians[0].currentAction == "walkingAndCasting")
		{
			treeGame.grounds[0].groundSprite.angle += .05;
		}
*/

        if (game.selectedLevel <= 4)
		{
			treeGame.mountains[0].mountainSprite.tilePosition.set((-levelPlanetState.camera.x) * .05, (-levelPlanetState.camera.y) * .1);
			treeGame.mountains[1].mountainSprite.tilePosition.set((-levelPlanetState.camera.x) * .1, (-levelPlanetState.camera.y) * .2);
			treeGame.mountains[2].mountainSprite.tilePosition.set((-levelPlanetState.camera.x) * .2, (-levelPlanetState.camera.y) * .4);
			levelPlanetState.texture.tilePosition.set((-levelPlanetState.camera.x) * .2, (-levelPlanetState.camera.y) * .25);
		}

		treeGame.altar.prototype.update();
		treeGame.deer.prototype.update();
		treeGame.crow.prototype.update();
		treeGame.squirrel.prototype.update();
		treeGame.human.prototype.update();
		treeGame.forestGuardian.prototype.update();
		treeGame.earthenDemigod.prototype.update();
		
		// Add gravity to stuff if on a planet rather than flat endless ground
		if (game.selectedLevel > 4)
		{	
			// Boulder
			treeGame.boulders.forEach(function (boulder)
			{
			    var speed = 320000;
				
				levelPlanetState.accelerateToObject(boulder.boulderSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Altars
			treeGame.altars.forEach(function (altar)
			{
			    var speed = 160000;
				
				levelPlanetState.accelerateToObject(altar.altarSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Poop
			treeGame.poops.forEach(function (poop)
			{
			    var speed = 10000;
				
				levelPlanetState.accelerateToObject(poop.poopSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Skulls
			treeGame.skulls.forEach(function (skull)
			{
			    var speed = 80000;
				
				levelPlanetState.accelerateToObject(skull.skullSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Trees
			treeGame.trees.forEach(function (tree)
			{
			    var speed = 240000;
				
				levelPlanetState.accelerateToObject(tree.treeSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Seeds
			treeGame.seeds.forEach(function (seed)
			{
			    var speed = 80000;
				
				levelPlanetState.accelerateToObject(seed.seedSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Plants
			treeGame.plants.forEach(function (plant)
			{
			    var speed = 80000;
				
				levelPlanetState.accelerateToObject(plant.plantSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
			
			// Fungi
			treeGame.fungi.forEach(function (fungus)
			{
			    var speed = 80000;
				
				levelPlanetState.accelerateToObject(fungus.fungusSprite, treeGame.grounds[0].groundSprite, speed);	
			          
			});
		}

		// Arrow keys move camera
		if (treeGame.cursors.up.isDown)
	    {
	        game.camera.y -= 4;
	    }
	    else if (treeGame.cursors.down.isDown)
	    {
	        game.camera.y += 4;
	    }
	
	    if (treeGame.cursors.left.isDown)
	    {
	        game.camera.x -= 4;
	    }
	    else if (treeGame.cursors.right.isDown)
	    {
	        game.camera.x += 4;
	    }
	    
	    
	    // Spawn ferns under trees

		if (game.time.now > treeGame.nextFernSpawn)
		{
			treeGame.nextFernSpawn = game.time.now + treeGame.fernSpawnDelay;
			treeGame.spawnZoneTreeShades.forEach(function (spawnZoneTreeShade) 
			{
				if (spawnZoneTreeShade.spawnZoneTreeShadeVicinity.alive == true)
				{
					if (Phaser.Utils.chanceRoll(5)) {
						var randomValueX = game.rnd.integerInRange(-500, 500);
					    var x = treeGame.trees[spawnZoneTreeShade.belongsToTree].treeSprite.x + randomValueX;
					    var y = game.world.height/2 - 50;
					    treeGame.plants.push(new treeGame.plant(x, y, 'fern'));
					}	
				}
				
			});	
			
	    }
	    
	    // Spawn clover

		if (game.time.now > treeGame.nextCloverSpawn)
		{
			treeGame.nextCloverSpawn = game.time.now + treeGame.cloverSpawnDelay;

			if (Phaser.Utils.chanceRoll(10)) {
				var xRandomVariation = this.game.rnd.integerInRange(0, this.game.world.width);
				treeGame.plants.push( new treeGame.plant(xRandomVariation, this.game.world.height/2 + 120, 'clover'));
			}					
	    }
	    
	    // Spawn seeds on trees

		if (game.time.now > treeGame.nextSeedSpawn)
		{
			treeGame.nextSeedSpawn = game.time.now + treeGame.seedSpawnDelay;
			treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed) 
			{
				if (spawnZoneSeed.spawnZoneSeedVicinity.alive == true)
				{
					
					if (spawnZoneSeed.spawnZoneSeedVicinity.body.wet == true)
					{
						var wetModifier = 1;
					} else {
						var wetModifier = 0;
					}
					
					switch(spawnZoneSeed.specieOftree)
					{
						case "birch":
							if (Phaser.Utils.chanceRoll(.3 + wetModifier)) {
							    var x = spawnZoneSeed.spawnZoneSeedVicinity.x;
							    var y = spawnZoneSeed.spawnZoneSeedVicinity.y;
							    treeGame.seeds.push(new treeGame.seed(x, y, spawnZoneSeed.specieOftree));
						    }
							break;
						case "pine":
							if (Phaser.Utils.chanceRoll(.15 + wetModifier)) {
							    var x = spawnZoneSeed.spawnZoneSeedVicinity.x;
							    var y = spawnZoneSeed.spawnZoneSeedVicinity.y;
							    treeGame.seeds.push(new treeGame.seed(x, y, spawnZoneSeed.specieOftree));
						    }
							break;						
						default:
							if (Phaser.Utils.chanceRoll(.2 + wetModifier)) {
							    var x = spawnZoneSeed.spawnZoneSeedVicinity.x;
							    var y = spawnZoneSeed.spawnZoneSeedVicinity.y;
							    treeGame.seeds.push(new treeGame.seed(x, y, spawnZoneSeed.specieOftree));
							}
							break;
						
					}	
				}
					
					
			});
				
		}	
			
	    	
/*
	    
	    // Spawn leaves on trees

		if (game.time.now > treeGame.nextLeafSpawn)
		{
			treeGame.nextLeafSpawn = game.time.now + treeGame.leafSpawnDelay;
			treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed) 
			{
				if (spawnZoneSeed.spawnZoneSeedVicinity.alive == true)
				{
					if (Phaser.Utils.chanceRoll(50)) {
						var randomValueX = game.rnd.integerInRange(-25, 25);
					    var x = spawnZoneSeed.spawnZoneSeedVicinity.x;
					    var y = spawnZoneSeed.spawnZoneSeedVicinity.y;
					    treeGame.leaves.push(new treeGame.leaf(treeGame.leaves.total + 1, x, y, 0, .5, spawnZoneSeed.specieOftree));
					}	
				}
				
			});	
			
	    }	
*/	

		// Cloud Movement
		
		for (var i = 0; i < treeGame.clouds.length; i++)
		{ 
            treeGame.clouds.forEach(function (cloud) {
	            game.world.wrap(cloud.cloudSprite, 100, false);
                game.physics.arcade.velocityFromAngle(0, 100 + cloud.randomSpeedVariation, cloud.cloudSprite.body.velocity);
                		
                if (game.particleEffectsToggle == true)
                {
	                cloud.rainEmitter.x = cloud.cloudSprite.body.x + cloud.cloudSprite.width/2;
                }

            });
        }
			
    }, // End Update Function
	
	
	shutdown: function() 
	{		
	    this.game.world.removeAll();	    
	},
				
	render: function(game) {
		
// 		game.debug.geom(levelPlanetState.sky,'#534741');

/*
		treeGame.spawnZoneSeeds.forEach(function (spawnZoneSeed) {
			game.debug.body(spawnZoneSeed.spawnZoneSeedVicinity)
		});		
*/	

// 		game.debug.text("FPS: " + game.time.fps, 25, window.innerHeight - 30);

	}   

};







